diff -Nur ghostscript-9.53.3-orig/Makefile ghostscript-9.53.3/Makefile
--- ghostscript-9.53.3-orig/Makefile	Thu Jan 01 09:00:00 1970
+++ ghostscript-9.53.3/Makefile	Sun Aug 25 12:27:37 2019
@@ -0,0 +1,4 @@
+#
+#  nmake should be used.
+#
+!include psi\msvc32.mak
diff -Nur ghostscript-9.53.3-orig/Resource/Init/cidfmap ghostscript-9.53.3/Resource/Init/cidfmap
--- ghostscript-9.53.3-orig/Resource/Init/cidfmap	Thu Oct 01 17:11:07 2020
+++ ghostscript-9.53.3/Resource/Init/cidfmap	Thu Jan 01 09:00:00 1970
@@ -1,47 +0,0 @@
-%!
-% This is a sample map file for CIDFont category.
-
-%
-% The map is a set of records, which must use one of the two formats :
-%
-% 1. A substutution of a CIDFont font with another CIDFont :
-%
-%    /substituted /original ;
-%
-%    Where 'substituted' is a name being used in a document,
-%    'original' is a name of an available resource.
-%
-% 2. A substutution of a CIDFont font with a True Type font :
-%
-%    /substituted << /FileType /TrueType /Path (path) /SubfontID 1 /CSI [(ordering) supplement] >> ;
-%
-%    Where 'substituted' is a name being used in a document,
-%    'path' is a path to a True Type font file,
-%    'ordering' is a value of Ordering required for CIDSystemInfo dictionary,
-%    'supplement' is a value of Supplement required for CIDSystemInfo dictionary.
-%    'SubfontID' is the index of the desired font in a TTC - ignored if the target is not a TTC.
-%
-%    The Ordering, and Registry (if present) entries should be PostScript string types
-%    ie enclosed in parentheses, not PostScript name type (initial character '/'). See
-%    gs/doc/Use.htm#CIDFontSubstitution
-%
-%    Alternatively:
-%    (substituted name) << /FileType /TrueType /Path (path) /SubfontID 1 /CSI [(ordering) supplement] >> ;
-%
-%    This is where the CIDFont name in the document contains a space character. Using a string instead of a name
-%    allows this work - Ghostscript will internally convert the key string with a space to a name.
-%
-%
-% Examples :
-%    
-%   /ShinGo-Bold   /HeiseiKakuGo-W5 ;
-%   /Ryumin-Medium << /FileType /TrueType /Path (H:/AuxFiles/Fonts/BATANG.TTC) /SubfontID 3 /CSI [(Japan1) 2] >> ;
-%   /Ryumin-Medium << /FileType /TrueType /Path (windir) getenv not {(c:/windows)}if (/Fonts/BATANG.TTC)concatstrings /SubfontID 3 /CSI [(Japan1) 2] >> ;
-%
-%   NOTE: getenv returns a boolean to indicate success of or failure, as well as the value on success. In the example, it uses this
-%         to include a default value should getenv fail.
-%
-%  (Century Gothic) << /FileType /TrueType /Path (/usr/share/fonts/truetype/fonts-japanese-gothic.ttf) /CSI [(Identity) 1] >> ;
-%
-%  Note the use of a string to cope with the name containing a space.
-%
diff -Nur ghostscript-9.53.3-orig/Resource/Init/gs_init.ps ghostscript-9.53.3/Resource/Init/gs_init.ps
--- ghostscript-9.53.3-orig/Resource/Init/gs_init.ps	Thu Oct 01 17:11:07 2020
+++ ghostscript-9.53.3/Resource/Init/gs_init.ps	Thu Oct 01 22:47:38 2020
@@ -177,6 +177,8 @@
    currentdict /OUTPUTFILE .undef
  } if
 currentdict /QUIET known   /QUIET exch def
+currentdict /WINKANJI known /WINKANJI exch def
+currentdict /NOWINKANJI known /NOWINKANJI exch def
 % DELAYSAFER is effectively the same as newer NOSAFER
 currentdict /DELAYSAFER known { /DELAYSAFER //true def /NOSAFER //true def } if
 /SAFER currentdict /NOSAFER known {
@@ -2576,6 +2578,15 @@
 % Turn off array packing, since some PostScript code assumes that
 % procedures are writable.
 //false setpacking
+
+% Load the kanji font environment.
+NOWINKANJI not {
+  WINKANJI {
+    (metrics2.ps) runlibfile
+    (kinit.ps) runlibfile
+    1048576 setcachelimit
+  } if
+} if
 
 (END INIT) VMDEBUG
 
diff -Nur ghostscript-9.53.3-orig/base/gp_dosfs.c ghostscript-9.53.3/base/gp_dosfs.c
--- ghostscript-9.53.3-orig/base/gp_dosfs.c	Thu Oct 01 17:11:07 2020
+++ ghostscript-9.53.3/base/gp_dosfs.c	Thu Oct 01 22:36:34 2020
@@ -77,7 +77,8 @@
 
     if (len == 0)
         return 0;
-    if (len > 1 && fname[0] == '\\' && fname[1] == '\\') {
+    if (len > 1 && ((fname[0] == '\\' && fname[1] == '\\') ||
+       (fname[0] == '/' && fname[1] == '/'))) {
         /* A network path: "\\server\share\" */
         int k = 0;
 
diff -Nur ghostscript-9.53.3-orig/base/gp_ntfs.c ghostscript-9.53.3/base/gp_ntfs.c
--- ghostscript-9.53.3-orig/base/gp_ntfs.c	Thu Oct 01 17:11:07 2020
+++ ghostscript-9.53.3/base/gp_ntfs.c	Thu Oct 01 22:36:58 2020
@@ -359,7 +359,8 @@
 
     if (len == 0)
         return 0;
-    if (len > 1 && fname[0] == '\\' && fname[1] == '\\') {
+    if (len > 1 && ((fname[0] == '\\' && fname[1] == '\\') ||
+       (fname[0] == '/' && fname[1] == '/'))) {
         /* A network path: "\\server\share\" */
         int k = 0;
 
diff -Nur ghostscript-9.53.3-orig/base/kfutil.c ghostscript-9.53.3/base/kfutil.c
--- ghostscript-9.53.3-orig/base/kfutil.c	Thu Jan 01 09:00:00 1970
+++ ghostscript-9.53.3/base/kfutil.c	Thu Oct 01 22:46:14 2020
@@ -0,0 +1,174 @@
+/*
+ * kfutil.c --- kanji font utilities
+ *
+ * Copyright (C) 1992 Norio Katayama.
+ * Apr. 23, 1992 Programmed by N.Katayama (katayama@nacsis.ac.jp)
+ */
+
+#include "ghost.h"
+#include "oper.h"
+#include "gserrors.h"
+#include "gsmatrix.h"
+
+/*
+ * Adjustment for Vertical Kanji
+ */
+
+static int
+move(double dx, double dy, gs_rect *pbbox, gs_matrix *pmat)
+{
+	gs_matrix tmat;
+
+	gs_make_translation(dx, dy, &tmat);
+	gs_matrix_multiply(pmat, &tmat, pmat);
+	gs_point_transform(pbbox->p.x, pbbox->p.y, &tmat, &pbbox->p);
+	gs_point_transform(pbbox->q.x, pbbox->q.y, &tmat, &pbbox->q);
+	return 0;
+}
+
+static int
+roll(double xcl, double ycl, gs_rect *pbbox, gs_matrix *pmat)
+{
+	double lly, ury;
+	gs_matrix mat, tmat;
+	static gs_matrix rmat =
+		{ constant_matrix_body(0.0, -1.0, 1.0, 0.0, 0.0, 0.0) };
+
+	gs_make_translation(xcl - ycl, xcl + ycl, &tmat);
+	gs_matrix_multiply(&rmat, &tmat, &mat);
+
+	gs_matrix_multiply(pmat, &mat, pmat);
+	gs_point_transform(pbbox->p.x, pbbox->p.y, &mat, &pbbox->p);
+	gs_point_transform(pbbox->q.x, pbbox->q.y, &mat, &pbbox->q);
+	lly = pbbox->q.y;
+	ury = pbbox->p.y;
+	pbbox->p.y = lly;
+	pbbox->q.y = ury;
+	return 0;
+}
+
+static int
+mirror(double xcl, double ycl, gs_rect *pbbox, gs_matrix *pmat)
+{
+	gs_point temp;
+	gs_matrix mat, tmat;
+	static gs_matrix mmat =
+		{ constant_matrix_body(0.0, -1.0, -1.0, 0.0, 0.0, 0.0) };
+
+	gs_make_translation(xcl + ycl, xcl + ycl, &tmat);
+	gs_matrix_multiply(&mmat, &tmat, &mat);
+
+	gs_matrix_multiply(pmat, &mat, pmat);
+	gs_point_transform(pbbox->p.x, pbbox->p.y, &mat, &pbbox->p);
+	gs_point_transform(pbbox->q.x, pbbox->q.y, &mat, &pbbox->q);
+	temp = pbbox->p;
+	pbbox->p = pbbox->q;
+	pbbox->q = temp;
+	return 0;
+}
+
+#define MOVE(dx, dy)	move(dx, dy, pbbox, pmat)
+#define LEFT	move(- pbbox->p.x, 0.0, pbbox, pmat)
+#define RIGHT	move(xcl*2.0 - pbbox->q.x, 0.0, pbbox, pmat)
+#define TOP	move(0.0, ycl*2.0 - pbbox->q.y, pbbox, pmat)
+#define BOTTOM	move(0.0, - pbbox->p.y, pbbox, pmat);
+#define HCENTER	move(xcl - (pbbox->p.x + pbbox->q.x)/2.0, 0.0, pbbox, pmat)
+#define VCENTER	move(0.0, ycl - (pbbox->p.y + pbbox->q.y)/2.0, pbbox, pmat)
+#define ROLL	roll(xcl, ycl, pbbox, pmat)
+#define MIRROR	mirror(xcl, ycl, pbbox, pmat)
+
+int
+kf_vmatrix(int jis_code, double xcl, double ycl, 
+	   gs_rect *pbbox, gs_matrix *pmat)
+{
+	gs_make_identity(pmat);
+
+	switch(jis_code) {
+
+	case 0x2122: RIGHT; TOP; MOVE(-100.0, 0.0); break;
+	case 0x2123: RIGHT; TOP; MOVE(-100.0, 0.0); break;
+	case 0x2131: ROLL; RIGHT; VCENTER; break;
+	case 0x2132: ROLL; LEFT; VCENTER; break;
+	case 0x213c: MIRROR; HCENTER; VCENTER; break;
+	case 0x213d: ROLL; HCENTER; VCENTER; break;
+
+	case 0x213e: ROLL; HCENTER; VCENTER; break;
+	case 0x2141: MIRROR; HCENTER; VCENTER; break;
+	case 0x2142: ROLL; HCENTER; VCENTER; break;
+	case 0x2143: ROLL; HCENTER; VCENTER; break;
+	case 0x2144: ROLL; HCENTER; VCENTER; break;
+	case 0x2145: ROLL; HCENTER; VCENTER; break;
+
+	case 0x214a: ROLL; HCENTER; BOTTOM; break;
+	case 0x214b: ROLL; HCENTER; TOP; break;
+	case 0x214c: ROLL; HCENTER; BOTTOM; break;
+	case 0x214d: ROLL; HCENTER; TOP; break;
+	case 0x214e: ROLL; HCENTER; BOTTOM; break;
+	case 0x214f: ROLL; HCENTER; TOP; break;
+
+	case 0x2150: ROLL; HCENTER; BOTTOM; break;
+	case 0x2151: ROLL; HCENTER; TOP; break;
+	case 0x2152: ROLL; HCENTER; BOTTOM; break;
+	case 0x2153: ROLL; HCENTER; TOP; break;
+	case 0x2154: ROLL; HCENTER; BOTTOM; break;
+	case 0x2155: ROLL; HCENTER; TOP; break;
+
+	case 0x2156: ROLL; RIGHT; BOTTOM; break;
+	case 0x2157: ROLL; LEFT; TOP; break;
+	case 0x2158: ROLL; RIGHT; BOTTOM; break;
+	case 0x2159: ROLL; LEFT; TOP; break;
+	case 0x215a: ROLL; HCENTER; BOTTOM; break;
+	case 0x215b: ROLL; HCENTER; TOP; break;
+
+	case 0x222e: ROLL; HCENTER; VCENTER; break;
+	case 0x2421: HCENTER; MOVE(100.0, 0.0); VCENTER; break;
+	case 0x2423: HCENTER; MOVE(100.0, 0.0); VCENTER; break;
+	case 0x2425: HCENTER; MOVE(100.0, 0.0); VCENTER; break;
+	case 0x2427: HCENTER; MOVE(100.0, 0.0); VCENTER; break;
+	case 0x2429: HCENTER; MOVE(100.0, 0.0); VCENTER; break;
+
+	case 0x2443: HCENTER; MOVE(100.0, 0.0); VCENTER; break;
+	case 0x2463: HCENTER; MOVE(100.0, 0.0); VCENTER; break;
+	case 0x2465: HCENTER; MOVE(100.0, 0.0); VCENTER; break;
+	case 0x2467: HCENTER; MOVE(100.0, 0.0); VCENTER; break;
+	case 0x246e: HCENTER; MOVE(100.0, 0.0); VCENTER; break;
+	case 0x2521: HCENTER; MOVE(100.0, 0.0); VCENTER; break;
+
+	case 0x2523: HCENTER; MOVE(100.0, 0.0); VCENTER; break;
+	case 0x2525: HCENTER; MOVE(100.0, 0.0); VCENTER; break;
+	case 0x2527: HCENTER; MOVE(100.0, 0.0); VCENTER; break;
+	case 0x2529: HCENTER; MOVE(100.0, 0.0); VCENTER; break;
+	case 0x2543: HCENTER; MOVE(100.0, 0.0); VCENTER; break;
+	case 0x2563: HCENTER; MOVE(100.0, 0.0); VCENTER; break;
+
+	case 0x2565: HCENTER; MOVE(100.0, 0.0); VCENTER; break;
+	case 0x2567: HCENTER; MOVE(100.0, 0.0); VCENTER; break;
+	case 0x256e: HCENTER; MOVE(100.0, 0.0); VCENTER; break;
+	case 0x2575: HCENTER; MOVE(100.0, 0.0); VCENTER; break;
+	case 0x2576: HCENTER; MOVE(100.0, 0.0); VCENTER; break;
+	default: 
+		return 0;
+	};
+	return 1;
+}
+
+int
+kf_is_vchar(int jis_code)
+{
+	switch(jis_code) {
+	case 0x2122: case 0x2123: case 0x2131: case 0x2132: case 0x213c: 
+	case 0x213d: case 0x213e: case 0x2141: case 0x2142: case 0x2143:
+	case 0x2144: case 0x2145: case 0x214a: case 0x214b: case 0x214c:
+	case 0x214d: case 0x214e: case 0x214f: case 0x2150: case 0x2151:
+	case 0x2152: case 0x2153: case 0x2154: case 0x2155: case 0x2156:
+	case 0x2157: case 0x2158: case 0x2159: case 0x215a: case 0x215b:
+	case 0x222e: case 0x2421: case 0x2423: case 0x2425: case 0x2427:
+	case 0x2429: case 0x2443: case 0x2463: case 0x2465: case 0x2467:
+	case 0x246e: case 0x2521: case 0x2523: case 0x2525: case 0x2527:
+	case 0x2529: case 0x2543: case 0x2563: case 0x2565: case 0x2567:
+	case 0x256e: case 0x2575: case 0x2576:
+		return 1;
+	default: 
+		return 0;
+	};
+}
diff -Nur ghostscript-9.53.3-orig/base/kfutil.h ghostscript-9.53.3/base/kfutil.h
--- ghostscript-9.53.3-orig/base/kfutil.h	Thu Jan 01 09:00:00 1970
+++ ghostscript-9.53.3/base/kfutil.h	Thu Oct 01 22:46:16 2020
@@ -0,0 +1,7 @@
+/*
+Akira Tanaka <akr@jaist.ac.jp> created for gs5.10-vflib-1.3. 1998/05/12
+*/
+
+
+int kf_vmatrix(int jis_code, double xcl, double ycl, gs_rect *pbbox, gs_matrix *pmat);
+int kf_is_vchar(int jis_code);
diff -Nur ghostscript-9.53.3-orig/base/lib.mak ghostscript-9.53.3/base/lib.mak
--- ghostscript-9.53.3-orig/base/lib.mak	Thu Oct 01 17:11:07 2020
+++ ghostscript-9.53.3/base/lib.mak	Thu Oct 01 22:39:51 2020
@@ -38,7 +38,7 @@
 AUX=$(AUXDIR)$(D)
 GLO_=$(O_)$(GLOBJ)
 AUXO_=$(O_)$(AUX)
-GLI_=$(GLGENDIR) $(II)$(GLSRCDIR) $(II)$(DEVSRCDIR)
+GLI_=$(GLGENDIR) $(II)$(GLSRCDIR) $(II)$(DEVSRCDIR) $(II)$(PSSRCDIR)
 GLF_=
 GLINCLUDES=$(I_)$(GLI_)$(_I)
 GLCCFLAGS=$(GLINCLUDES) $(GLF_) $(D_)WHICH_CMS="$(WHICH_CMS)"$(_D)
@@ -52,6 +52,7 @@
 GLLWFJPXCC=$(CC_) $(I_)$(LWF_JPXI_) $(II)$(GLI_)$(_I) $(JPXCF_) $(GLF_)
 GLJPXOPJCC=$(CC_) $(I_)$(JPX_OPENJPEG_I_)$(D).. $(I_)$(JPX_OPENJPEG_I_) $(II)$(GLI_)$(_I) $(JPXCF_) $(GLF_)
 GLCCSHARED=$(CC_SHARED) $(GLCCFLAGS)
+GLCCCC=$(CCCC_) $(GLCCFLAGS)
 # We can't use $(CC_) for GLLCMS2MTCC because that includes /Za on
 # msvc builds, and lcms configures itself to depend on msvc extensions
 # (inline asm, including windows.h) when compiled under msvc.
@@ -915,6 +916,21 @@
  $(gzcpath_h) $(gzline_h) $(gzpath_h) $(LIB_MAK) $(MAKEDIRS)
 	$(GLCC) $(GLO_)gxstroke.$(OBJ) $(C_) $(GLSRC)gxstroke.c
 
+# ===========================
+# Japanese support
+
+$(GLOBJ)kfutil.$(OBJ): $(GLSRC)kfutil.c $(gsmatrix_h)
+	$(GLCC) $(GLO_)kfutil.$(OBJ) $(C_) $(GLSRC)kfutil.c
+
+$(GLOBJ)zkfimpath.$(OBJ): $(GLSRC)zkfimpath.c $(gsmatrix_h) \
+     $(gspath_h) $(igstate_h) $(store_h)
+	$(GLCC) $(GLO_)zkfimpath.$(OBJ) $(C_) $(GLSRC)zkfimpath.c
+
+$(GLOBJ)zkfwin32.$(OBJ): $(GLSRC)zkfwin32.c
+	$(GLCCCC) $(GLO_)zkfwin32.$(OBJ) $(C_) $(GLSRC)zkfwin32.c
+
+# In the above, GLCCCC is for Win32 (NO /Za option).
+# GLCCCC is defined in msvccmd.mak (1999 A.K.)
 ###### Higher-level facilities
 
 # gscedata.[ch] are generated automatically by lib/encs2c.ps.
@@ -1441,6 +1457,7 @@
 LIB8x=$(GLOBJ)gxi12bit.$(OBJ) $(GLOBJ)gxi16bit.$(OBJ) $(GLOBJ)gxiscale.$(OBJ) $(GLOBJ)gxpaint.$(OBJ) $(GLOBJ)gxpath.$(OBJ) $(GLOBJ)gxpath2.$(OBJ)
 LIB9x=$(GLOBJ)gxpcopy.$(OBJ) $(GLOBJ)gxpdash.$(OBJ) $(GLOBJ)gxpflat.$(OBJ)
 LIB10x=$(GLOBJ)gxsample.$(OBJ) $(GLOBJ)gxstroke.$(OBJ) $(GLOBJ)gxsync.$(OBJ)
+LIB11x=$(GLOBJ)kfutil.$(OBJ) $(GLOBJ)zkfwin32.$(OBJ) $(GLOBJ)zkfimpath.$(OBJ)
 LIB1d=$(GLOBJ)gdevabuf.$(OBJ) $(GLOBJ)gdevdbit.$(OBJ) $(GLOBJ)gdevddrw.$(OBJ) $(GLOBJ)gdevdflt.$(OBJ)
 LIB2d=$(GLOBJ)gdevdgbr.$(OBJ) $(GLOBJ)gdevnfwd.$(OBJ) $(GLOBJ)gdevmem.$(OBJ) $(GLOBJ)gdevplnx.$(OBJ)
 LIB3d=$(GLOBJ)gdevm1.$(OBJ) $(GLOBJ)gdevm2.$(OBJ) $(GLOBJ)gdevm4.$(OBJ) $(GLOBJ)gdevm8.$(OBJ)
@@ -1449,7 +1466,7 @@
 LIB6d=$(GLOBJ)gdevdsha.$(OBJ) $(GLOBJ)gxscanc.$(OBJ)
 LIBs=$(LIB0s) $(LIB1s) $(LIB2s) $(LIB3s) $(LIB4s) $(LIB5s) $(LIB6s) $(LIB7s)\
  $(LIB8s) $(LIB9s) $(LIB10s) $(LIB11s) $(LIB12s) $(LIB13s)
-LIBx=$(LIB1x) $(LIB2x) $(LIB3x) $(LIB4x) $(LIB5x) $(LIB6x) $(LIB7x) $(LIB8x) $(LIB9x) $(LIB10x)
+LIBx=$(LIB1x) $(LIB2x) $(LIB3x) $(LIB4x) $(LIB5x) $(LIB6x) $(LIB7x) $(LIB8x) $(LIB9x) $(LIB10x) $(LIB11x)
 LIBd=$(LIB1d) $(LIB2d) $(LIB3d) $(LIB4d) $(LIB5d) $(LIB6d)
 LIB_ALL=$(LIBs) $(LIBx) $(LIBd)
 # We include some optional library modules in the dependency list,
@@ -1491,6 +1508,7 @@
 	$(ADDMOD) $(GLD)libx $(LIB8x)
 	$(ADDMOD) $(GLD)libx $(LIB9x)
 	$(ADDMOD) $(GLD)libx $(LIB10x)
+	$(ADDMOD) $(GLD)libx $(LIB11x)
 	$(ADDMOD) $(GLD)libx -imageclass 0_interpolate
 	$(ADDMOD) $(GLD)libx -imageclass 1_simple 3_mono
 	$(ADDMOD) $(GLD)libx -imagetype 1 mask1
diff -Nur ghostscript-9.53.3-orig/base/msvccmd.mak ghostscript-9.53.3/base/msvccmd.mak
--- ghostscript-9.53.3-orig/base/msvccmd.mak	Thu Oct 01 17:11:07 2020
+++ ghostscript-9.53.3/base/msvccmd.mak	Thu Oct 01 22:40:32 2020
@@ -250,8 +250,9 @@
 
 
 # /Za disables the MS-specific extensions & enables ANSI mode.
-CC_WX=$(CC) $(WX)
+CC_WX=$(CC) $(WX) /wd4819
 CC_=$(CC_WX) /Za $(ZM)
+CCCC_=$(CC_WX) $(ZM)
 CC_NO_WARN=$(CC_)
 
 # Compiler for auxiliary programs
diff -Nur ghostscript-9.53.3-orig/base/msvclib.mak ghostscript-9.53.3/base/msvclib.mak
--- ghostscript-9.53.3-orig/base/msvclib.mak	Thu Oct 01 17:11:07 2020
+++ ghostscript-9.53.3/base/msvclib.mak	Thu Oct 01 22:41:18 2020
@@ -65,7 +65,7 @@
 # Define the root directory for Ghostscript installation.
 
 !ifndef AROOTDIR
-AROOTDIR=c:/gs
+AROOTDIR=C:/gs
 !endif
 !ifndef GSROOTDIR
 GSROOTDIR=$(AROOTDIR)/gs$(GS_DOT_VERSION)
@@ -84,7 +84,7 @@
 # illegal escape.
 
 !ifndef GS_LIB_DEFAULT
-GS_LIB_DEFAULT=$(GSROOTDIR)/Resource/Init;$(GSROOTDIR)/lib;$(GSROOTDIR)/Resource;$(AROOTDIR)/fonts
+GS_LIB_DEFAULT=C:/Windows/Fonts;C:/WINDOWS/Fonts;C:/windows/Fonts
 !endif
 
 # Define whether or not searching for initialization files should always
@@ -617,7 +617,7 @@
 
 !ifndef MSVC_VERSION
 !MESSAGE Could not determine MSVC_VERSION! Guessing at an ancient one.
-MSVC_VERSION=6
+MSVC_VERSION=10
 !endif
 !ifndef MSVC_MINOR_VERSION
 MSVC_MINOR_VERSION=0
@@ -739,9 +739,9 @@
 !if $(MSVC_VERSION) == 10
 ! ifndef DEVSTUDIO
 !if $(BUILD_SYSTEM) == 64
-DEVSTUDIO=C:\Program Files (x86)\Microsoft Visual Studio 10.0
+DEVSTUDIO=c:\usr\studio10
 !else
-DEVSTUDIO=C:\Program Files\Microsoft Visual Studio 10.0
+DEVSTUDIO=c:\usr\studio10
 !endif
 ! endif
 !if "$(DEVSTUDIO)"==""
@@ -758,10 +758,10 @@
 RCDIR=$(MSSDK)\bin
 !  endif
 ! else
-!ifdef WIN64
-RCDIR=C:\Program Files (x86)\Microsoft SDKs\Windows\v7.0\bin
+!if $(BUILD_SYSTEM) == 64
+RCDIR=C:\Program Files (x86)\Microsoft SDKs\Windows\v7.0A\bin
 !else
-RCDIR=C:\Program Files\Microsoft SDKs\Windows\v7.0\bin
+RCDIR=C:\Program Files\Microsoft SDKs\Windows\v7.0A\bin
 !endif
 ! endif
 COMPBASE=$(DEVSTUDIO)\VC
@@ -865,9 +865,9 @@
 !if $(MSVC_VERSION) == 14
 ! ifndef DEVSTUDIO
 !  if $(BUILD_SYSTEM) == 64
-DEVSTUDIO=C:\Program Files (x86)\Microsoft Visual Studio 14.0
+DEVSTUDIO=C:usr\studio15
 !  else
-DEVSTUDIO=C:\Program Files\Microsoft Visual Studio 14.0
+DEVSTUDIO=C:usr\studio15
 !  endif
 ! endif
 ! if "$(DEVSTUDIO)"==""
@@ -885,9 +885,9 @@
 !   endif
 !  else
 !   if $(BUILD_SYSTEM) == 64
-RCDIR=C:\Program Files (x86)\Microsoft SDKs\Windows\v10.0A\Bin
+RCDIR=C:\Program Files (x86)\Windows Kits\8.1\bin\x86
 !   else
-RCDIR=C:\Program Files\Microsoft SDKs\Windows\v10.0A\Bin
+RCDIR=C:\Program Files\Windows Kits\8.1\bin\x86
 !   endif
 !  endif
 COMPBASE=$(DEVSTUDIO)\VC
@@ -1179,7 +1179,7 @@
 # See gs.mak for details.
 
 !ifndef COMPILE_INITS
-COMPILE_INITS=1
+COMPILE_INITS=0
 !endif
 
 # Choose whether to store band lists on files or in memory.
diff -Nur ghostscript-9.53.3-orig/base/zkfimpath.c ghostscript-9.53.3/base/zkfimpath.c
--- ghostscript-9.53.3-orig/base/zkfimpath.c	Thu Jan 01 09:00:00 1970
+++ ghostscript-9.53.3/base/zkfimpath.c	Thu Oct 01 22:46:04 2020
@@ -0,0 +1,341 @@
+/*
+ * Bitmap Image Utility Routines
+ *
+ * Copyright (C) 1991 Norio Katayama.
+ * Aug. 28, 1991 Programmed by N.Katayama (katayama@nacsis.ac.jp)
+ */
+
+#include "memory_.h"
+#include "ghost.h"
+#include "oper.h"
+#include "opdef.h"
+#include "gserrors.h"
+#include "gsmatrix.h"
+#include "gspath.h"
+#include "gsstate.h"
+#include "igstate.h"
+#include "store.h"
+#include "gxdevice.h"
+#include "iref.h"
+
+/* Forward declaration */
+
+int gs_imagebbox(int, int, int, gs_matrix *, byte *, gs_rect *);
+static int imagepath(i_ctx_t *, int, int, int, gs_matrix *, byte *);
+static int trace_path(i_ctx_t *, byte *, int, int, int, gs_matrix *, int);
+
+/*
+ * imagepath
+ */
+
+int
+zkfimagepath(i_ctx_t *i_ctx_p)
+{
+	os_ptr op = osp;
+	int code;
+	gs_matrix mat;
+
+	check_type(op[-4], t_integer);
+	check_type(op[-3], t_integer);
+	check_type(op[-2], t_boolean);
+	if((code = read_matrix(imemory, op - 1, &mat)) < 0)
+		return code;
+	check_type(*op, t_string);
+
+	if((code = 
+	    imagepath(i_ctx_p, (int)op[-4].value.intval, (int)op[-3].value.intval, 
+		      (int)op[-2].value.boolval, &mat, op[0].value.bytes)) < 0)
+		return code;
+
+	pop(5);
+	return 0;
+}
+
+/*
+ * imagebbox
+ */
+
+int
+zkfimagebbox(i_ctx_t *i_ctx_p)
+{
+	os_ptr op = osp;
+	int code;
+	gs_rect bbox;
+	gs_matrix mat;
+
+	check_type(op[-4], t_integer);
+	check_type(op[-3], t_integer);
+	check_type(op[-2], t_boolean);
+	if((code = read_matrix(imemory, op - 1, &mat)) < 0)
+		return code;
+	check_type(op[0], t_string);
+
+	if((code = 
+	    gs_imagebbox((int)op[-4].value.intval, (int)op[-3].value.intval, 
+			 (int)op[-2].value.boolval, &mat, op[0].value.bytes,
+			 &bbox)) < 0)
+		return code;
+
+	pop(1);
+	op --;
+	make_real(op - 3, bbox.p.x);
+	make_real(op - 2, bbox.p.y);
+	make_real(op - 1, bbox.q.x);
+	make_real(op, bbox.q.y);
+	return 0;
+}
+
+/* -------- Initialization procedure -------- */
+
+const op_def zkfimagepath_op_defs[] = {
+	{"5imagepath", zkfimagepath},
+	{"5imagebbox", zkfimagebbox},
+	op_def_end(0)
+};
+
+
+/* -------- Library routines -------- */
+
+/*
+ * Retrieve the boundary box of bitmap image
+ */
+
+int
+gs_imagebbox(int width, int height, int bool, 
+	     gs_matrix *pmat, byte *image, gs_rect *pbbox)
+{
+	int code, x, y, offx, offy;
+	int width8 = width / 8 + (width % 8 ? 1 : 0);
+	int minx, miny, maxx, maxy;
+	byte mask;
+	gs_matrix imat;
+
+	minx = width;
+	maxx = 0;
+	miny = height;
+	maxy = 0;
+
+	for(y=0, offy=0; y<height; y++, offy+=width8) {
+		mask = 0x80;
+		for(x=0, offx=offy; x<width; x++) {
+			if((image[offx] & mask) ? bool : !bool) {
+				if(x < minx)
+					minx = x;
+				if(x > maxx)
+					maxx = x;
+				if(y < miny)
+					miny = y;
+				if(y > maxy)
+					maxy = y;
+			}
+			if((mask = (mask >> 1)) == 0) {
+				mask = 0x80;
+				offx ++;
+			}
+		}
+	}
+	
+	if((code = gs_matrix_invert(pmat, &imat)) < 0)
+		return code;
+
+	gs_point_transform((double)minx, (double)miny, &imat, &pbbox->p);
+	gs_point_transform((double)maxx+1, (double)maxy+1, &imat, &pbbox->q);
+
+	if(pbbox->p.x > pbbox->q.x) {
+		double temp;
+		temp = pbbox->p.x;
+		pbbox->p.x = pbbox->q.x;
+		pbbox->q.x = temp;
+	}
+	if(pbbox->p.y > pbbox->q.y) {
+		double temp;
+		temp = pbbox->p.y;
+		pbbox->p.y = pbbox->q.y;
+		pbbox->q.y = temp;
+	}
+
+	return 0;
+}
+
+/* -------- Internal routines -------- */
+
+/*
+ * imagepath
+ */
+
+#define BIT_ON		0x01
+#define WEST_EDGE_DONE	0x02
+#define FIRST_BIT	0x04
+
+#define moveto(x, y)	{ gs_point pt; \
+	gs_point_transform((float)(x)/4.0, (float)(y)/4.0, pmat, &pt); \
+	gs_moveto(igs, pt.x, pt.y); }
+
+#define lineto(x, y)	{ gs_point pt; \
+	gs_point_transform((float)(x)/4.0, (float)(y)/4.0, pmat, &pt); \
+	gs_lineto(igs, pt.x, pt.y); }
+
+#define closepath()	gs_closepath(igs)
+
+static int
+imagepath(i_ctx_t *i_ctx_p, int width, int height, int fine,
+gs_matrix *pmat, byte *image)
+{
+	byte *bitmap, *bpx, *bpy;
+	int code, x, y, offx, offy;
+	int width8 = width / 8 + (width % 8 ? 1 : 0);
+	int bwidth = width + 2;
+	int bheight = height + 2;
+	int bsize = bwidth*bheight;
+	byte mask;
+	gs_matrix imat;
+
+	if((code = gs_matrix_invert(pmat, &imat)) < 0)
+		return code;
+
+/*
+	if((bitmap = (byte *)malloc(bsize) == 0))
+		return gs_error_VMerror;
+*/
+	if((bitmap = (byte *)gs_malloc(imemory, bsize, 1, "imagepath(bitmap)")) == 0)
+		return gs_error_VMerror;
+
+	memset(bitmap, 0, bsize);
+
+	for(y=0, bpy=bitmap+bwidth, offy=0; y<height; 
+	    y++, bpy+=bwidth, offy+=width8) {
+		mask = 0x80;
+		for(x=0, bpx=bpy+1, offx=offy; x<width; x++, bpx++) {
+			if(image[offx] & mask)
+				*bpx = 1;
+			if((mask = (mask >> 1)) == 0) {
+				mask = 0x80;
+				offx ++;
+			}
+		}
+	}
+	
+	for(y=0, bpy=bitmap+bwidth; y<height; y++,bpy+=bwidth) {
+		for(x=0, bpx=bpy+1; x<width; x++, bpx++) {
+			if(*(bpx - 1) == 0 && *bpx == BIT_ON)
+				trace_path(i_ctx_p, bpx, bwidth, x, y, &imat, fine);
+		}
+	}
+/*
+	free(bitmap);
+*/
+	gs_free(imemory, (char *)bitmap, bsize, 1, "imagepath(bitmap)");
+	return 0;
+}
+
+static int
+trace_path(i_ctx_t *i_ctx_p, byte *bp, int bwidth, int x, int y,
+	   gs_matrix *pmat, int fine)
+{
+#define EAST	0
+#define SOUTH	1
+#define WEST	2
+#define NORTH	3
+	static int bd[] = {
+		1,		/* east */
+		-1,		/* south */
+		-1,		/* west */
+		1,		/* north */
+	};
+	static struct xy {
+		int x, y;
+	} xy[] = {
+		{ 1, 0 },	/* east */
+		{ 0, -1 },	/* south */
+		{ -1, 0 },	/* west */
+		{ 0, 1 },	/* north */
+	};
+	int edge = WEST;
+	int dir = NORTH;
+	int straight = 0;
+	int ex, ey, dx, dy;
+	int bd_edge, bd_dir;
+	int temp;
+
+	bd[NORTH] = bwidth;
+	bd[SOUTH] = -bwidth;
+	x = x*4;
+	y = y*4 + 2;
+	moveto(x, y);
+	
+	*bp |= FIRST_BIT;
+	do {
+		if(edge == WEST)
+			*bp |= WEST_EDGE_DONE;
+		ex = xy[edge].x;
+		ey = xy[edge].y;
+		dx = xy[dir].x;
+		dy = xy[dir].y;
+		bd_edge = bd[edge];
+		bd_dir = bd[dir];
+		if(*(bp + bd_dir + bd_edge)) {
+			if(fine) {
+				if(*(bp + bd_dir)) {
+					x += dx;
+					y += dy;
+					lineto(x, y);
+					x += dx + ex;
+					y += dy + ey;
+					lineto(x, y);
+					x += ex;
+					y += ey;
+				}
+				else {
+					lineto(x, y);
+					x += (dx << 1) + (ex << 1);
+					y += (dy << 1) + (ey << 1);
+					lineto(x, y);
+				}
+			}
+			else {
+				if(straight)
+					lineto(x, y);
+				x += (dx << 1) + (ex << 1);
+				y += (dy << 1) + (ey << 1);
+				lineto(x, y);
+			}	
+			bp += bd_dir + bd_edge;
+			temp = edge;
+			edge = (dir + 2) & 3;
+			dir = temp;
+			straight = 0;
+		}
+		else if(*(bp + bd_dir)) {
+			x += dx << 2;
+			y += dy << 2;
+			bp += bd_dir;
+			straight = 1;
+		}
+		else {
+			if(fine) {
+				x += dx;
+				y += dy;
+				lineto(x, y);
+				x += dx - ex;
+				y += dy - ey;
+				lineto(x, y);
+				x += - ex;
+				y += - ey;
+			}
+			else {
+				if(straight)
+					lineto(x, y);
+				x += (dx << 1) - (ex << 1);
+				y += (dy << 1) - (ey << 1);
+				lineto(x, y);
+			}
+			temp = edge;
+			edge = dir;
+			dir = (temp + 2) & 3;
+			straight = 0;
+		}
+	} while( edge != WEST || !(*bp & FIRST_BIT));
+	closepath();
+	*bp &= ~FIRST_BIT;
+	return 0;
+}
diff -Nur ghostscript-9.53.3-orig/base/zkfwin32.c ghostscript-9.53.3/base/zkfwin32.c
--- ghostscript-9.53.3-orig/base/zkfwin32.c	Thu Jan 01 09:00:00 1970
+++ ghostscript-9.53.3/base/zkfwin32.c	Thu Oct 01 22:46:08 2020
@@ -0,0 +1,519 @@
+/*
+ * zkfwin32.c --- Kanji font operator for MS-Windows API.
+ * Copyright (C) ASAYAMA Kazunori  1997.
+ *
+ * Bitmap fonts  (--ak, 2002)
+ */
+
+
+#include "math_.h"
+#include "memory_.h"
+#include "ghost.h"
+#include "gp.h"
+#include "oper.h"
+#include "gserrors.h"
+#include "gspath.h"
+#include "gsmatrix.h"
+#include "gscoord.h"
+#include "gsstate.h"
+#include "igstate.h"
+#include "stream.h"
+#include "files.h"
+#include "store.h"
+#include "gsmalloc.h"
+#include "iref.h"
+#include "gxdevice.h"
+#include "gxcindex.h"
+#include "windows_.h"
+
+#define BOX_SIZE 1000
+#define B_X_CL   500 /* horizontal center in BuildChar */
+#define B_Y_CL   400 /* vertical center in BuildChar */
+
+/* Forward declaration */
+extern int kf_is_vchar(int);
+extern int kf_vmatrix(int, double, double, gs_rect *, gs_matrix *);
+static int draw_font(i_ctx_t *,const char *, int);
+static int open_font(i_ctx_t *,const char *, HFONT* );
+
+int
+zkfwin32(i_ctx_t *i_ctx_p)
+{
+  os_ptr op = osp;
+  char *font_name;
+  int code, jis_code, wmode;
+  
+  check_type(op[-2], t_integer);                /* JIS Code */
+  check_type(op[-1], t_integer);                /* WMode */
+  check_type(op[0], t_string);          /* Font Name */ 
+  
+  jis_code = op[-2].value.intval;
+  wmode = op[-1].value.intval;
+/*
+  font_name = (char *)malloc(r_size(op) + 2);
+*/
+  font_name = gs_malloc(imemory, r_size(op) + 2, 1, "zkfwin32");
+  if (font_name == NULL)
+    return gs_error_VMerror;
+  
+  memcpy(font_name, op->value.bytes, r_size(op));
+  font_name[r_size(op)] = 0;
+  
+  if(wmode && kf_is_vchar(jis_code)) {
+    /* vertical kanji character */
+    gs_matrix smat, vmat;
+    gs_rect bbox;
+    if((code = gs_gsave(igs)) >= 0 && /* i_ctx_p ? */
+       (code = draw_font(i_ctx_p, font_name, jis_code)) >= 0 &&
+       (code = gs_flattenpath(igs)) >= 0 &&
+       (code = gs_pathbbox(igs, &bbox)) >= 0 &&
+       (code = gs_grestore(igs)) >= 0) {
+      gs_currentmatrix(igs, &smat);
+      kf_vmatrix(jis_code, 
+		 (double)B_X_CL, (double)B_Y_CL, &bbox, &vmat);
+      if((code = gs_concat(igs, &vmat)) >= 0 &&
+	 (code = draw_font(i_ctx_p, font_name, jis_code)) >= 0)
+	gs_setmatrix(igs, &smat);
+    }
+  }
+  else
+    code = draw_font(i_ctx_p, font_name, jis_code);
+
+/*  
+  free(font_name);
+*/
+  gs_free(imemory, font_name, r_size(op) + 2, 1, "zkfwin32");
+  if (code >= 0)
+    pop(3); /* i_ctx_p ? */
+  
+  return code;
+}
+
+/* -------- Internal routines -------- */
+#define fixed2double(p) ( (double)*(LONG*)&(p) / 0x10000 )
+
+/* data coordination -> character coordination */
+#define map_x(x) ( fixed2double(x) / BOX_SIZE * 1000 )
+#define map_y(y) ( fixed2double(y) / BOX_SIZE * 1000 )
+
+/* drawing */
+#define moveto(p) gs_moveto(igs, map_x((p)->x), map_y((p)->y))
+#define lineto(p) gs_lineto(igs, map_x((p)->x), map_y((p)->y))
+#define curveto(p0, p1, p2) \
+  gs_curveto(igs, \
+	     (map_x((p0)->x) + 2 * map_x((p1)->x)) / 3, \
+	     (map_y((p0)->y) + 2 * map_y((p1)->y)) / 3, \
+             (2 * map_x((p1)->x) + map_x((p2)->x)) / 3, \
+	     (2 * map_y((p1)->y) + map_y((p2)->y)) / 3, \
+	     map_x((p2)->x), map_y((p2)->y))
+#define closepath() gs_closepath(igs)
+
+/* encoding */
+int _mbcjistojms(int jis);
+
+#define jistosjis(jis) _mbcjistojms(jis)
+
+/*
+ * Open font 
+ */
+
+static LOGFONT g_lfPrev;
+static HFONT g_hPrevFont = NULL;
+
+static int
+open_font(i_ctx_t *i_ctx_p, const char *font_name, HFONT* phFont)
+{
+  LOGFONT lf;
+  
+  if (g_hPrevFont) {
+    if (strcmp(g_lfPrev.lfFaceName, font_name) == 0) {
+      *phFont = g_hPrevFont;
+      return 0;
+    }
+    DeleteObject(g_hPrevFont);
+  }
+  
+  lf.lfHeight = - BOX_SIZE;
+  lf.lfWidth = 0;
+  lf.lfEscapement = 0;
+  lf.lfOrientation = 0;
+  lf.lfWeight = FW_NORMAL;
+  lf.lfItalic = 0;
+  lf.lfUnderline = 0;
+  lf.lfStrikeOut = 0;
+  lf.lfCharSet = SHIFTJIS_CHARSET;
+  lf.lfOutPrecision = OUT_TT_ONLY_PRECIS;
+  lf.lfClipPrecision = CLIP_TT_ALWAYS;
+  lf.lfQuality = PROOF_QUALITY;
+  lf.lfPitchAndFamily = DEFAULT_PITCH;
+  strcpy(lf.lfFaceName, font_name);
+  
+  g_hPrevFont = CreateFontIndirect(&lf);
+  if (!g_hPrevFont) {
+    eprintf1("win32(open_font): Cannot open the font `%s'.\n", font_name);
+    return gs_error_ioerror;
+  }
+  
+  *phFont = g_hPrevFont;
+  strcpy(g_lfPrev.lfFaceName, font_name);
+  
+  return 0;
+}
+
+static int
+draw_contour(i_ctx_t *i_ctx_p, TTPOLYGONHEADER *lpHdr)
+{
+  TTPOLYCURVE *lpCrv = (TTPOLYCURVE*)((LPBYTE)lpHdr + sizeof(TTPOLYGONHEADER));
+  TTPOLYCURVE *lpCrvEnd = (TTPOLYCURVE*)((LPBYTE)lpHdr + lpHdr->cb);
+  POINTFX pt;
+  int code;
+  
+  if (lpHdr->dwType != TT_POLYGON_TYPE) {
+    /* unsupported type of outline */
+    return gs_error_unknownerror;
+  }
+  
+  pt = lpHdr->pfxStart;
+  if ((code = moveto(&pt)) < 0) /* i_ctx_p ? */
+    return code;
+  while (lpCrv < lpCrvEnd) {
+    if (lpCrv->wType == TT_PRIM_LINE) {
+      int i;
+      for (i=0;i<lpCrv->cpfx;i++) {
+	if ((code = lineto(lpCrv->apfx + i)) < 0)
+	  return code;
+      }
+      pt = lpCrv->apfx[lpCrv->cpfx-1];
+    }
+    else if (lpCrv->wType == TT_PRIM_QSPLINE) {
+      int i;
+      for (i=0;i<lpCrv->cpfx - 1;i++) {
+	POINTFX ptc, ptn;
+	ptc = lpCrv->apfx[i];
+	ptn = lpCrv->apfx[i+1];
+	if (i + 2 < lpCrv->cpfx) {
+	  *(LONG*)&ptn.x = (*(LONG*)&ptc.x + *(LONG*)&ptn.x) / 2;
+	  *(LONG*)&ptn.y = (*(LONG*)&ptc.y + *(LONG*)&ptn.y) / 2;
+	}
+	if ((code = curveto(&pt, &ptc, &ptn)) < 0)
+	  return code;
+	pt = ptn;
+      }
+    }
+    else {
+      /* unknown type of curve */
+      return gs_error_unknownerror;
+    }
+    lpCrv = (TTPOLYCURVE*)(lpCrv->apfx + lpCrv->cpfx);
+  }
+  return closepath();
+}
+
+static int 
+draw_font(i_ctx_t *i_ctx_p, const char *font_name, int jis)
+{
+  int code = 0;
+  HFONT hFont, hOldFont;
+  HWND hWnd = HWND_DESKTOP;
+  HDC hDC;
+  DWORD len;
+  GLYPHMETRICS met;
+  MAT2 mat;
+  byte *glyph;
+  int sjis;
+  
+  code = open_font(i_ctx_p, font_name, &hFont);
+  if (code < 0) return code;
+
+  hDC = GetDC(hWnd);
+  if (!hDC) return gs_error_unknownerror;
+
+  memset(&mat, 0, sizeof(mat));
+  mat.eM11.value = 1;
+  mat.eM22.value = 1;
+  sjis = jistosjis(jis);
+  hOldFont = SelectObject(hDC, hFont);
+  len = GetGlyphOutline(hDC, sjis, GGO_NATIVE, &met, 0, NULL, &mat);
+/*
+  glyph = (byte *)malloc(len);
+*/
+  glyph = gs_malloc(imemory, len, 1, "zkfwin32");
+
+  if (!glyph) {
+    code = gs_error_VMerror;
+  }
+  else {
+    int n = GetGlyphOutline(hDC, sjis, GGO_NATIVE, &met, len, glyph, &mat);
+    if (n == GDI_ERROR) {
+      code = gs_error_unknownerror;
+    }
+    else {
+      LPBYTE p = glyph;
+      while (p < glyph + len) {
+	code = draw_contour(i_ctx_p,(TTPOLYGONHEADER*)p);
+	if (code < 0) break;
+	p += ((TTPOLYGONHEADER*)p)->cb;
+      }
+    }
+/*
+    free(glyph);
+*/
+    gs_free(imemory, glyph, len, 1, "zkfwin32");
+
+  }
+  SelectObject(hDC, hOldFont);
+  
+  ReleaseDC(hWnd, hDC);
+  
+  return code;
+}
+
+
+/*
+   ====================================================
+
+Experiment of BitMap Fonts (2002 --ak)
+
+   ====================================================
+*/
+
+/* global parameter */
+double Factor_for_Width;
+
+static int CALLBACK EnumFontProc( ENUMLOGFONT* lpelf, NEWTEXTMETRIC* lpntm, 
+				 int nFontType, LPARAM lParam )
+{
+  if(nFontType & TRUETYPE_FONTTYPE)
+    Factor_for_Width = 0.5;
+  else
+    Factor_for_Width = 1.0;
+  return 0;
+}
+
+static int
+open_fontBM(i_ctx_t *i_ctx_p, int width, int height,
+	    const char *font_name, HFONT* phFont)
+{
+  LOGFONT lf;
+  
+  if (g_hPrevFont) {
+    if (strcmp(g_lfPrev.lfFaceName, font_name) == 0 &&
+	g_lfPrev.lfWidth == width &&
+	g_lfPrev.lfHeight == -height) {
+      *phFont = g_hPrevFont;
+      return 0;
+    }
+    DeleteObject(g_hPrevFont);
+  }
+  
+  lf.lfHeight = -height;
+  lf.lfWidth = width;
+  lf.lfEscapement = 0;
+  lf.lfOrientation = 0;
+  lf.lfWeight = FW_NORMAL;
+  lf.lfItalic = 0;
+  lf.lfUnderline = 0;
+  lf.lfStrikeOut = 0;
+  lf.lfCharSet = SHIFTJIS_CHARSET;
+  lf.lfOutPrecision = OUT_TT_ONLY_PRECIS;
+  lf.lfClipPrecision = CLIP_DEFAULT_PRECIS;
+  lf.lfQuality = PROOF_QUALITY;
+  lf.lfPitchAndFamily = DEFAULT_PITCH;
+  strcpy(lf.lfFaceName, font_name);
+  
+  g_hPrevFont = CreateFontIndirect(&lf);
+  if (!g_hPrevFont) {
+    eprintf1("win32(open_font): Cannot open the font `%s'.\n", font_name);
+    return gs_error_ioerror;
+  }
+  
+  *phFont = g_hPrevFont;
+  strcpy(g_lfPrev.lfFaceName, font_name);
+  g_lfPrev.lfWidth = width;
+  g_lfPrev.lfHeight = -height;
+  
+  return 0;
+}
+
+static int
+WINapiimage(i_ctx_t *i_ctx_p, const char *font_name, int jis_code, 
+	      int *width, int *height, byte *bitmap, int length,
+	      gs_matrix *pmat, double *wx, double *wy)
+{
+  int code = 0;
+  HFONT hFont, hOldFont;
+  HWND hWnd = HWND_DESKTOP;
+  HDC hDC;
+  GLYPHMETRICS met;
+  MAT2 mat2;
+  int sjis;
+  LPARAM lParam; /* dummy */
+
+  int i, len;
+  double wd, ht;
+  double dx, dy;
+  gs_matrix mat, smat, tmat;
+  gx_device *dev = gs_currentdevice_inline(igs);
+  int alpha_bits = (*dev_proc(dev, get_alpha_bits))(dev, go_text);
+
+  gs_currentmatrix(igs, &mat);
+  wd = 1000.0 * hypot(mat.xx, mat.yx);
+  ht = 1000.0 * hypot(mat.yy, mat.xy);
+
+  if (alpha_bits > 1) {
+    wd *= (1 << (alpha_bits/2));
+    ht *= (1 << (alpha_bits/2));
+  }
+
+  if (wd < 4 || ht < 4) wd = ht = 4;		/* Too small! */
+  if (wd > 200 || ht > 200) wd = ht = 200;	/* Too large! */
+
+  hDC = GetDC(hWnd);
+  if(!hDC) return gs_error_unknownerror;
+
+  i = EnumFonts(hDC, font_name, EnumFontProc, lParam);
+  len = Factor_for_Width * 2;
+  if( i != 0 || (len != 1 && len != 2)) {
+    ReleaseDC(hWnd, hDC);
+    return gs_error_unknownerror;
+  }
+
+  *width = (wd + 0.5) * Factor_for_Width;
+  *height = ht + 0.5;
+
+  code = open_fontBM(i_ctx_p, *width, *height, font_name, &hFont);
+  if(code < 0) {
+    ReleaseDC(hWnd, hDC);
+    return code;
+  }
+
+  memset(&mat2, 0, sizeof(mat2));
+  mat2.eM11.value = 1;
+  mat2.eM22.value = 1;
+  sjis = jistosjis(jis_code);
+
+  hOldFont = SelectObject(hDC, hFont);
+  
+  len = GetGlyphOutline(hDC, sjis, GGO_BITMAP, &met, 0, NULL, &mat2);
+  if (len > length) {
+    SelectObject(hDC, hOldFont);
+    ReleaseDC(hWnd, hDC);
+    return gs_error_rangecheck;
+  }
+  
+  for (i = 0; i < length; i++) bitmap[i] = 0;
+  
+  i = GetGlyphOutline(hDC, sjis, GGO_BITMAP, &met, len, bitmap, &mat2);
+  
+  if(i == GDI_ERROR)
+    code = gs_error_unknownerror;
+  else {
+    code = 0;
+    *width = ((met.gmBlackBoxX + 31) >> 5)<<5;
+    *height = met.gmBlackBoxY;
+
+    /* Transform Image */
+
+    gs_make_identity(pmat);
+    gs_make_scaling(wd / 1000.0, -ht / 1000.0, &smat);
+
+    dx = -met.gmptGlyphOrigin.x;
+    dy = met.gmptGlyphOrigin.y;
+
+    gs_make_translation(dx, dy, &tmat);
+    gs_matrix_multiply(pmat, &smat, pmat);
+    gs_matrix_multiply(pmat, &tmat, pmat);
+    *wx = (double)1000.0;
+    *wy = 0;
+  }
+  SelectObject(hDC, hOldFont);
+  ReleaseDC(hWnd, hDC);
+  return code;
+}
+
+int
+zkfwin32BM(i_ctx_t *i_ctx_p)
+{
+  os_ptr op = osp;
+  char *font_name;
+  int code, width, height, length;
+  int jis_code, wmode;
+  byte *bitmap;
+  double w0x, w0y;
+  gs_matrix mat, vmat, imat;
+  gs_rect bbox;
+
+  check_type(op[-4], t_integer);		/* JIS Code */
+  check_type(op[-3], t_integer);		/* WMode */
+  check_write_type(op[-2], t_array);	/* ImageMatrix */
+  if ( r_size(op - 2) != 6 )
+    return_error(gs_error_rangecheck);
+  check_type(op[-1], t_string);		/* ImageString */
+  check_type(op[0], t_string);		/* FileName */
+
+/*
+  font_name = (char *)malloc(r_size(op) + 2);
+*/
+  font_name = gs_malloc(imemory, r_size(op) + 2, 1, "zkfwin32BM");
+  if (font_name == NULL)
+    return gs_error_VMerror;
+
+  memcpy(font_name, op->value.bytes, r_size(op));
+  font_name[r_size(op)] = 0;
+
+  jis_code = op[-4].value.intval;
+  wmode = op[-3].value.intval;
+
+  bitmap = op[-1].value.bytes;
+  length = r_size(op - 1);
+
+  if((code = WINapiimage(i_ctx_p, font_name, jis_code, &width, &height,
+			 bitmap, length, &mat, &w0x, &w0y)) < 0) {
+    pop(5);
+    return_error(code);
+  }
+
+  if((code = gs_imagebbox(width, height, 1, &mat, bitmap, &bbox)) < 0)
+    return_error(code);
+
+  if(wmode && kf_is_vchar(jis_code)) {
+    kf_vmatrix(jis_code, (double)500,
+	       (double)400, &bbox, &vmat);
+    gs_matrix_invert(&vmat, &imat);
+    gs_matrix_multiply(&imat, &mat, &mat);
+  }
+
+  mat.ty = (int)((mat.ty > 0)? (mat.ty + 0.5) : (mat.ty - 0.5));
+  mat.tx = (int)((mat.tx > 0)? (mat.tx + 0.5) : (mat.tx - 0.5));
+
+  /* Push results */
+  /* w0x w0y llx lly urx ury width height bool matrix bitmap */
+  push(6);
+  op[-1] = op[-8];	/* matrix */
+  make_real(op - 10, w0x);
+  make_real(op - 9, w0y);
+  make_real(op - 8, bbox.p.x);
+  make_real(op - 7, bbox.p.y);
+  make_real(op - 6, bbox.q.x);
+  make_real(op - 5, bbox.q.y);
+  make_int(op - 4, width);
+  make_int(op - 3, height);
+  make_bool(op - 2 , 1);
+  write_matrix(op - 1, &mat);
+  make_tasv(op , t_string, a_all, length, bytes, bitmap);
+
+/*
+  free(font_name);
+*/
+  gs_free(imemory, font_name, r_size(op) + 2, 1, "zkfwin32BM");
+
+  return 0;
+}
+
+/* -------- Initialization procedure -------- */
+
+const op_def zkfwin32_op_defs[] = {
+  {"3kfwin32", zkfwin32},
+  {"4kfwin32BM", zkfwin32BM},
+  op_def_end(0)
+};
diff -Nur ghostscript-9.53.3-orig/kanji/allkanji.ps ghostscript-9.53.3/kanji/allkanji.ps
--- ghostscript-9.53.3-orig/kanji/allkanji.ps	Thu Jan 01 09:00:00 1970
+++ ghostscript-9.53.3/kanji/allkanji.ps	Sun Jul 18 22:15:38 1999
@@ -0,0 +1,102 @@
+%!PS-Adobe-2.0
+%
+% Listing up all the kanji characters
+
+% Akira Tanaka <akr@jaist.ac.jp> modified for gs5.10-vflib-1.3. 1998/05/12
+
+/LEFT   110 def
+/TOP    750 def
+/BOTTOM  50 def
+/SIZE    28 def
+
+/FONT_NAME /Ryumin-Light-H def
+/FONT_WIDTH  1000 def
+/FONT_DESCENT 120 def
+/FONT_ASCENT  880 def
+/FONT_HEIGHT FONT_ASCENT FONT_DESCENT add def
+
+% Initialize
+
+/FONT_WIDTH FONT_WIDTH 1000 div SIZE mul def
+/FONT_DESCENT FONT_DESCENT 1000 div SIZE mul def
+/FONT_ASCENT FONT_ASCENT 1000 div SIZE mul def
+/FONT_HEIGHT FONT_HEIGHT 1000 div SIZE mul def
+
+/NUM_FONT /Courier findfont SIZE scalefont def
+/NUM_WIDTH gsave NUM_FONT setfont (0) stringwidth pop def grestore
+/LINES TOP BOTTOM sub FONT_HEIGHT div cvi def
+/STR2 2 string def
+
+/NEWLINE {
+	/ROW_CODE CODE 16 idiv 16 mul def
+	/LINE LINE 1 add def
+	LINE LINES eq { NEWPAGE } if
+	/BASE_LINE TOP LINE FONT_HEIGHT mul sub FONT_ASCENT sub def
+
+	% Draw Lines and Numbers
+
+	gsave
+	NUM_FONT setfont
+
+	LEFT NUM_WIDTH 5 mul sub BASE_LINE moveto
+	ROW_CODE 16 4 string cvrs show
+
+	LEFT TOP LINE FONT_HEIGHT mul sub moveto
+	0 FONT_HEIGHT neg rlineto FONT_WIDTH 16 mul 0 rlineto 
+	0 FONT_HEIGHT rlineto 
+	closepath stroke
+
+	0 1 15 {
+		/COLUMN exch def
+
+		LEFT FONT_WIDTH COLUMN 1 add mul add
+		TOP LINE FONT_HEIGHT mul sub 
+		moveto
+		0 FONT_HEIGHT neg rlineto
+		stroke
+
+		LINE 0 eq {
+			LEFT COLUMN FONT_WIDTH mul add
+			FONT_WIDTH NUM_WIDTH sub 2 div add
+			TOP FONT_DESCENT add
+			moveto
+			COLUMN 16 1 string cvrs
+			show
+		} if
+	} for
+
+	grestore
+} def
+
+/NEWPAGE { showpage /LINE 0 def } def	
+
+%
+% List up Characters
+%
+
+FONT_NAME findfont SIZE scalefont setfont
+/LINE -1 def
+/ROW_CODE 0 def
+
+[[16#2121 16#227E]
+ [16#2330 16#2658]
+ [16#2721 16#2771]
+ [16#2821 16#2841]
+ [16#3021 16#4F53]
+ [16#5021 16#7426]]
+{
+	dup 0 get /FROM exch def 1 get /TO exch def
+	FROM 1 TO {
+		/CODE exch def
+
+		CODE 256 mod dup 16#21 ge exch 16#7E le and {
+			CODE 16 idiv 16 mul ROW_CODE ne { NEWLINE } if
+
+			LEFT CODE 16 mod FONT_WIDTH mul add BASE_LINE moveto
+			STR2 0 CODE 256 idiv put
+			STR2 1 CODE 256 mod put
+			STR2 show
+		} if
+	} for
+} forall
+showpage
diff -Nur ghostscript-9.53.3-orig/kanji/article9.ps ghostscript-9.53.3/kanji/article9.ps
--- ghostscript-9.53.3-orig/kanji/article9.ps	Thu Jan 01 09:00:00 1970
+++ ghostscript-9.53.3/kanji/article9.ps	Sun Jul 18 22:15:38 1999
@@ -0,0 +1,97 @@
+%!PS-Adobe-2.0
+%
+% Article 9 of the Constitution of Japan 
+% written in vertical direction using ...
+%	Fonts:
+%		Ryumin-Light-V, GothicBBB-Medium-V
+%	Operators for characters:
+%		show, widthshow, ashow, stringwidth, charpath, cshow
+
+% constants
+
+/RIGHT	550 def
+/WIDTH	500 def
+/TOP	750 def
+/HEIGHT	700 def
+/SIZE	 24 def
+/MARGIN	 40 def
+
+% utility operators
+
+/GOTHIC { /GothicBBB-Medium-V findfont exch dup
+	  /FONTSIZE exch def scalefont setfont } def
+/RYUMIN { /Ryumin-Light-V findfont exch dup
+	  /FONTSIZE exch def scalefont setfont } def
+/NEXTLINE { currentpoint pop FONTSIZE 1.8 mul sub TOP MARGIN sub moveto } def
+
+/MARU { dup gsave false charpath flattenpath pathbbox grestore
+	/ury exch def /urx exch def /lly exch def /llx exch def
+	gsave llx urx add 2 div lly ury add 2 div translate 
+	urx llx sub ury lly sub 2 copy gt { pop }{ exch pop }ifelse 
+	1.2 mul dup scale 0 setlinewidth
+	0.5 0 moveto 0 0 0.5 0 360 arc stroke grestore show } def
+/STRLEN { 0 exch { pop pop pop 1 add } exch cshow } def
+/JUSTIFY { dup STRLEN 1 sub 1 index stringwidth exch pop 
+	   currentpoint exch pop add TOP HEIGHT MARGIN sub sub sub
+	   exch div neg 0 exch 3 -1 roll ashow } def
+
+% initialize
+
+RIGHT TOP moveto 0 HEIGHT neg rlineto WIDTH neg 0 rlineto 0 HEIGHT rlineto
+closepath stroke
+
+RIGHT MARGIN sub TOP MARGIN sub moveto
+
+% title
+
+SIZE 2 mul GOTHIC
+<2121467C4B5C3971377B4B21> show
+NEXTLINE
+
+% chapter
+
+SIZE 1.5 mul GOTHIC
+<21212121426846733E4F2121> show
+
+SIZE 1.5 mul RYUMIN
+<406F4168244E4A7C347E> show
+NEXTLINE
+
+% abstract
+
+SIZE GOTHIC
+0 SIZE 2 div 16#2122 <2121214C406F4168244E4A7C347E2122406F4E4F244E49544A5D3B7D
+21223872406F3822244E485D4727214D> widthshow
+NEXTLINE
+
+% sentence
+
+SIZE GOTHIC
+<426836653E72> show
+SIZE RYUMIN
+<2331> MARU
+<2121467C4B5C39714C31244F212240353541244843613D7824723470443424482439246B39713A
+5D> JUSTIFY
+NEXTLINE
+
+<4A3F4F422472403F3C42244B347535612437212239713822244E482F4630243F246B406F416824
+48212249704E4F244B2468246B> JUSTIFY
+NEXTLINE
+
+<305233454B74244F49704E4F244E39543B48244F212239713A5D4A364168247232723768243924
+6B3C6A434A244824372446> JUSTIFY
+NEXTLINE
+
+<244F2122314A3557244B2433246C24724A7C347E2439246B2123> show
+NEXTLINE
+
+<2332> MARU
+<212141303960244E4C5C452A247243232439246B243F246121224E26332436753733243D244E42
+3E244E406F4E4F> JUSTIFY
+NEXTLINE
+
+<244F21222433246C24724A5D3B7D2437244A242421233971244E3872406F3822244F2122243324
+6C247247272461244A24242123> show
+NEXTLINE
+
+showpage
diff -Nur ghostscript-9.53.3-orig/kanji/fmaptype.ps ghostscript-9.53.3/kanji/fmaptype.ps
--- ghostscript-9.53.3-orig/kanji/fmaptype.ps	Thu Jan 01 09:00:00 1970
+++ ghostscript-9.53.3/kanji/fmaptype.ps	Sun Jul 18 22:15:38 1999
@@ -0,0 +1,245 @@
+%!PS-Adobe-2.0
+%
+% Sample program of various FMapTypes
+
+/LEFT  50  def
+/TOP  700 def
+/SIZE  24 def
+
+%
+% Initialize
+%
+
+/NEWLINE { currentpoint exch pop SIZE 4 mul sub LEFT exch moveto } def
+/STRIPE {
+	gsave
+	true charpath gsave pathbbox grestore clip newpath
+	/ury exch def /urx exch def /lly exch def /llx exch def
+	/height ury lly sub def
+	llx height 15 div urx height add {
+		ury moveto
+		height neg height neg rlineto
+	} for
+	stroke
+	grestore
+} def
+/UNDERLINE {
+	dup gsave 
+	0 SIZE 3 div neg rmoveto stringwidth rlineto 
+	0.5 setgray SIZE 10 div setlinewidth stroke 
+	grestore show
+} def
+
+/ALPH /Courier findfont def
+
+/Ryumin-Light-H findfont 
+dup /FDepVector get /FDepVector exch def
+/Encoding get /Encoding exch def
+/KIGO FDepVector Encoding 16#21 get get def
+/HIRA FDepVector Encoding 16#24 get get def
+/KATA FDepVector Encoding 16#25 get get def
+
+/Ryumin-Light-EUC-H findfont
+dup /FDepVector get /FDepVector exch def
+/Encoding get /Encoding exch def
+/HIRA-EUC FDepVector Encoding 16#A4 get get def
+/KATA-EUC FDepVector Encoding 16#A5 get get def
+
+LEFT TOP moveto
+
+save
+
+/GothicBBB-Medium-H findfont SIZE 2 mul scalefont setfont
+<25552529257325482126255E2543255425732530> STRIPE
+
+restore
+NEWLINE
+
+%
+% FMapType2: 8/8 Mapping
+%
+
+save
+
+/FMapType2 11 dict begin
+/FontType 0 def
+/FontMatrix matrix def
+/FMapType 2 def
+/Encoding [ 0 1 2 3 ] def
+/FDepVector [
+	KIGO
+	ALPH
+	HIRA
+	KATA
+] def
+currentdict end
+definefont pop
+
+/FMapType2 findfont SIZE scalefont setfont
+<01 46 01 4D 01 61 01 70 01 54 01 79 01 70 01 65 01 32 02 4F 00 22 
+ 01 38 00 3F 01 38 03 5E 03 43 03 54 03 73 03 30 02 47 02 39 00 23> 
+UNDERLINE
+
+restore
+NEWLINE
+
+%
+% FMapType3: Escape Mapping
+%
+
+save
+
+/FMapType3-Child-1 11 dict begin
+/FontType 0 def
+/FontMatrix matrix def
+/FMapType 3 def
+/Encoding [ 0 1 ] def
+/FDepVector [
+	KIGO
+	ALPH
+] def
+currentdict end
+definefont pop
+
+/FMapType3-Child-2 11 dict begin
+/FontType 0 def
+/FontMatrix matrix def
+/FMapType 3 def
+/Encoding [ 0 1 ] def
+/FDepVector [
+	HIRA
+	KATA
+] def
+currentdict end
+definefont pop
+
+/FMapType3-Parent 11 dict begin
+/FontType 0 def
+/FontMatrix matrix def
+/FMapType 3 def
+/Encoding [ 0 1 ] def
+/FDepVector [
+	/FMapType3-Child-1 findfont
+	/FMapType3-Child-2 findfont
+] def
+currentdict end
+definefont pop
+
+/FMapType3-Parent findfont SIZE scalefont setfont
+<FF 00 FF 01 46 4D 61 70 54 79 70 65 33 FF FF 01 4F FF FF 00 22 
+ FF 01 45 73 63 61 70 65 FF FF 01 FF 00 FF 01 5E 43 54 73 30 FF 00 47 39 
+ FF FF 00 FF 00 23> 
+UNDERLINE
+
+restore
+NEWLINE
+
+%
+% FMapType4: 1/7 Mapping
+%
+
+save
+
+/FMapType4-Child-1 11 dict begin
+/FontType 0 def
+/FontMatrix matrix def
+/FMapType 2 def
+/Encoding [ 0 1 ] def
+/FDepVector [
+	KIGO
+	ALPH
+] def
+currentdict end
+definefont pop
+
+/FMapType4-Child-2 11 dict begin
+/FontType 0 def
+/FontMatrix matrix def
+/FMapType 2 def
+/Encoding [ 0 1 ] def
+/FDepVector [
+	HIRA-EUC
+	KATA-EUC
+] def
+currentdict end
+definefont pop
+
+/FMapType4-Parent 11 dict begin
+/FontType 0 def
+/FontMatrix matrix def
+/FMapType 4 def
+/Encoding [ 0 1 ] def
+/FDepVector [
+	/FMapType4-Child-1 findfont
+	/FMapType4-Child-2 findfont
+] def
+currentdict end
+definefont pop
+
+/FMapType4-Parent findfont SIZE scalefont setfont
+<01 46 01 4D 01 61 01 70 01 54 01 79 01 70 01 65 01 34 80 CF 00 22 
+ 01 31 00 3F 01 37 81 DE 81 C3 81 D4 81 F3 81 B0 80 C7 80 B9 00 23>
+UNDERLINE
+
+restore
+NEWLINE
+
+%
+% FMapType5: 9/7 Mapping
+%
+
+save
+
+/FMapType5 11 dict begin
+/FontType 0 def
+/FontMatrix matrix def
+/FMapType 5 def
+/Encoding [ 0 1 2 3 ] def
+/FDepVector [
+	KIGO
+	ALPH
+	HIRA
+	KATA
+] def
+currentdict end
+definefont pop
+
+/FMapType5 findfont SIZE scalefont setfont
+<00 C6 00 CD 00 E1 00 F0 00 D4 00 F9 00 F0 00 E5 00 B5 01 4F 00 22 
+ 00 B9 00 3F 00 B7 01 DE 01 C3 01 D4 01 F3 01 B0 01 47 01 39 00 23>
+UNDERLINE
+
+restore
+NEWLINE
+
+%
+% FMapType6: SubsVector Mapping
+%
+
+save
+
+/FMapType6 11 dict begin
+/FontType 0 def
+/FontMatrix matrix def
+/FMapType 6 def
+/Encoding [ 0 1 2 3 ] def
+/SubsVector <01 0100 0080 0080> def
+/FDepVector [
+	ALPH
+	KIGO
+	HIRA
+	KATA
+] def
+currentdict end
+definefont pop
+
+/FMapType6 findfont SIZE scalefont setfont
+<00 46 00 4D 00 61 00 70 00 54 00 79 00 70 00 65 00 36 01 CF 01 22
+ 00 53 00 75 00 62 00 73 00 56 00 65 00 63 00 74 00 6F 00 72
+ 02 5E 02 43 02 54 02 73 02 30 01 C7 01 B9 01 23>
+UNDERLINE
+
+restore
+NEWLINE
+
+showpage
diff -Nur ghostscript-9.53.3-orig/kanji/hankaku.ps ghostscript-9.53.3/kanji/hankaku.ps
--- ghostscript-9.53.3-orig/kanji/hankaku.ps	Thu Jan 01 09:00:00 1970
+++ ghostscript-9.53.3/kanji/hankaku.ps	Sun Jul 18 22:15:38 1999
@@ -0,0 +1,93 @@
+%!PS-Adobe-2.0
+%
+% Listing up Hankaku characters
+
+% Akira Tanaka <akr@jaist.ac.jp> modified for gs4.03/VFlib support. 1996/10/17
+% Akira Tanaka <akr@jaist.ac.jp> modified for gs5.0/VFlib support. 1997/6/9
+
+/SHOW_BYTE_CHARS
+{
+	/LEFT   150 def
+	/TOP    675 def
+	/SIZE    40 def
+
+	/FONT_WIDTH  500 def
+	/FONT_DESCENT 120 def
+	/FONT_ASCENT  880 def
+	/FONT_HEIGHT FONT_ASCENT FONT_DESCENT add def
+
+	% Initialize
+
+	dup findfont SIZE scalefont /FONT exch def
+	32 string cvs /FONT_NAME exch def
+
+	/FONT_WIDTH FONT_WIDTH 1000 div SIZE mul def
+	/FONT_DESCENT FONT_DESCENT 1000 div SIZE mul def
+	/FONT_ASCENT FONT_ASCENT 1000 div SIZE mul def
+	/FONT_HEIGHT FONT_HEIGHT 1000 div SIZE mul def
+
+	/DIGIT_FONT /Courier findfont SIZE 0.8 mul scalefont def
+	/DIGIT_WIDTH gsave DIGIT_FONT setfont (0) stringwidth pop def grestore
+	/DIGIT_OFFSET FONT_WIDTH DIGIT_WIDTH sub 2 div def
+	/STR1 1 string def
+
+	% draw title
+
+	/Times-Roman findfont SIZE scalefont setfont
+	FONT_WIDTH 16 mul FONT_NAME stringwidth pop sub 2 div LEFT add
+	TOP SIZE 1.5 mul add moveto FONT_NAME show
+
+	% draw glid
+
+	0 1 16 {
+		dup FONT_WIDTH mul LEFT add TOP moveto 
+		0 FONT_HEIGHT 16 mul neg rlineto
+		dup FONT_HEIGHT mul TOP exch sub LEFT exch moveto
+		FONT_WIDTH 16 mul 0 rlineto
+		pop
+	} for
+	stroke
+
+	% show character codes
+
+	DIGIT_FONT setfont
+	0 1 15 {
+		dup 16 STR1 cvrs pop
+		dup FONT_WIDTH mul LEFT add DIGIT_OFFSET add 
+		TOP FONT_DESCENT add moveto STR1 show
+		dup FONT_HEIGHT mul TOP exch sub FONT_ASCENT sub
+		LEFT FONT_WIDTH 2 mul sub exch moveto STR1 show (0) show
+		pop
+	} for
+
+	% show characters
+
+	FONT setfont
+	0 1 15 {
+		/ROW exch def
+		0 1 15 {
+			/COLUMN exch def
+			STR1 0 ROW 16 mul COLUMN add put
+			LEFT COLUMN FONT_WIDTH mul add
+			TOP ROW FONT_HEIGHT mul sub FONT_ASCENT sub moveto
+			{ STR1 show } stopped {
+				.clearerror
+				0 FONT_ASCENT rmoveto
+				FONT_WIDTH FONT_HEIGHT neg rlineto 
+				FONT_WIDTH neg 0 rmoveto
+				FONT_WIDTH FONT_HEIGHT rlineto stroke
+			} if
+		} for
+	} for
+	showpage
+} def
+
+[ /Ryumin-Light.Roman
+  /Ryumin-Light.Hankaku
+  /Ryumin-Light.Hiragana
+  /Ryumin-Light.Katakana
+  /Ryumin-Light-RKSJ-H ]
+{
+	SHOW_BYTE_CHARS
+} forall
+
diff -Nur ghostscript-9.53.3-orig/kanji/kbase.ps ghostscript-9.53.3/kanji/kbase.ps
--- ghostscript-9.53.3-orig/kanji/kbase.ps	Thu Jan 01 09:00:00 1970
+++ ghostscript-9.53.3/kanji/kbase.ps	Sun Jul 18 22:15:38 1999
@@ -0,0 +1,302 @@
+%
+% kbase.ps  -  define /basekanji operator
+%
+% Apr.10,1992 Programmed by N.Katayama
+%
+
+%
+% font_name unique_id font_info private build_char BASEKANJI unique_id
+%
+
+/basekanji {
+
+	9 dict begin		% fontname, uniqueid, fontinfo, private,
+				% BEGIN, END, buildchar, prototype and rowcode
+
+	/buildchar exch def
+	/private exch def
+	/fontinfo exch def
+	/uniqueid exch def
+	/fontname exch def
+
+	/BEGIN {
+		prototype dup maxlength dict copy begin
+		/UniqueID uniqueid def
+	} def
+	/END { 
+		currentdict end
+		dup /FontName get exch definefont pop
+		/uniqueid uniqueid 1 add def
+	} def
+
+	%
+	% Define prototype
+	%
+
+	12 dict begin
+%	/FontName
+	/FontInfo fontinfo readonly def
+	/PaintType 0 def
+	/FontType 3 def
+	/FontMatrix [ 0.001 0 0 0.001 0 0 ] readonly def
+	/FontBBox { 0 -120 1000 880 } readonly def
+%	/Encoding
+%	/UniqueID
+%	/WMode
+%	/Private
+	/BuildChar /buildchar load def
+	currentdict end
+	/prototype exch def
+
+	%
+	% JIS 
+	%
+
+	16#21 1 16#7E {
+		/rowcode exch def
+		BEGIN
+		/FontName fontname (.r) rowcode () basefontname def
+		/Encoding JISSubEncoding def
+		/WMode 0 def
+		/Private private dup maxlength 3 add dict copy begin
+		/MappingOffset rowcode 256 mul def
+		/MappingDict JISMappingDict def
+		/MappingProc /StandardMapping load def
+		currentdict end readonly def
+		END
+	} for
+		
+	[ 16#21 16#22 16#24 16#25 ] {
+		/rowcode exch def
+		BEGIN
+		/FontName fontname (.r) rowcode (v) basefontname def
+		/Encoding JISSubEncoding def
+		/WMode 1 def
+		/Private private dup maxlength 3 add dict copy begin
+		/MappingOffset rowcode 256 mul def
+		/MappingDict JISMappingDict def
+		/MappingProc /StandardMapping load def
+		currentdict end readonly def
+		END
+	} forall
+
+	%
+	% Shift-JIS kanji base font
+	%
+
+       	16#81 1 16#9F {
+		/rowcode exch def
+		BEGIN
+		/FontName fontname (.sr) rowcode () basefontname def
+		/Encoding SJSubEncoding def
+		/WMode 0 def
+		/Private private dup maxlength 3 add dict copy begin
+		/MappingOffset rowcode 16#81 sub 16#200 mul 16#2100 add def
+		/MappingDict SJMappingDict def
+		/MappingProc /StandardMapping load def
+		currentdict end readonly def
+		END
+	} for
+
+       	16#E0 1 16#EA {
+		/rowcode exch def
+		BEGIN
+		/FontName fontname (.sr) rowcode () basefontname def
+		/Encoding SJSubEncoding def
+		/WMode 0 def
+		/Private private dup maxlength 3 add dict copy begin
+		/MappingOffset rowcode 16#E0 sub 16#200 mul 16#5F00 add def
+		/MappingDict SJMappingDict def
+		/MappingProc /StandardMapping load def
+		currentdict end readonly def
+		END
+	} for
+
+	16#81 1 16#83 {
+		/rowcode exch def
+		BEGIN
+		/FontName fontname (.sr) rowcode (v) basefontname def
+		/Encoding SJSubEncoding def
+		/WMode 1 def
+		/Private private dup maxlength 3 add dict copy begin
+		/MappingOffset rowcode 16#81 sub 16#200 mul 16#2100 add def
+		/MappingDict SJMappingDict def
+		/MappingProc /StandardMapping load def
+		currentdict end readonly def
+		END
+	} for
+
+	%
+	% 90pv-RKSJ kanji base font
+	%
+
+	[ 16#85 16#86 16#87 16#88 ] {
+		/rowcode exch def
+		BEGIN
+		/FontName fontname (.90pv-sr) rowcode () basefontname def
+		/Encoding SJSubEncoding def
+		/WMode 0 def
+		/Private private dup maxlength 3 add dict copy begin
+		/MappingOffset rowcode 16#81 sub 16#200 mul 16#2100 add def
+		/MappingDict SJMappingDict def
+		/MappingProc /StandardMapping load def
+		currentdict end readonly def
+		END
+	} forall
+
+	[ 16#EB 16#EC 16#ED ] {
+		/rowcode exch def
+		BEGIN
+		/FontName fontname (.90pv-sr) rowcode () basefontname def
+		/Encoding SJSubEncoding def
+		/WMode 0 def
+		/Private private dup maxlength 3 add dict copy begin
+		/MappingOffset rowcode 16#E0 sub 16#200 mul 16#5F00 add def
+		/MappingDict SJMappingDict def
+		/MappingProc /StandardMapping load def
+		currentdict end readonly def
+		END
+	} forall
+
+	[ 16#87 ] {
+		/rowcode exch def
+		BEGIN
+		/FontName fontname (.90pv-sr) rowcode (v) basefontname def
+		/Encoding SJSubEncoding def
+		/WMode 1 def
+		/Private private dup maxlength 3 add dict copy begin
+		/MappingOffset rowcode 16#81 sub 16#200 mul 16#2100 add def
+		/MappingDict SJMappingDict def
+		/MappingProc /StandardMapping load def
+		currentdict end readonly def
+		END
+	} forall
+
+	%
+	% 90ms-RKSJ kanji base font
+	%
+
+	[ 16#87 ] {
+		/rowcode exch def
+		BEGIN
+		/FontName fontname (.90ms-sr) rowcode () basefontname def
+		/Encoding SJSubEncoding def
+		/WMode 0 def
+		/Private private dup maxlength 3 add dict copy begin
+		/MappingOffset rowcode 16#81 sub 16#200 mul 16#2100 add def
+		/MappingDict SJMappingDict def
+		/MappingProc /StandardMapping load def
+		currentdict end readonly def
+		END
+	} forall
+
+	[ 16#ED 16#EE 16#FA 16#FB 16#FC ] {
+		/rowcode exch def
+		BEGIN
+		/FontName fontname (.90ms-sr) rowcode () basefontname def
+		/Encoding SJSubEncoding def
+		/WMode 0 def
+		/Private private dup maxlength 3 add dict copy begin
+		/MappingOffset rowcode 16#E0 sub 16#200 mul 16#5F00 add def
+		/MappingDict SJMappingDict def
+		/MappingProc /StandardMapping load def
+		currentdict end readonly def
+		END
+	} forall
+
+	[ 16#87 ] {
+		/rowcode exch def
+		BEGIN
+		/FontName fontname (.90ms-sr) rowcode (v) basefontname def
+		/Encoding SJSubEncoding def
+		/WMode 1 def
+		/Private private dup maxlength 3 add dict copy begin
+		/MappingOffset rowcode 16#81 sub 16#200 mul 16#2100 add def
+		/MappingDict SJMappingDict def
+		/MappingProc /StandardMapping load def
+		currentdict end readonly def
+		END
+	} forall
+
+	%
+	% Roman
+	%
+
+	BEGIN
+	/FontName fontname (.Roman) composename def
+	/FontMatrix [ 0.0005 0 0 0.001 0 0 ] readonly def
+	/Encoding RomanEncoding def
+	/WMode 0 def
+	/Private private dup maxlength 3 add dict copy begin
+	/MappingOffset 0 def
+	/MappingDict CNameMappingDict def
+	/MappingProc /StandardMapping load def
+	currentdict end readonly def
+	END
+
+	%
+	% Hiragana 
+	%
+
+	BEGIN
+	/FontName fontname (.Hiragana) composename def
+	/FontMatrix [ 0.0005 0 0 0.001 0 0 ] readonly def
+	/Encoding HiraganaEncoding def
+	/WMode 0 def
+	/Private private dup maxlength 3 add dict copy begin
+	/MappingOffset 0 def
+	/MappingDict CNameMappingDict def
+	/MappingProc /StandardMapping load def
+	currentdict end readonly def
+	END
+
+	%
+	% Katakana
+	%
+
+	BEGIN
+	/FontName fontname (.Katakana) composename def
+	/FontMatrix [ 0.0005 0 0 0.001 0 0 ] readonly def
+	/Encoding KatakanaEncoding def
+	/WMode 0 def
+	/Private private dup maxlength 3 add dict copy begin
+	/MappingOffset 0 def
+	/MappingDict CNameMappingDict def
+	/MappingProc /StandardMapping load def
+	currentdict end readonly def
+	END
+
+	%
+	% Hankaku
+	%
+
+	BEGIN
+	/FontName fontname (.Hankaku) composename def
+	/FontMatrix [ 0.0005 0 0 0.001 0 0 ] readonly def
+	/Encoding HankakuEncoding def
+	/WMode 0 def
+	/Private private dup maxlength 3 add dict copy begin
+	/MappingOffset 0 def
+	/MappingDict CNameMappingDict def
+	/MappingProc /StandardMapping load def
+	currentdict end readonly def
+	END
+
+	%
+	% SuppK
+	%
+
+	BEGIN
+	/FontName fontname (.SuppK) composename def
+	/FontMatrix [ 0.0005 0 0 0.001 0 0 ] readonly def
+	/Encoding RKSuppKEncoding def
+	/WMode 0 def
+	/Private private dup maxlength 3 add dict copy begin
+	/MappingOffset 0 def
+	/MappingDict CNameMappingDict def
+	/MappingProc /StandardMapping load def
+	currentdict end readonly def
+	END
+
+	uniqueid end
+} bind def
diff -Nur ghostscript-9.53.3-orig/kanji/kbitmap.ps ghostscript-9.53.3/kanji/kbitmap.ps
--- ghostscript-9.53.3-orig/kanji/kbitmap.ps	Thu Jan 01 09:00:00 1970
+++ ghostscript-9.53.3/kanji/kbitmap.ps	Sun Apr 30 10:55:02 2006
@@ -0,0 +1,62 @@
+%
+% kbitmap.ps  -  define /bitmapkanji operator
+%
+% Apr. 6,1992 Programmed by N.Katayama
+%
+
+%
+% font_name unique_id font_info image_proc BITMAPKANJI unique_id
+%
+
+/bitmapkanji {
+	8 dict begin	% fontname, uniqueid, fontinfo, imageproc
+			% imagematrix, imagestring, private and buildchar
+
+	/imageproc exch def
+	/fontinfo exch def
+	/uniqueid exch def
+	/fontname exch def
+	/imagematrix matrix def
+%	/imagestring 8000 string noaccess def
+	/imagestring 10000 string noaccess def
+
+	% Private dictionary
+
+	/private 3 dict begin 
+	/ImageMatrix imagematrix def
+	/ImageString imagestring def
+	/ImageProc /imageproc load def
+	currentdict end def
+
+	% Define BuildChar procedure
+
+	/buildchar {		
+		exch begin
+		Encoding exch get dup Private /MappingProc get exec
+		currentfont /WMode 2 copy known { get }{ pop pop 0 } ifelse
+
+		Private begin ImageMatrix ImageString ImageProc end 
+
+		11 5 roll 0 -1000 500 880 16 -1 roll setmetrics2
+		3 -1 roll pop false 3 1 roll imagepath
+
+		PaintType 0 eq 
+		{ eofill }{
+			currentdict /StrokeWidth known
+			{StrokeWidth}{0} ifelse
+			setlinewidth stroke
+		} ifelse
+		end
+	} bind def
+
+	% Define base fonts
+
+	fontname uniqueid fontinfo private /buildchar load basekanji
+	/uniqueid exch def
+
+	% Define composite fonts
+
+	fontname fontinfo compositekanji
+
+	uniqueid end
+} def
diff -Nur ghostscript-9.53.3-orig/kanji/kcomp.ps ghostscript-9.53.3/kanji/kcomp.ps
--- ghostscript-9.53.3-orig/kanji/kcomp.ps	Thu Jan 01 09:00:00 1970
+++ ghostscript-9.53.3/kanji/kcomp.ps	Sun Aug 11 14:45:00 2013
@@ -0,0 +1,628 @@
+%
+% kcomp.ps  -  define /compositekanji operator
+%
+% Apr.10,1992 Programmed by N.Katayama
+%
+% Akira Tanaka <akr@jaist.ac.jp> modified for gs5.10/VFlib support. 1996/11/26
+
+%
+% font_name font_info COMPOSITEKANJI -
+%
+%% --------------------------------------------------------------------
+%%		2 dict begin
+%%			/Ryumin-Light		/Times-Roman	def
+%%			/GothicBBB-Medium	/Helvetica	def
+%%		currentdict
+%%		end
+%%
+%% sometimes causes a crash. Therefore I write as follows as a workarround,
+%% though I don't understand anything about the issue (2013/08/11 --ak).
+%%
+%%		2 dict begin
+%%			/RRyumin-Light		/Times-Roman	def
+%%			/GGothicBBB-Medium	/Helvetica	def
+%%		currentdict
+%%		end
+%% --------------------------------------------------------------------
+%%
+/compositekanji {
+
+	6 dict begin	% fontname, fontinfo,
+			% BEGIN, END, basefont and prototype
+
+	/fontinfo exch def
+	/fontname exch def
+	
+	/BEGIN {
+		prototype dup maxlength 3 -1 roll add dict copy begin
+	} def
+	/END {
+		currentdict end dup /FontName get exch definefont pop
+	} def
+	/basefont {
+		fontname 3 -1 roll 4 2 roll basefontname findfont
+	} def
+
+	%
+	% Define prototype
+	%
+
+	12 dict begin
+	/FontInfo fontinfo def
+	/PaintType 0 def
+	/FontType 0 def
+	/FontMatrix [ 1 0 0 1 0 0 ] readonly def
+	/FontBBox { 0 -120 1000 880 } readonly def
+%	/FontName
+%	/Encoding
+%	/FMapType
+%	/WMode
+%	/FDepVector
+	currentdict end /prototype exch def
+
+	% Define Composite Kanji Fonts
+
+	% JIS
+
+	0 BEGIN
+	/FontName fontname (-H) composename def
+	/WMode 0 def
+	/FMapType 2 def
+	/Encoding JISEncoding def
+	/FDepVector [
+		/NotDefFont findfont
+		16#21 1 16#28 { (.r) () basefont } for
+		16#30 1 16#74 { (.r) () basefont } for
+	] readonly def
+	END
+
+	0 BEGIN
+	/FontName fontname (-V) composename def
+	/WMode 1 def
+	/FMapType 2 def
+	/Encoding JISEncoding def
+	/FDepVector [
+		/NotDefFont findfont
+		16#21 1 16#22 { (.r) (v) basefont } for
+		16#23 (.r) () basefont
+		16#24 1 16#25 { (.r) (v) basefont } for
+		16#26 1 16#28 { (.r) () basefont } for
+		16#30 1 16#74 { (.r) () basefont } for
+	] readonly def
+	END
+
+	%
+	% Ext
+	%
+
+	0 BEGIN
+	/FontName fontname (-Ext-H) composename def
+	/WMode 0 def
+	/FMapType 2 def
+	/Encoding ExtEncoding def
+	/FDepVector [
+		/NotDefFont findfont
+		16#21 1 16#27 { (.r) () basefont } for
+		16#29 1 16#2D { (.r) () basefont } for
+		16#30 1 16#73 { (.r) () basefont } for
+	] readonly def
+	END
+
+	0 BEGIN
+	/FontName fontname (-Ext-V) composename def
+	/WMode 1 def
+	/FMapType 2 def
+	/Encoding ExtEncoding def
+	/FDepVector [
+		/NotDefFont findfont
+		16#21 1 16#22 { (.r) (v) basefont } for
+		16#23 (.r) () basefont
+		16#24 1 16#25 { (.r) (v) basefont } for
+		16#26 1 16#27 { (.r) () basefont } for
+		16#29 1 16#2D { (.r) () basefont } for
+		16#30 1 16#73 { (.r) () basefont } for
+	] readonly def
+	END
+
+	%
+	% EUC
+	%
+
+	0 BEGIN
+	/FontName fontname (-EUC-H) composename def
+	/WMode 0 def
+	/FMapType 2 def
+	/Encoding EUCEncoding def
+	/FDepVector [
+		/NotDefFont findfont
+		16#21 1 16#28 { (.r) () basefont } for
+		16#30 1 16#74 { (.r) () basefont } for
+	] readonly def
+	END
+
+	0 BEGIN
+	/FontName fontname (-EUC-V) composename def
+	/WMode 1 def
+	/FMapType 2 def
+	/Encoding EUCEncoding def
+	/FDepVector [
+		/NotDefFont findfont
+		16#21 1 16#22 { (.r) (v) basefont } for
+		16#23 (.r) () basefont
+		16#24 1 16#25 { (.r) (v) basefont } for
+		16#26 1 16#28 { (.r) () basefont } for
+		16#30 1 16#74 { (.r) () basefont } for
+	] readonly def
+	END
+
+	%
+	% Shift-JIS-SuppA
+	%
+
+	0 BEGIN
+	/FontName fontname (-SJ-SuppA-H) composename def
+	/WMode 0 def
+	/FMapType 2 def
+	/Encoding SJSuppAEncoding def
+	/FDepVector [
+		/NotDefFont findfont
+		16#81 1 16#9F { (.sr) () basefont } for
+	] readonly def
+	END
+
+	0 BEGIN
+	/FontName fontname (-SJ-SuppA-V) composename def
+	/WMode 1 def
+	/FMapType 2 def
+	/Encoding SJSuppAEncoding def
+	/FDepVector [
+		/NotDefFont findfont
+		16#81 1 16#83 { (.sr) (v) basefont } for
+		16#84 1 16#9F { (.sr) () basefont } for
+	] readonly def
+	END
+
+	%
+	% Shift-JIS-SuppB
+	%
+
+	0 BEGIN
+	/FontName fontname (-SJ-SuppB-HV) composename def
+	/WMode 0 def
+	/FMapType 2 def
+	/Encoding SJSuppBEncoding def
+	/FDepVector [
+		/NotDefFont findfont
+		16#E0 1 16#EA { (.sr) () basefont } for
+	] readonly def
+	END
+
+	%
+	% RKSJ
+	%
+
+	1 BEGIN
+	/FontName fontname (-RKSJ-H) composename def
+	/WMode 0 def
+	/FMapType 6 def
+	/Encoding RKSJEncoding def
+	/SubsVector RKSJSubsVector def
+	/FDepVector [
+		fontname (.Roman) composename findfont
+		/NotDefFont findfont
+		fontname (-SJ-SuppA-H) composename findfont
+		fontname (.SuppK) composename findfont
+		fontname (-SJ-SuppB-HV) composename findfont
+		/NotDefFont findfont
+	] readonly def
+	END
+
+	1 BEGIN
+	/FontName fontname (-RKSJ-V) composename def
+	/WMode 1 def
+	/FMapType 6 def
+	/Encoding RKSJEncoding def
+	/SubsVector RKSJSubsVector def
+	/FDepVector [
+		fontname (.Roman) composename findfont
+		/NotDefFont findfont
+		fontname (-SJ-SuppA-V) composename findfont
+		fontname (.SuppK) composename findfont
+		fontname (-SJ-SuppB-HV) composename findfont
+		/NotDefFont findfont
+	] readonly def
+	END
+
+	%
+	% 83pv-Shift-JIS-SuppB
+	%
+
+	0 BEGIN
+	/FontName fontname (-83pv-SJ-SuppB-H) composename def
+	/WMode 0 def
+	/FMapType 2 def
+	/Encoding 83pvSJSuppBEncoding def
+	/FDepVector [
+		/NotDefFont findfont
+		16#E0 1 16#EA { (.sr) () basefont } for
+		16#81 1 16#83 { (.sr) (v) basefont } for
+		/NotDefFont findfont	% 16#87
+	] readonly def
+	END
+
+	0 BEGIN
+	/FontName fontname (-83pv-SJ-SuppB-V) composename def
+	/WMode 1 def
+	/FMapType 2 def
+	/Encoding 83pvSJSuppBEncoding def
+	/FDepVector [
+		/NotDefFont findfont
+		16#E0 1 16#EA { (.sr) () basefont } for
+		16#81 1 16#83 { (.sr) (v) basefont } for
+		/NotDefFont findfont	% 16#87
+	] readonly def
+	END
+
+	%
+	% 83pv-RKSJ
+	%
+
+	1 BEGIN
+	/FontName fontname (-83pv-RKSJ-H) composename def
+	/WMode 0 def
+	/FMapType 6 def
+	/Encoding RKSJEncoding def
+	/SubsVector RKSJSubsVector def
+	/FDepVector [
+		2 dict begin
+			/RRyumin-Light		/Times-Roman	def
+			/GGothicBBB-Medium	/Helvetica	def
+		currentdict
+		end
+		fontname 2 copy known {
+			get findfont
+		}{
+			pop pop	fontname (.Roman) composename findfont
+		} ifelse
+		/NotDefFont findfont
+		fontname (-SJ-SuppA-H) composename findfont
+		fontname (.SuppK) composename findfont
+		fontname (-83pv-SJ-SuppB-H) composename findfont
+		/NotDefFont findfont
+	] readonly def
+	END
+
+	1 BEGIN
+	/FontName fontname (-83pv-RKSJ-V) composename def
+	/WMode 1 def
+	/FMapType 6 def
+	/Encoding RKSJEncoding def
+	/SubsVector RKSJSubsVector def
+	/FDepVector [
+		2 dict begin
+			/RRyumin-Light		/Times-Roman	def
+			/GGothicBBB-Medium	/Helvetica	def
+		currentdict
+		end
+		fontname 2 copy known {
+			get findfont
+		}{
+			pop pop	fontname (.Roman) composename findfont
+		} ifelse
+		/NotDefFont findfont
+		fontname (-SJ-SuppA-V) composename findfont
+		fontname (.SuppK) composename findfont
+		fontname (-83pv-SJ-SuppB-V) composename findfont
+		/NotDefFont findfont
+	] readonly def
+	END
+
+	%
+	% 90pv-SJ-SuppA-H
+	%
+
+	0 BEGIN
+	/FontName fontname (-90pv-SJ-SuppA-H) composename def
+	/WMode 0 def
+	/FMapType 2 def
+	/Encoding SJSuppAEncoding def
+	/FDepVector [
+		/NotDefFont findfont
+		16#81 1 16#84 { (.sr) () basefont } for
+		16#85 1 16#88 { (.90pv-sr) () basefont } for
+		16#89 1 16#9F { (.sr) () basefont } for
+	] readonly def
+	END
+
+	%
+	% 90pv-SJ-SuppA-V
+	%
+
+	0 BEGIN
+	/FontName fontname (-90pv-SJ-SuppA-V) composename def
+	/WMode 1 def
+	/FMapType 2 def
+	/Encoding SJSuppAEncoding def
+	/FDepVector [
+		/NotDefFont findfont
+		16#81 1 16#83 { (.sr) (v) basefont } for
+		16#84 1 16#86 { (.sr) () basefont } for
+		16#87 1 16#87 { (.90pv-sr) (v) basefont } for
+		16#88 1 16#9F { (.sr) () basefont } for
+	] readonly def
+	END
+
+	%
+	% 90pv-SJ-SuppB-HV
+	%
+
+	0 BEGIN
+	/FontName fontname (-90pv-SJ-SuppB-HV) composename def
+	/WMode 0 def
+	/FMapType 2 def
+	/Encoding 90pvSJSuppBEncoding def
+	/FDepVector [
+		/NotDefFont findfont
+		16#E0 1 16#EA { (.sr) () basefont } for
+		16#EB 1 16#ED { (.90pv-sr) () basefont } for
+	] readonly def
+	END
+
+	%
+	% 90pv-RKSJ-H
+	%
+
+	1 BEGIN
+	/FontName fontname (-90pv-RKSJ-H) composename def
+	/WMode 0 def
+	/FMapType 6 def
+	/Encoding RKSJEncoding def
+	/SubsVector RKSJSubsVector def
+	/FDepVector [
+		2 dict begin
+			/RRyumin-Light		/Times-Roman	def
+			/GGothicBBB-Medium	/Helvetica	def
+		currentdict
+		end
+		fontname 2 copy known {
+			get findfont
+		}{
+			pop pop	fontname (.Roman) composename findfont
+		} ifelse
+		/NotDefFont findfont
+		fontname (-90pv-SJ-SuppA-H) composename findfont
+		fontname (.SuppK) composename findfont
+		fontname (-90pv-SJ-SuppB-HV) composename findfont
+		/NotDefFont findfont
+	] readonly def
+	END
+
+	%
+	% 90pv-RKSJ-V
+	%
+
+	1 BEGIN
+	/FontName fontname (-90pv-RKSJ-V) composename def
+	/WMode 1 def
+	/FMapType 6 def
+	/Encoding RKSJEncoding def
+	/SubsVector RKSJSubsVector def
+	/FDepVector [
+		2 dict begin
+			/RRyumin-Light		/Times-Roman	def
+			/GGothicBBB-Medium	/Helvetica	def
+		currentdict
+		end
+		fontname 2 copy known {
+			get findfont
+		}{
+			pop pop	fontname (.Roman) composename findfont
+		} ifelse
+		/NotDefFont findfont
+		fontname (-90pv-SJ-SuppA-V) composename findfont
+		fontname (.SuppK) composename findfont
+		fontname (-90pv-SJ-SuppB-HV) composename findfont
+		/NotDefFont findfont
+	] readonly def
+	END
+
+	%
+	% 90ms-SJ-SuppA-H
+	%
+
+	0 BEGIN
+	/FontName fontname (-90ms-SJ-SuppA-H) composename def
+	/WMode 0 def
+	/FMapType 2 def
+	/Encoding SJSuppAEncoding def
+	/FDepVector [
+		/NotDefFont findfont
+		16#81 1 16#86 { (.sr) () basefont } for
+		16#87 1 16#87 { (.90ms-sr) () basefont } for
+		16#88 1 16#9F { (.sr) () basefont } for
+	] readonly def
+	END
+
+	%
+	% 90ms-SJ-SuppA-V
+	%
+
+	0 BEGIN
+	/FontName fontname (-90ms-SJ-SuppA-V) composename def
+	/WMode 1 def
+	/FMapType 2 def
+	/Encoding SJSuppAEncoding def
+	/FDepVector [
+		/NotDefFont findfont
+		16#81 1 16#83 { (.sr) (v) basefont } for
+		16#84 1 16#86 { (.sr) () basefont } for
+		16#87 1 16#87 { (.90ms-sr) (v) basefont } for
+		16#88 1 16#9F { (.sr) () basefont } for
+	] readonly def
+	END
+
+	%
+	% 90ms-SJ-SuppB
+	%
+
+	0 BEGIN
+	/FontName fontname (-90ms-SJ-SuppB-HV) composename def
+	/WMode 0 def
+	/FMapType 2 def
+	/Encoding 90msSJSuppBEncoding def
+	/FDepVector [
+		/NotDefFont findfont
+		16#E0 1 16#EA { (.sr) () basefont } for
+		16#ED 1 16#EE { (.90ms-sr) () basefont } for
+		16#FA 1 16#FC { (.90ms-sr) () basefont } for
+	] readonly def
+	END
+
+	%
+	% 90ms-RKSJ-H
+	%
+
+	1 BEGIN
+	/FontName fontname (-90ms-RKSJ-H) composename def
+	/WMode 0 def
+	/FMapType 6 def
+	/Encoding 90msRKSJEncoding def
+	/SubsVector 90msRKSJSubsVector def
+	/FDepVector [
+		fontname (.Roman) composename findfont
+		/NotDefFont findfont
+		fontname (-90ms-SJ-SuppA-H) composename findfont
+		fontname (.SuppK) composename findfont
+		fontname (-90ms-SJ-SuppB-HV) composename findfont
+		/NotDefFont findfont
+	] readonly def
+	END
+
+	%
+	% 90ms-RKSJ-V
+	%
+
+	1 BEGIN
+	/FontName fontname (-90ms-RKSJ-V) composename def
+	/WMode 1 def
+	/FMapType 6 def
+	/Encoding 90msRKSJEncoding def
+	/SubsVector 90msRKSJSubsVector def
+	/FDepVector [
+		fontname (.Roman) composename findfont
+		/NotDefFont findfont
+		fontname (-90ms-SJ-SuppA-V) composename findfont
+		fontname (.SuppK) composename findfont
+		fontname (-90ms-SJ-SuppB-HV) composename findfont
+		/NotDefFont findfont
+	] readonly def
+	END
+	%
+	% 90msp-RKSJ-H
+	%
+
+	1 BEGIN
+	/FontName fontname (-90msp-RKSJ-H) composename def
+	/WMode 0 def
+	/FMapType 6 def
+	/Encoding RKSJEncoding def
+	/SubsVector 90msRKSJSubsVector def
+	/FDepVector [
+		2 dict begin
+			/RRyumin-Light		/Times-Roman	def
+			/GGothicBBB-Medium	/Helvetica	def
+		currentdict
+		end
+		fontname 2 copy known {
+			get findfont
+		}{
+			pop pop	fontname (.Roman) composename findfont
+		} ifelse
+		/NotDefFont findfont
+		fontname (-90ms-SJ-SuppA-H) composename findfont
+		fontname (.SuppK) composename findfont
+		fontname (-90ms-SJ-SuppB-HV) composename findfont
+		/NotDefFont findfont
+	] readonly def
+	END
+
+	%
+	% 90msp-RKSJ-V
+	%
+
+	1 BEGIN
+	/FontName fontname (-90msp-RKSJ-V) composename def
+	/WMode 1 def
+	/FMapType 6 def
+	/Encoding RKSJEncoding def
+	/SubsVector 90msRKSJSubsVector def
+	/FDepVector [
+		2 dict begin
+			/RRyumin-Light		/Times-Roman	def
+			/GGothicBBB-Medium	/Helvetica	def
+		currentdict
+		end
+		fontname 2 copy known {
+			get findfont
+		}{
+			pop pop	fontname (.Roman) composename findfont
+		} ifelse
+		/NotDefFont findfont
+		fontname (-90ms-SJ-SuppA-V) composename findfont
+		fontname (.SuppK) composename findfont
+		fontname (-90ms-SJ-SuppB-HV) composename findfont
+		/NotDefFont findfont
+	] readonly def
+	END
+
+	end
+} bind def
+
+/copycompfont
+{
+  100 string 100 string
+
+  3 index 2 index cvs length
+  3 index 2 index cvs length
+
+  [ 
+    (-H)
+    (-V)
+    (-Ext-H)
+    (-Ext-V)
+    (-EUC-H)
+    (-EUC-V)
+    (-SJ-SuppA-H)
+    (-SJ-SuppA-V)
+    (-SJ-SuppB-HV)
+    (-RKSJ-H)
+    (-RKSJ-V)
+    (-83pv-SJ-SuppB-H)
+    (-83pv-SJ-SuppB-V)
+    (-83pv-RKSJ-H)
+    (-83pv-RKSJ-V)
+    (-90pv-SJ-SuppA-H)
+    (-90pv-SJ-SuppA-V)
+    (-90pv-SJ-SuppB-HV)
+    (-90pv-RKSJ-H)
+    (-90pv-RKSJ-V)
+    (-90ms-SJ-SuppA-H)
+    (-90ms-SJ-SuppA-V)
+    (-90ms-SJ-SuppB-HV)
+    (-90ms-RKSJ-H)
+    (-90ms-RKSJ-V)
+    (-90msp-RKSJ-H)
+    (-90msp-RKSJ-V)
+    (-Ext-RKSJ-H)
+    (-Ext-RKSJ-V)
+  ]
+  {
+    dup length
+    5 index 4 index 3 index putinterval 5 index 0 5 index 3 index add getinterval cvn
+    5 index 4 index 4 index putinterval 5 index 0 5 index 4 index add getinterval cvn
+    4 2 roll pop pop
+    copyfont
+  } forall
+
+  pop pop pop pop pop pop
+} bind def
diff -Nur ghostscript-9.53.3-orig/kanji/kconfig.ps ghostscript-9.53.3/kanji/kconfig.ps
--- ghostscript-9.53.3-orig/kanji/kconfig.ps	Thu Jan 01 09:00:00 1970
+++ ghostscript-9.53.3/kanji/kconfig.ps	Sat Aug 24 00:12:33 2013
@@ -0,0 +1,81 @@
+%
+% Kanji Font Configuration File (Win32: Win32 API)
+%
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+%
+% Example:
+% 	/Ryumin-Light  4300000  (lr ) win32BMkanji
+% 	/Ryumin-Light  4300000  (lr ) win32kanji
+%
+% Descriptions:
+% 	/Ryumin-Light
+%		is the name of the Kanji font group to be installed.
+%		/Ryumin-Light and /GothicBBB-Medium are standard.
+%
+%	4300000
+%		is the offset of the identifiers to be used by the group.
+%		You should specify the offset at intervals of 200,
+%		because each font group uses about 170 identifiers.
+%
+%	(lr )
+%		is the name of the TrueType font (NOT FILE NAME!!).
+%
+%	win32kanji
+%		is the operator to install Kanji outline font groups under
+%               Win32 API.
+%               
+%	win32BMkanji
+%		is the operator to install Kanji bitmap font groups under
+%               Win32 API.
+%               
+%
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+%%
+%% Bitmap fonts
+%%
+/Ryumin-Light		4300000	(lr )            win32BMkanji
+/GothicBBB-Medium	4300200	(lr SVbN)        win32BMkanji
+
+/HeiseiMin-W3		4300400	(lr )            win32BMkanji
+/HeiseiKakuGo-W5	4300600	(lr SVbN)        win32BMkanji
+
+%/Ryumin-Light		4300000	(HGB)              win32BMkanji
+%/GothicBBB-Medium	4300200	(HG޼M)             win32BMkanji
+
+%/HeiseiMin-W3		4300400	(HGB)              win32BMkanji
+%/HeiseiKakuGo-W5	4300600	(HG޼M)             win32BMkanji
+
+%/Ryumin-Light		4300000	(HGȏ)           win32BMkanji
+%/GothicBBB-Medium	4300200	(HGۺ޼M-PRO)       win32BMkanji
+
+%/HeiseiMin-W3		4300400	(HGȏ)           win32BMkanji
+%/HeiseiKakuGo-W5	4300600	(HGۺ޼M-PRO)       win32BMkanji
+
+%/Ryumin-Light		4300000	(˖ Pro R)       win32BMkanji
+%/GothicBBB-Medium	4300200	(˃SVbN Pro M)   win32BMkanji
+
+%/HeiseiMin-W3		4300400	(˖ Pro R)       win32BMkanji
+%/HeiseiKakuGo-W5	4300600	(˃SVbN Pro M)   win32BMkanji
+
+%/Ryumin-Light		4300000	(˖ Pr6N R)      win32BMkanji
+%/GothicBBB-Medium	4300200	(˃SVbN Pr6N M)  win32BMkanji
+
+%/HeiseiMin-W3		4300400	(˖ Pr6N R)      win32BMkanji
+%/HeiseiKakuGo-W5	4300600	(˃SVbN Pr6N M)  win32BMkanji
+
+%%
+%% outline fonts
+%%
+%/Ryumin-Light		4300000	(lr )	win32kanji
+%/GothicBBB-Medium	4300200	(lr SVbN)	win32kanji
+
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+%
+% Kanji Font Aliases
+%
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+
+/Ryumin-Light-RKSJ-H /Ryumin-Light-Ext-RKSJ-H copyfont
+/Ryumin-Light-RKSJ-V /Ryumin-Light-Ext-RKSJ-V copyfont
+/GothicBBB-Medium-RKSJ-H /GothicBBB-Medium-Ext-RKSJ-H copyfont
+/GothicBBB-Medium-RKSJ-V /GothicBBB-Medium-Ext-RKSJ-V copyfont
diff -Nur ghostscript-9.53.3-orig/kanji/kfwin32.ps ghostscript-9.53.3/kanji/kfwin32.ps
--- ghostscript-9.53.3-orig/kanji/kfwin32.ps	Thu Jan 01 09:00:00 1970
+++ ghostscript-9.53.3/kanji/kfwin32.ps	Sun Jul 18 22:15:38 1999
@@ -0,0 +1,37 @@
+%
+% kfwin32.ps - Configuration for Vector Fonts under Win32 API.
+%
+% Written by ASAYAMA Kazunori   Sep. 10, 1997
+%
+
+1 dict begin 		% /FontInfo
+
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+%
+% Font Info Dictionary
+%
+
+/FontInfo 6 dict dup begin
+/Notice ("Using Japanese TrueType fonts vice Win32 API") readonly def
+/FamilyName (Kanji) readonly def
+/FullName (Win32 API) readonly def
+/isFixedPitch true def
+/ItalicAngle 0 def
+/Weight (Medium) readonly def
+end readonly def
+
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+%
+% Kanji Font Operator under Win32 API.
+%
+
+% font_name unique_id font_file win32kanji -
+
+/win32kanji {
+	//FontInfo [ 3 -1 roll /kfwin32 load ] cvx
+	outlinekanji pop
+} userdict 3 1 roll put
+
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+
+end
diff -Nur ghostscript-9.53.3-orig/kanji/kfwin32bm.ps ghostscript-9.53.3/kanji/kfwin32bm.ps
--- ghostscript-9.53.3-orig/kanji/kfwin32bm.ps	Thu Jan 01 09:00:00 1970
+++ ghostscript-9.53.3/kanji/kfwin32bm.ps	Thu Aug 29 02:19:22 2002
@@ -0,0 +1,37 @@
+%
+% kfwin32bm.ps - Configuration for Bitmap Fonts under 'Win32API'.
+%
+% I. Matsuda   Feb. 3, 1998        (A. Kakuto 2002, Win32API)
+%
+
+1 dict begin 		% /FontInfo
+
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+%
+% Font Info Dictionary
+%
+
+/FontInfo 6 dict dup begin
+/Notice ("Win32 Bitmap Font Library") readonly def
+/FamilyName (Kanji) readonly def
+/FullName (Win32 Bitmap Font Library) readonly def
+/isFixedPitch true def
+/ItalicAngle 0 def
+/Weight (Medium) readonly def
+end readonly def
+
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+%
+% Kanji Font Operator under the Win32API.
+%
+
+% font_name unique_id font_file win32BMkanji -
+
+/win32BMkanji {
+	//FontInfo [ 3 -1 roll /kfwin32BM load ] cvx
+	bitmapkanji pop
+} userdict 3 1 roll put
+
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+
+end
diff -Nur ghostscript-9.53.3-orig/kanji/kinit.ps ghostscript-9.53.3/kanji/kinit.ps
--- ghostscript-9.53.3-orig/kanji/kinit.ps	Thu Jan 01 09:00:00 1970
+++ ghostscript-9.53.3/kanji/kinit.ps	Thu Aug 29 02:20:14 2002
@@ -0,0 +1,457 @@
+%
+% kinit.ps  -  install Kanji fonts
+%
+% Apr. 4, 1992 by N.Katayama
+%
+% Akira Tanaka <akr@jaist.ac.jp> modified for gs4.03/VFlib support. 1996/10/17
+
+%QUIET not { (Installing Kanji fonts... ) print flush } if
+
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+%
+% Define utility operators
+%
+
+14 dict begin		% QUIET
+			% acvs, copyfont,
+			% buffer, basefontname, composename,
+			% JISMappingDict, SJISMappingDict, CNameMappingDict,
+			% StandardMappingProc,
+			% bitmapkanji, outlinekanji
+			% basekanji and compositekanji
+
+/QUIET true def
+
+%
+% array string ACVS string
+%
+
+/acvs {
+	% Check stack		
+	2 copy type /stringtype ne exch type /arraytype ne or {
+		/acvs errordict /typecheck get exec
+	} if
+	2 copy length exch length ne {
+		/acvs errordict /rangecheck get exec
+	} if
+	% Convert array into string
+	0 1 3 index length 1 sub {
+		dup 3 index exch get 2 index 3 1 roll put
+	} for
+	exch pop
+} bind def
+
+%
+% fontname newname COPYFONT -
+%
+
+/copyfont {
+	% Check stack
+	count 2 lt {
+		/copyfont errordict /stackunderflow get exec
+	} if
+	2 copy type /nametype ne exch type /nametype ne or {
+		/copyfont errordict /typecheck get exec
+	} if
+	exch findfont dup maxlength dict begin {
+		1 index /FID ne 2 index /UniqueID ne and
+		{ def }{ pop pop } ifelse
+	} forall
+	currentdict end
+	definefont pop
+} bind def
+
+%
+% Buffer
+%
+
+/buffer 2 dict begin
+/str 256 string def
+/len 0 def
+currentdict end def
+
+%
+% font_name suffix1 row_code suffix2 BASEFONTNAME font_name
+%
+
+/basefontname {
+	buffer begin
+	4 -1 roll str cvs length /len exch def
+	str len 4 index putinterval 3 -1 roll length len add /len exch def
+	exch 16 str len 2 getinterval cvrs pop /len len 2 add def
+	str len 2 index putinterval length len add /len exch def
+	str 0 len getinterval cvn
+	end
+} bind def
+
+%
+% font_name suffix NAME font_name
+%
+
+/composename {
+	buffer begin
+	exch str cvs length /len exch def
+	str len 2 index putinterval length len add /len exch def
+	str 0 len getinterval cvn
+	end
+} bind def
+
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+%
+% Define Encoding Vectors
+%
+
+userdict begin
+
+%
+% JIS
+%
+
+/JISEncoding [
+	16#00 1 16#20 { pop 0 } for
+	16#21 1 16#28 { 16#20 sub } for
+	16#29 1 16#2F { pop 0 } for
+	16#30 1 16#74 { 16#27 sub } for
+	16#75 1 16#FF { pop 0 } for
+] readonly def
+
+%
+% Ext
+%
+
+/ExtEncoding
+[
+	16#00 1 16#20 { pop 0 } for
+	16#21 1 16#27 { 16#20 sub } for
+	16#28 1 16#28 { pop 0 } for
+	16#29 1 16#2D { 16#21 sub } for
+	16#2E 1 16#2F { pop 0 } for
+	16#30 1 16#73 { 16#23 sub } for
+	16#74 1 16#FF { pop 0 } for
+] readonly def
+
+%
+% EUC
+%
+
+/EUCEncoding
+[
+	16#00 1 16#A0 { pop 0 } for
+	16#A1 1 16#A8 { 16#A0 sub } for
+	16#A9 1 16#AF { pop 0 } for
+	16#B0 1 16#F4 { 16#A7 sub } for
+	16#F5 1 16#FF { pop 0 } for
+] readonly def
+
+%
+% JIS Sub
+%
+
+/JISSubEncoding [
+% 16#00
+    /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef
+    /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef
+    /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef
+    /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef
+% 16#20
+    /.notdef /c21     /c22     /c23     /c24     /c25     /c26     /c27
+    /c28     /c29     /c2A     /c2B     /c2C     /c2D     /c2E     /c2F
+    /c30     /c31     /c32     /c33     /c34     /c35     /c36     /c37
+    /c38     /c39     /c3A     /c3B     /c3C     /c3D     /c3E     /c3F
+% 16#40
+    /c40     /c41     /c42     /c43     /c44     /c45     /c46     /c47
+    /c48     /c49     /c4A     /c4B     /c4C     /c4D     /c4E     /c4F
+    /c50     /c51     /c52     /c53     /c54     /c55     /c56     /c57
+    /c58     /c59     /c5A     /c5B     /c5C     /c5D     /c5E     /c5F
+% 16#60
+    /c60     /c61     /c62     /c63     /c64     /c65     /c66     /c67
+    /c68     /c69     /c6A     /c6B     /c6C     /c6D     /c6E     /c6F
+    /c70     /c71     /c72     /c73     /c74     /c75     /c76     /c77
+    /c78     /c79     /c7A     /c7B     /c7C     /c7D     /c7E     /.notdef
+128 copy ] readonly def
+
+%
+% Roman
+%
+
+/RomanEncoding [
+% 16#00
+/.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef
+/.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef
+/.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef
+/.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef
+% 16#20
+/space /exclam /quotedbl /numbersign /dollar /percent /ampersand /quoteright
+/parenleft /parenright /asterisk /plus /comma /hyphen /period /slash
+/zero /one /two /three /four /five /six /seven 
+/eight /nine /colon /semicolon /less /equal /greater /question
+% 16#40
+/at
+/A /B /C /D /E /F /G /H /I /J /K /L /M /N /O /P /Q /R /S /T /U /V /W /X /Y /Z
+/bracketleft /yen /bracketright /asciicircum /underscore
+% 16#60
+/quoteleft
+/a /b /c /d /e /f /g /h /i /j /k /l /m /n /o /p /q /r /s /t /u /v /w /x /y /z
+/braceleft /bar /braceright /overline /.notdef 
+% 16#80
+1 1 128 { /.notdef } for
+] readonly def
+
+%
+% Hiragana
+%
+
+/HiraganaEncoding [
+% 16#00
+/.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef
+/.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef
+/.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef
+/.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef
+% 16#20
+/space /jperiod /jbracketleft /jbracketright
+/jcomma /periodcentered /wogana /asmallgana
+/ismallgana /usmallgana /esmallgana /osmallgana
+/yasmallgana /yusmallgana /yosmallgana /tsusmallgana
+/jprolonged /agana /igana /ugana /egana /ogana /kagana /kigana
+/kugana /kegana /kogana /sagana /shigana /sugana /segana /sogana
+% 16#40
+/tagana /chigana /tsugana /tegana /togana /nagana /nigana /nugana
+/negana /nogana /hagana /higana /fugana /hegana /hogana /magana
+/migana /mugana /megana /mogana /yagana /yugana /yogana /ragana
+/rigana /rugana /regana /rogana /wagana /ngana /jvoiced /jsemivoiced
+% 16#60
+/wigana /yegana /wasmallgana /.notdef /.notdef /.notdef /gagana /gigana
+/gugana /gegana /gogana /zagana /jigana /zugana /zegana /zogana
+/dagana /digana /dugana /degana /dogana /bagana /pagana /bigana
+/pigana /bugana /pugana /begana /pegana /bogana /pogana /.notdef
+% 16#80
+1 1 128 { /.notdef } for
+] readonly def
+
+%
+% Katakana
+%
+
+/KatakanaEncoding [
+% 16#00
+/.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef
+/.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef
+/.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef
+/.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef
+% 16#20
+/space /jperiod /jbracketleft /jbracketright
+/jcomma /periodcentered /wokana /asmallkana
+/ismallkana /usmallkana /esmallkana /osmallkana
+/yasmallkana /yusmallkana /yosmallkana /tsusmallkana
+/jprolonged /akana /ikana /ukana /ekana /okana /kakana /kikana
+/kukana /kekana /kokana /sakana /shikana /sukana /sekana /sokana
+% 16#40
+/takana /chikana /tsukana /tekana /tokana /nakana /nikana /nukana
+/nekana /nokana /hakana /hikana /fukana /hekana /hokana /makana
+/mikana /mukana /mekana /mokana /yakana /yukana /yokana /rakana
+/rikana /rukana /rekana /rokana /wakana /nkana /jvoiced /jsemivoiced
+% 16#60
+/wikana /yekana /wasmallkana /kasmallkana /kesmallkana /vukana /gakana /gikana
+/gukana /gekana /gokana /zakana /jikana /zukana /zekana /zokana
+/dakana /dikana /dukana /dekana /dokana /bakana /pakana /bikana
+/pikana /bukana /pukana /bekana /pekana /bokana /pokana /.notdef
+% 16#80
+1 1 128 { /.notdef } for
+] readonly def
+
+%
+% Hankaku
+%
+/HankakuEncoding [
+% 16#00
+/.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef
+/.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef
+/.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef
+/.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef
+% 16#20
+/space /exclam /quotedbl /numbersign /dollar /percent /ampersand /quoteright
+/parenleft /parenright /asterisk /plus /comma /hyphen /period /slash
+/zero /one /two /three /four /five /six /seven 
+/eight /nine /colon /semicolon /less /equal /greater /question
+% 16#40
+/at
+/A /B /C /D /E /F /G /H /I /J /K /L /M /N /O /P /Q /R /S /T /U /V /W /X /Y /Z
+/bracketleft /yen /bracketright /asciicircum /underscore
+% 16#60
+/quoteleft
+/a /b /c /d /e /f /g /h /i /j /k /l /m /n /o /p /q /r /s /t /u /v /w /x /y /z
+/braceleft /bar /braceright /overline /.notdef 
+% 16#80
+/space /jperiod /jbracketleft /jbracketright
+/jcomma /periodcentered /wogana /asmallgana
+/ismallgana /usmallgana /esmallgana /osmallgana
+/yasmallgana /yusmallgana /yosmallgana /tsusmallgana
+/jprolonged /agana /igana /ugana /egana /ogana /kagana /kigana
+/kugana /kegana /kogana /sagana /shigana /sugana /segana /sogana
+%16#A0
+/space /jperiod /jbracketleft /jbracketright
+/jcomma /periodcentered /wokana /asmallkana
+/ismallkana /usmallkana /esmallkana /osmallkana
+/yasmallkana /yusmallkana /yosmallkana /tsusmallkana
+/jprolonged /akana /ikana /ukana /ekana /okana /kakana /kikana
+/kukana /kekana /kokana /sakana /shikana /sukana /sekana /sokana
+% 16#C0
+/takana /chikana /tsukana /tekana /tokana /nakana /nikana /nukana
+/nekana /nokana /hakana /hikana /fukana /hekana /hokana /makana
+/mikana /mukana /mekana /mokana /yakana /yukana /yokana /rakana
+/rikana /rukana /rekana /rokana /wakana /nkana /jvoiced /jsemivoiced
+% 16#E0
+/tagana /chigana /tsugana /tegana /togana /nagana /nigana /nugana
+/negana /nogana /hagana /higana /fugana /hegana /hogana /magana
+/migana /mugana /megana /mogana /yagana /yugana /yogana /ragana
+/rigana /rugana /regana /rogana /wagana /ngana /jvoiced /jsemivoiced
+] readonly def
+
+%
+% Shift-JIS 
+%
+
+/RKSJEncoding [ 0 1 2 3 4 5 ] readonly def	
+/RKSJSubsVector [ 0 128 1 31 64 16 ] dup length string acvs readonly def
+
+/SJSuppAEncoding [
+	16#81 1 16#9F { 16#80 sub } for
+] readonly def
+
+/SJSuppBEncoding [
+	16#E0 1 16#EA { 16#DF sub } for
+	16#EB 1 16#EF { pop 0 } for
+] readonly def
+
+/83pvSJSuppBEncoding [
+	16#E0 1 16#EE { 16#DF sub } for
+	16#EF 1 16#EF { pop 0 } for
+] readonly def
+
+/90pvSJSuppBEncoding [
+	16#E0 1 16#ED { 16#DF sub } for
+	16#EE 1 16#EF { pop 0 } for
+] readonly def
+
+/90msRKSJEncoding [ 0 1 2 3 4 5 ] readonly def	
+/90msRKSJSubsVector [ 0 128 1 31 64 29 ] dup length string acvs readonly def
+/90msSJSuppBEncoding [
+	16#E0 1 16#EA { 16#DF sub } for
+        16#EB 1 16#EC { pop 0 } for
+        16#ED 1 16#EE { 16#E1 sub } for
+	16#EF 1 16#F9 { pop 0 } for
+	16#FA 1 16#FC { 16#EC sub } for
+] readonly def
+
+/RKSuppKEncoding [
+% 16#00
+    /space /jperiod /jbracketleft /jbracketright
+    /jcomma /periodcentered /wokana /asmallkana
+    /ismallkana /usmallkana /esmallkana /osmallkana
+    /yasmallkana /yusmallkana /yosmallkana /tsusmallkana
+    /jprolonged /akana /ikana /ukana /ekana /okana /kakana /kikana
+    /kukana /kekana /kokana /sakana /shikana /sukana /sekana /sokana
+% 16#20
+    /takana /chikana /tsukana /tekana /tokana /nakana /nikana /nukana
+    /nekana /nokana /hakana /hikana /fukana /hekana /hokana /makana
+    /mikana /mukana /mekana /mokana /yakana /yukana /yokana /rakana
+    /rikana /rukana /rekana /rokana /wakana /nkana /jvoiced /jsemivoiced
+] readonly def
+
+/SJSubEncoding [
+% 16#00
+    /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef
+    /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef
+    /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef
+    /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef
+% 16#20
+    /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef
+    /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef
+    /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef
+    /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef
+% 16#40
+    /c40     /c41     /c42     /c43     /c44     /c45     /c46     /c47
+    /c48     /c49     /c4A     /c4B     /c4C     /c4D     /c4E     /c4F
+    /c50     /c51     /c52     /c53     /c54     /c55     /c56     /c57
+    /c58     /c59     /c5A     /c5B     /c5C     /c5D     /c5E     /c5F
+% 16#60
+    /c60     /c61     /c62     /c63     /c64     /c65     /c66     /c67
+    /c68     /c69     /c6A     /c6B     /c6C     /c6D     /c6E     /c6F
+    /c70     /c71     /c72     /c73     /c74     /c75     /c76     /c77
+    /c78     /c79     /c7A     /c7B     /c7C     /c7D     /c7E     /.notdef
+% 16#80
+    /c80     /c81     /c82     /c83     /c84     /c85     /c86     /c87
+    /c88     /c89     /c8A     /c8B     /c8C     /c8D     /c8E     /c8F
+    /c90     /c91     /c92     /c93     /c94     /c95     /c96     /c97
+    /c98     /c99     /c9A     /c9B     /c9C     /c9D     /c9E     /c9F
+% 16#A0
+    /cA0     /cA1     /cA2     /cA3     /cA4     /cA5     /cA6     /cA7
+    /cA8     /cA9     /cAA     /cAB     /cAC     /cAD     /cAE     /cAF
+    /cB0     /cB1     /cB2     /cB3     /cB4     /cB5     /cB6     /cB7
+    /cB8     /cB9     /cBA     /cBB     /cBC     /cBD     /cBE     /cBF
+% 16#C0
+    /cC0     /cC1     /cC2     /cC3     /cC4     /cC5     /cC6     /cC7
+    /cC8     /cC9     /cCA     /cCB     /cCC     /cCD     /cCE     /cCF
+    /cD0     /cD1     /cD2     /cD3     /cD4     /cD5     /cD6     /cD7
+    /cD8     /cD9     /cDA     /cDB     /cDC     /cDD     /cDE     /cDF
+% 16#E0
+    /cE0     /cE1     /cE2     /cE3     /cE4     /cE5     /cE6     /cE7
+    /cE8     /cE9     /cEA     /cEB     /cEC     /cED     /cEE     /cEF
+    /cF0     /cF1     /cF2     /cF3     /cF4     /cF5     /cF6     /cF7
+    /cF8     /cF9     /cFA     /cFB     /cFC     /.notdef /.notdef /.notdef
+] readonly def
+
+end
+
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+%
+% Include supplementary files
+%
+
+% Define basekanji operator
+
+(kbase.ps) runlibfile
+
+% Define compositekanji operator
+
+(kcomp.ps) runlibfile
+
+% Define Mapping Dictionary
+
+(kmapping.ps) runlibfile
+
+% Define outlinekanji operator
+
+(koutline.ps) runlibfile
+
+% Define bitmapkanji operator
+
+(kbitmap.ps) runlibfile
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+%
+% Define NotDefFont
+%
+
+7 dict begin
+/FontName /NotDefFont def
+/FontType 3 def
+/FontMatrix [ 0.001 0 0 0.001 0 0 ] readonly def
+/FontBBox { 0 -120 1000 880 } readonly def
+/Encoding [ 0 1 255 { pop 0 } for ] readonly def
+/BuildChar { pop pop 
+	1000 0 0 -120 1000 880 0 -1000 500 880 setcachedevice2
+} readonly def
+currentdict end dup /FontName get exch definefont pop
+
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+%
+% Load Kanji font configuration file
+%
+
+systemdict /KCONFIG 2 copy known { get }{ pop pop (kconfig.ps) } ifelse runlibfile
+
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+
+end
+
+%QUIET not { (done.\n) print flush } if
diff -Nur ghostscript-9.53.3-orig/kanji/kmapping.ps ghostscript-9.53.3/kanji/kmapping.ps
--- ghostscript-9.53.3-orig/kanji/kmapping.ps	Thu Jan 01 09:00:00 1970
+++ ghostscript-9.53.3/kanji/kmapping.ps	Sun Jul 18 22:15:38 1999
@@ -0,0 +1,155 @@
+%
+% Mapping from character names to Kanji JIS code
+%
+% Apr.10,1992 Written by N.Katayama
+%
+
+%
+% JIS
+%
+
+/JISMappingDict 94 dict begin
+	3 string dup 0 (c) putinterval dup 1 2 getinterval
+	16#21 1 16#7E {
+		dup 16 3 index cvrs pop
+		2 index cvn exch def
+	} for
+	pop pop
+currentdict end readonly def
+
+%
+% Shift JIS
+%
+
+/SJMappingDict 188 dict begin
+	3 string dup 0 (c) putinterval dup 1 2 getinterval
+	16#40 1 16#7E {
+		dup 16 3 index cvrs pop
+		16#40 sub 16#21 add
+		2 index cvn exch def
+	} for
+	16#80 1 16#9E {
+		dup 16 3 index cvrs pop
+		16#80 sub 16#60 add
+		2 index cvn exch def
+	} for
+	16#9F 1 16#FC {
+		dup 16 3 index cvrs pop
+		16#9F sub 16#0121 add
+		2 index cvn exch def
+	} for
+	pop pop
+currentdict end readonly def	
+
+%
+% Character Name Mapping
+%
+
+/CNameMappingDict 512 dict begin
+%
+% Symbols
+%
+/space		16#2121	def	/jcomma		16#2122 def
+/jperiod	16#2123 def	/comma		16#2124 def
+/period		16#2125 def	/periodcentered	16#2126 def
+/colon		16#2127 def	/semicolon	16#2128 def
+/question	16#2129	def	/exclam		16#212A	def
+/jvoiced 	16#212B def	/jsemivoiced	16#212C def
+%
+/asciicircum	16#2130	def	/overline	16#2131	def
+/underscore	16#2132 def	
+%
+/jprolonged	16#213C def	/hyphen		16#213D def
+%
+/slash		16#213F	def	/backslash	16#2140 def
+%
+/bar		16#2143	def
+%
+/quoteleft	16#2146 def	/quoteright	16#2147	def
+%
+/quotedbl	16#2149	def
+/parenleft	16#214A	def	/parenright	16#214B	def
+%
+/bracketleft	16#214E	def	/bracketright	16#214F	def	
+/braceleft	16#2150	def	/braceright	16#2151	def	
+%
+/jbracketleft	16#2156 def	/jbracketright	16#2157	def
+%
+/plus		16#215C	def	/minus		16#215D def
+%
+/equal		16#2161	def
+%
+/less		16#2163	def	/greater	16#2164	def
+%
+/yen		16#216F	def	/dollar		16#2170	def
+%
+/percent	16#2173	def	/numbersign	16#2174	def
+/ampersand	16#2175	def	/asterisk	16#2176	def	
+/at		16#2177	def
+%
+% Digits
+%
+[
+/zero /one /two /three /four /five /six /seven /eight /nine
+] 16#2330 1 16#2339 { 2 copy 16#2330 sub get exch def } for pop
+%
+% Alphabets
+%
+[
+/A /B /C /D /E /F /G /H /I /J /K /L /M /N /O /P /Q /R /S /T /U /V /W /X /Y /Z
+] 16#2341 1 16#235A { 2 copy 16#2341 sub get exch def } for pop
+%
+[
+/a /b /c /d /e /f /g /h /i /j /k /l /m /n /o /p /q /r /s /t /u /v /w /x /y /z
+] 16#2361 1 16#237A { 2 copy 16#2361 sub get exch def } for pop
+%
+% Hiragana
+%
+[
+/asmallgana /agana /ismallgana /igana /usmallgana /ugana
+/esmallgana /egana /osmallgana /ogana
+/kagana	/gagana /kigana /gigana /kugana /gugana
+/kegana /gegana /kogana /gogana
+/sagana /zagana /shigana /jigana /sugana /zugana
+/segana /zegana /sogana /zogana
+/tagana /dagana /chigana /digana /tsusmallgana /tsugana /dugana
+/tegana /degana /togana /dogana
+/nagana /nigana /nugana /negana /nogana
+/hagana /bagana /pagana /higana /bigana /pigana /fugana /bugana /pugana
+/hegana /begana /pegana /hogana /bogana /pogana
+/magana /migana /mugana /megana /mogana
+/yasmallgana /yagana /yusmallgana /yugana /yosmallgana /yogana
+/ragana /rigana /rugana /regana /rogana 
+/wasmallgana /wagana /wigana /yegana /wogana /ngana
+] 16#2421 1 16#2473 { 2 copy 16#2421 sub get exch def } for pop
+%
+% Katakana
+%
+[
+/asmallkana /akana /ismallkana /ikana /usmallkana /ukana
+/esmallkana /ekana /osmallkana /okana
+/kakana	/gakana /kikana /gikana /kukana /gukana
+/kekana /gekana /kokana /gokana
+/sakana /zakana /shikana /jikana /sukana /zukana
+/sekana /zekana /sokana /zokana
+/takana /dakana /chikana /dikana /tsusmallkana /tsukana /dukana
+/tekana /dekana /tokana /dokana
+/nakana /nikana /nukana /nekana /nokana
+/hakana /bakana /pakana /hikana /bikana /pikana /fukana /bukana /pukana
+/hekana /bekana /pekana /hokana /bokana /pokana
+/makana /mikana /mukana /mekana /mokana
+/yasmallkana /yakana /yusmallkana /yukana /yosmallkana /yokana
+/rakana /rikana /rukana /rekana /rokana 
+/wasmallkana /wakana /wikana /yekana /wokana /nkana
+/vukana /kasmallkana /kesmallkana
+] 16#2521 1 16#2576 { 2 copy 16#2521 sub get exch def } for pop
+currentdict end readonly def
+
+%
+% Mapping procedure
+%
+
+/StandardMapping {
+	Private /MappingDict get exch 2 copy known 
+	{ get Private /MappingOffset get add }{ pop pop 16#2121 } ifelse
+} def
diff -Nur ghostscript-9.53.3-orig/kanji/koutline.ps ghostscript-9.53.3/kanji/koutline.ps
--- ghostscript-9.53.3-orig/kanji/koutline.ps	Thu Jan 01 09:00:00 1970
+++ ghostscript-9.53.3/kanji/koutline.ps	Sun Jul 18 22:15:38 1999
@@ -0,0 +1,64 @@
+%
+% koutline.ps  -  define /outlinekanji operator
+%
+% Apr. 6,1992 Programmed by N.Katayama
+%
+% Akira Tanaka <akr@jaist.ac.jp> modified for gs4.03/VFlib support. 1996/10/17
+% Akira Tanaka <akr@jaist.ac.jp> modified for gs5.0/VFlib support. 1997/6/9
+% Akira Tanaka <akr@jaist.ac.jp> modified for gs5.10/VFlib support. 1998/4/7
+
+%
+% font_name unique_id font_info path_proc OUTLINEKANJI unique_id
+%
+
+/outlinekanji {
+	6 dict begin	% fontname, uniqueid, fontinfo, pathproc,
+			% private and buildchar
+
+	/pathproc exch def
+	/fontinfo exch def
+	/uniqueid exch def
+	/fontname exch def
+
+	% Private dictionary
+
+	/private 1 dict begin 
+	/PathProc /pathproc load def
+	currentdict end def
+
+	% Define BuildChar procedure
+
+	/buildchar {		
+		exch begin
+		Encoding exch get dup Private /MappingProc get exec
+		currentfont /WMode 2 copy known { get }{ pop pop 0 } ifelse
+
+% Akira Tanaka <akr@jaist.ac.jp> modified for bogus speedup. 1998/05/17
+		%gsave
+		%2 copy Private /PathProc get exec
+		%{ flattenpath pathbbox } stopped { .clearerror 0 0 0 0 } if
+		%grestore
+                0 -120 1000 880
+
+		1000 0 6 2 roll 0 -1000 500 880 13 -1 roll setmetrics2
+		Private /PathProc get exec
+		PaintType 0 eq 
+		{ eofill }{
+			currentdict /StrokeWidth known
+			{StrokeWidth}{0} ifelse
+			setlinewidth stroke
+		} ifelse
+		end
+	} bind def
+
+	% Define base fonts
+
+	fontname uniqueid fontinfo private /buildchar load basekanji
+	/uniqueid exch def
+
+	% Define composite fonts
+
+	fontname fontinfo compositekanji
+
+	uniqueid end
+} def
diff -Nur ghostscript-9.53.3-orig/kanji/metrics2.ps ghostscript-9.53.3/kanji/metrics2.ps
--- ghostscript-9.53.3-orig/kanji/metrics2.ps	Thu Jan 01 09:00:00 1970
+++ ghostscript-9.53.3/kanji/metrics2.ps	Sun Jul 18 22:15:38 1999
@@ -0,0 +1,97 @@
+%
+% wmode.ps  -  define /setmetrics2 operator
+%
+% Aug.28,1991 Programmed by N.Katayama
+%
+% Akira Tanaka <akr@jaist.ac.jp> modified for gs4.03/VFlib support. 1996/10/17
+
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+%
+% Metrics Utility Operator
+% Execute this in the BuildChar procedure instead of setcachedevice2
+%
+
+%/SETMETRICS2 14 dict def	% private dictionary
+
+%
+% w0x w0y llx lly urx ury w1x w1y vx vy char setmetrics2 -
+%
+
+/setmetrics2
+{
+	currentdict 
+	14 dict begin
+	/font exch def
+	/char exch def	
+	/vy exch def	/vx exch def	/w1y exch def	/w1x exch def
+	/ury exch def	/urx exch def	/lly exch def	/llx exch def
+	/w0y exch def	/w0x exch def
+
+	/old-llx llx def
+	/old-lly lly def
+
+	% Metrics
+
+	font /Metrics 2 copy known {
+		get char 2 copy known {
+			get dup type 
+			dup /integertype eq { 
+				/w0x 2 index def 
+			} if
+			dup /realtype eq {
+				/w0x 2 index def
+			} if
+			dup /arraytype eq {
+				1 index
+				dup length 2 eq {
+					/llx 1 index 0 get def
+					/urx llx old-llx sub urx add def
+					/w0x 1 index 1 get def
+				} if
+				dup length 4 eq {
+					/llx 1 index 0 get def
+					/lly 1 index 1 get def
+					/urx llx old-llx sub urx add def
+					/ury lly old-lly sub ury add def
+					/w0x 1 index 2 get def
+					/w0y 1 index 3 get def
+				} if
+				pop
+			} if
+			pop pop
+		}{ pop pop } ifelse
+	}{ pop pop } ifelse
+
+	% Metrics2
+
+	font /Metrics2 2 copy known {
+		get char 2 copy known {
+			get 
+			dup 0 get /w1x exch def
+			dup 1 get /w1y exch def
+			dup 2 get /vx exch def
+			dup 3 get /vy exch def
+			pop
+		}{ pop pop } ifelse
+	}{ pop pop } ifelse
+
+	% CDevProc
+
+	font /CDevProc 2 copy known {
+		get
+		w0x w0y llx lly urx ury w1x w1y vx vy char 12 -1 roll exec
+		/vy exch def	/vx exch def	/w1y exch def	/w1x exch def
+		/ury exch def	/urx exch def	/lly exch def	/llx exch def
+		/w0y exch def	/w0x exch def
+	}{ pop pop } ifelse
+
+	% setcachedevice2
+
+	w0x w0y llx lly urx ury w1x w1y vx vy setcachedevice2
+
+	% translate
+
+	llx old-llx sub lly old-lly sub translate 
+	
+	end
+} bind def
diff -Nur ghostscript-9.53.3-orig/kanji/useopentype.ps ghostscript-9.53.3/kanji/useopentype.ps
--- ghostscript-9.53.3-orig/kanji/useopentype.ps	Thu Jan 01 09:00:00 1970
+++ ghostscript-9.53.3/kanji/useopentype.ps	Mon Sep 02 22:07:40 2013
@@ -0,0 +1,265 @@
+%%BeginFont: Ryumin-Light-H
+/Ryumin-Light-H
+/H /CMap findresource
+[/Ryumin-Light /CIDFont findresource]
+composefont pop
+%%EndFont
+
+%%BeginFont: GothicBBB-Medium-H
+/GothicBBB-Medium-H
+/H /CMap findresource
+[/GothicBBB-Medium /CIDFont findresource]
+composefont pop
+%%EndFont
+
+%%BeginFont: HiraKakuPro-W3-H
+/HiraKakuPro-W3-H
+/H /CMap findresource
+[/HiraKakuPro-W3 /CIDFont findresource]
+composefont pop
+%%EndFont
+
+%%BeginFont: HiraKakuPro-W6-H
+/HiraKakuPro-W6-H
+/H /CMap findresource
+[/HiraKakuPro-W6 /CIDFont findresource]
+composefont pop
+%%EndFont
+
+%%BeginFont: HiraKakuProN-W3-H
+/HiraKakuProN-W3-H
+/H /CMap findresource
+[/HiraKakuProN-W3 /CIDFont findresource]
+composefont pop
+%%EndFont
+
+%%BeginFont: HiraKakuProN-W6-H
+/HiraKakuProN-W6-H
+/H /CMap findresource
+[/HiraKakuProN-W6 /CIDFont findresource]
+composefont pop
+%%EndFont
+
+%%BeginFont: HiraKakuStd-W8-H
+/HiraKakuStd-W8-H
+/H /CMap findresource
+[/HiraKakuStd-W8 /CIDFont findresource]
+composefont pop
+%%EndFont
+
+%%BeginFont: HiraKakuStdN-W8-H
+/HiraKakuStdN-W8-H
+/H /CMap findresource
+[/HiraKakuStdN-W8 /CIDFont findresource]
+composefont pop
+%%EndFont
+
+%%BeginFont: HiraMaruPro-W4-H
+/HiraMaruPro-W4-H
+/H /CMap findresource
+[/HiraMaruPro-W4 /CIDFont findresource]
+composefont pop
+%%EndFont
+
+%%BeginFont: HiraMaruProN-W4-H
+/HiraMaruProN-W4-H
+/H /CMap findresource
+[/HiraMaruProN-W4 /CIDFont findresource]
+composefont pop
+%%EndFont
+
+%%BeginFont: HiraMinPro-W3-H
+/HiraMinPro-W3-H
+/H /CMap findresource
+[/HiraMinPro-W3 /CIDFont findresource]
+composefont pop
+%%EndFont
+
+%%BeginFont: HiraMinPro-W6-H
+/HiraMinPro-W6-H
+/H /CMap findresource
+[/HiraMinPro-W6 /CIDFont findresource]
+composefont pop
+%%EndFont
+
+%%BeginFont: HiraMinProN-W3-H
+/HiraMinProN-W3-H
+/H /CMap findresource
+[/HiraMinProN-W3 /CIDFont findresource]
+composefont pop
+%%EndFont
+
+%%BeginFont: HiraMinProN-W6-H
+/HiraMinProN-W6-H
+/H /CMap findresource
+[/HiraMinProN-W6 /CIDFont findresource]
+composefont pop
+%%EndFont
+
+%%BeginFont: KozGoPr6N-Bold-H
+/KozGoPr6N-Bold-H
+/H /CMap findresource
+[/KozGoPr6N-Bold /CIDFont findresource]
+composefont pop
+%%EndFont
+
+%%BeginFont: KozGoPr6N-ExtraLight-H
+/KozGoPr6N-ExtraLight-H
+/H /CMap findresource
+[/KozGoPr6N-ExtraLight /CIDFont findresource]
+composefont pop
+%%EndFont
+
+%%BeginFont: KozGoPr6N-Heavy-H
+/KozGoPr6N-Heavy-H
+/H /CMap findresource
+[/KozGoPr6N-Heavy /CIDFont findresource]
+composefont pop
+%%EndFont
+
+%%BeginFont: KozGoPr6N-Light-H
+/KozGoPr6N-Light-H
+/H /CMap findresource
+[/KozGoPr6N-Light /CIDFont findresource]
+composefont pop
+%%EndFont
+
+%%BeginFont: KozGoPr6N-Medium-H
+/KozGoPr6N-Medium-H
+/H /CMap findresource
+[/KozGoPr6N-Medium /CIDFont findresource]
+composefont pop
+%%EndFont
+
+%%BeginFont: KozGoPr6N-Regular-H
+/KozGoPr6N-Regular-H
+/H /CMap findresource
+[/KozGoPr6N-Regular /CIDFont findresource]
+composefont pop
+%%EndFont
+
+%%BeginFont: KozGoPro-Bold-H
+/KozGoPro-Bold-H
+/H /CMap findresource
+[/KozGoPro-Bold /CIDFont findresource]
+composefont pop
+%%EndFont
+
+%%BeginFont: KozGoPro-ExtraLight-H
+/KozGoPro-ExtraLight-H
+/H /CMap findresource
+[/KozGoPro-ExtraLight /CIDFont findresource]
+composefont pop
+%%EndFont
+
+%%BeginFont: KozGoPro-Heavy-H
+/KozGoPro-Heavy-H
+/H /CMap findresource
+[/KozGoPro-Heavy /CIDFont findresource]
+composefont pop
+%%EndFont
+
+%%BeginFont: KozGoPro-Light-H
+/KozGoPro-Light-H
+/H /CMap findresource
+[/KozGoPro-Light /CIDFont findresource]
+composefont pop
+%%EndFont
+
+%%BeginFont: KozGoPro-Medium-H
+/KozGoPro-Medium-H
+/H /CMap findresource
+[/KozGoPro-Medium /CIDFont findresource]
+composefont pop
+%%EndFont
+
+%%BeginFont: KozGoPro-Regular-H
+/KozGoPro-Regular-H
+/H /CMap findresource
+[/KozGoPro-Regular /CIDFont findresource]
+composefont pop
+%%EndFont
+
+%%BeginFont: KozMinPr6N-Bold-H
+/KozMinPr6N-Bold-H
+/H /CMap findresource
+[/KozMinPr6N-Bold /CIDFont findresource]
+composefont pop
+%%EndFont
+
+%%BeginFont: KozMinPr6N-ExtraLight-H
+/KozMinPr6N-ExtraLight-H
+/H /CMap findresource
+[/KozMinPr6N-ExtraLight /CIDFont findresource]
+composefont pop
+%%EndFont
+
+%%BeginFont: KozMinPr6N-Heavy-H
+/KozMinPr6N-Heavy-H
+/H /CMap findresource
+[/KozMinPr6N-Heavy /CIDFont findresource]
+composefont pop
+%%EndFont
+
+%%BeginFont: KozMinPr6N-Light-H
+/KozMinPr6N-Light-H
+/H /CMap findresource
+[/KozMinPr6N-Light /CIDFont findresource]
+composefont pop
+%%EndFont
+
+%%BeginFont: KozMinPr6N-Medium-H
+/KozMinPr6N-Medium-H
+/H /CMap findresource
+[/KozMinPr6N-Medium /CIDFont findresource]
+composefont pop
+%%EndFont
+
+%%BeginFont: KozMinPr6N-Regular-H
+/KozMinPr6N-Regular-H
+/H /CMap findresource
+[/KozMinPr6N-Regular /CIDFont findresource]
+composefont pop
+%%EndFont
+
+%%BeginFont: KozMinPro-Bold-H
+/KozMinPro-Bold-H
+/H /CMap findresource
+[/KozMinPro-Bold /CIDFont findresource]
+composefont pop
+%%EndFont
+
+%%BeginFont: KozMinPro-ExtraLight-H
+/KozMinPro-ExtraLight-H
+/H /CMap findresource
+[/KozMinPro-ExtraLight /CIDFont findresource]
+composefont pop
+%%EndFont
+
+%%BeginFont: KozMinPro-Heavy-H
+/KozMinPro-Heavy-H
+/H /CMap findresource
+[/KozMinPro-Heavy /CIDFont findresource]
+composefont pop
+%%EndFont
+
+%%BeginFont: KozMinPro-Light-H
+/KozMinPro-Light-H
+/H /CMap findresource
+[/KozMinPro-Light /CIDFont findresource]
+composefont pop
+%%EndFont
+
+%%BeginFont: KozMinPro-Medium-H
+/KozMinPro-Medium-H
+/H /CMap findresource
+[/KozMinPro-Medium /CIDFont findresource]
+composefont pop
+%%EndFont
+
+%%BeginFont: KozMinPro-Regular-H
+/KozMinPro-Regular-H
+/H /CMap findresource
+[/KozMinPro-Regular /CIDFont findresource]
+composefont pop
+%%EndFont
diff -Nur ghostscript-9.53.3-orig/kanji/vchars.ps ghostscript-9.53.3/kanji/vchars.ps
--- ghostscript-9.53.3-orig/kanji/vchars.ps	Thu Jan 01 09:00:00 1970
+++ ghostscript-9.53.3/kanji/vchars.ps	Sun Jul 18 22:15:38 1999
@@ -0,0 +1,46 @@
+%!PS-Adobe-2.0
+%
+% Sample of Vertical KANJI Characters
+%
+
+/font /Ryumin-Light-V def
+/size 80 def
+/left 50 def
+/right 600 def
+/top 750 def
+
+%
+
+right left sub size idiv size mul 2 div left add /center exch def
+/Times-Roman findfont size 5 div scalefont setfont
+(Vertical KANJI Characters) dup stringwidth pop 2 div center exch sub
+top size 6 div add moveto show
+
+/x left def
+/y top def
+
+font findfont size scalefont setfont
+
+{
+	pop pop
+	x y moveto 
+	size 0 rlineto 0 size neg rlineto size neg 0 rlineto
+	closepath stroke
+	x size 2 div add y moveto
+	1 string dup 0 4 -1 roll put show
+	/x x size add def
+	x size add right gt { /x left def /y y size sub def } if
+}
+
+< 2122 2123 2131 2132 213c 213d 213e 2141
+  2142 2143 2144 2145 214a 214b 214c 214d
+  214e 214f 2150 2151 2152 2153 2154 2155
+  2156 2157 2158 2159 215a 215b 222e 2421
+  2423 2425 2427 2429 2443 2463 2465 2467
+  246e
+                                     2521
+  2523 2525 2527 2529 2543 2563 2565 2567
+  256e 2575 2576 >
+
+cshow
+showpage
diff -Nur ghostscript-9.53.3-orig/kanji/vchars1.ps ghostscript-9.53.3/kanji/vchars1.ps
--- ghostscript-9.53.3-orig/kanji/vchars1.ps	Thu Jan 01 09:00:00 1970
+++ ghostscript-9.53.3/kanji/vchars1.ps	Sun Jul 18 22:15:38 1999
@@ -0,0 +1,55 @@
+%!PS-Adobe-2.0
+%
+% Sample of Vertical KANJI Characters
+%
+
+/font /Ryumin-Light-V def
+/size 80 def
+/left 50 def
+/right 600 def
+/top 750 def
+
+size size scale
+
+currentlinewidth size div setlinewidth
+
+/left left size div def
+/right right size div def
+/top top size div def
+/size 1 def
+
+%
+
+right left sub size mul 2 div left add /center exch def
+/Times-Roman findfont size 5 div scalefont setfont
+(Vertical KANJI Characters) dup stringwidth pop 2 div center exch sub
+top size 6 div add moveto show
+
+/x left def
+/y top def
+
+font findfont size scalefont setfont
+
+{
+	pop pop
+	x y moveto 
+	size 0 rlineto 0 size neg rlineto size neg 0 rlineto
+	closepath stroke
+	x size 2 div add y moveto
+	1 string dup 0 4 -1 roll put show
+	/x x size add def
+	x size add right gt { /x left def /y y size sub def } if
+}
+
+< 2122 2123 2131 2132 213c 213d 213e 2141
+  2142 2143 2144 2145 214a 214b 214c 214d
+  214e 214f 2150 2151 2152 2153 2154 2155
+  2156 2157 2158 2159 215a 215b 222e 2421
+  2423 2425 2427 2429 2443 2463 2465 2467
+  246e
+                                     2521
+  2523 2525 2527 2529 2543 2563 2565 2567
+  256e 2575 2576 >
+
+cshow
+showpage
diff -Nur ghostscript-9.53.3-orig/lcms2mt/src/cmsxform.c ghostscript-9.53.3/lcms2mt/src/cmsxform.c
--- ghostscript-9.53.3-orig/lcms2mt/src/cmsxform.c	Thu Oct 01 17:11:07 2020
+++ ghostscript-9.53.3/lcms2mt/src/cmsxform.c	Thu Oct 01 22:45:20 2020
@@ -1,40 +1,40 @@
-//---------------------------------------------------------------------------------
-//
-//  Little Color Management System
-//  Copyright (c) 1998-2020 Marti Maria Saguer
-//
-// Permission is hereby granted, free of charge, to any person obtaining
-// a copy of this software and associated documentation files (the "Software"),
-// to deal in the Software without restriction, including without limitation
-// the rights to use, copy, modify, merge, publish, distribute, sublicense,
-// and/or sell copies of the Software, and to permit persons to whom the Software
-// is furnished to do so, subject to the following conditions:
-//
-// The above copyright notice and this permission notice shall be included in
-// all copies or substantial portions of the Software.
-//
-// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
-// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO
-// THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
-// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
-// LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
-// OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
-// WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
-//
-//---------------------------------------------------------------------------------
-//
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
 
 #include "lcms2_internal.h"
 
-// Transformations stuff
-// -----------------------------------------------------------------------
+
+
 
 #define DEFAULT_OBSERVER_ADAPTATION_STATE 1.0
 
-// The Context0 observer adaptation state.
+
 _cmsAdaptationStateChunkType _cmsAdaptationStateChunk = { DEFAULT_OBSERVER_ADAPTATION_STATE };
 
-// Init and duplicate observer adaptation state
+
 void _cmsAllocAdaptationStateChunk(struct _cmsContext_struct* ctx,
                                    const struct _cmsContext_struct* src)
 {
@@ -52,61 +52,61 @@
 }
 
 
-// Sets adaptation state for absolute colorimetric intent in the given context.  Adaptation state applies on all
-// but cmsCreateExtendedTransform().  Little CMS can handle incomplete adaptation states.
-// The adaptation state may be defaulted by this function. If you don't like it, use the extended transform routine
+
+
+
 cmsFloat64Number CMSEXPORT cmsSetAdaptationState(cmsContext ContextID, cmsFloat64Number d)
 {
     cmsFloat64Number prev;
     _cmsAdaptationStateChunkType* ptr = (_cmsAdaptationStateChunkType*) _cmsContextGetClientChunk(ContextID, AdaptationStateContext);
 
-    // Get previous value for return
+    
     prev = ptr ->AdaptationState;
 
-    // Set the value if d is positive or zero
+    
     if (d >= 0.0) {
 
         ptr ->AdaptationState = d;
     }
 
-    // Always return previous value
+    
     return prev;
 }
 
 
-// -----------------------------------------------------------------------
 
-// Alarm codes for 16-bit transformations, because the fixed range of containers there are
-// no values left to mark out of gamut.
+
+
+
 
 #define DEFAULT_ALARM_CODES_VALUE {0x7F00, 0x7F00, 0x7F00, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}
 
 _cmsAlarmCodesChunkType _cmsAlarmCodesChunk = { DEFAULT_ALARM_CODES_VALUE };
 
-// Sets the codes used to mark out-out-gamut on Proofing transforms for a given context. Values are meant to be
-// encoded in 16 bits.
+
+
 void CMSEXPORT cmsSetAlarmCodes(cmsContext ContextID, const cmsUInt16Number AlarmCodesP[cmsMAXCHANNELS])
 {
     _cmsAlarmCodesChunkType* ContextAlarmCodes = (_cmsAlarmCodesChunkType*) _cmsContextGetClientChunk(ContextID, AlarmCodesContext);
 
-    _cmsAssert(ContextAlarmCodes != NULL); // Can't happen
+    _cmsAssert(ContextAlarmCodes != NULL); 
 
     memcpy(ContextAlarmCodes->AlarmCodes, AlarmCodesP, sizeof(ContextAlarmCodes->AlarmCodes));
 }
 
-// Gets the current codes used to mark out-out-gamut on Proofing transforms for the given context.
-// Values are meant to be encoded in 16 bits.
+
+
 void CMSEXPORT cmsGetAlarmCodes(cmsContext ContextID, cmsUInt16Number AlarmCodesP[cmsMAXCHANNELS])
 {
     _cmsAlarmCodesChunkType* ContextAlarmCodes = (_cmsAlarmCodesChunkType*) _cmsContextGetClientChunk(ContextID, AlarmCodesContext);
 
-    _cmsAssert(ContextAlarmCodes != NULL); // Can't happen
+    _cmsAssert(ContextAlarmCodes != NULL); 
 
     memcpy(AlarmCodesP, ContextAlarmCodes->AlarmCodes, sizeof(ContextAlarmCodes->AlarmCodes));
 }
 
 
-// Init and duplicate alarm codes
+
 void _cmsAllocAlarmCodesChunk(struct _cmsContext_struct* ctx,
                               const struct _cmsContext_struct* src)
 {
@@ -123,9 +123,9 @@
     ctx ->chunks[AlarmCodesContext] = _cmsSubAllocDup(ctx ->MemPool, from, sizeof(_cmsAlarmCodesChunkType));
 }
 
-// -----------------------------------------------------------------------
 
-// Get rid of transform resources
+
+
 void CMSEXPORT cmsDeleteTransform(cmsContext ContextID, cmsHTRANSFORM hTransform)
 {
     _cmsTRANSFORM* p = (_cmsTRANSFORM*) hTransform;
@@ -172,18 +172,18 @@
 {
     cmsUInt32Number fmt_bytes = T_BYTES(Format);
 
-    // For double, the T_BYTES field is zero
+    
     if (fmt_bytes == 0)
         return sizeof(cmsUInt64Number);
 
-    // Otherwise, it is already correct for all formats
+    
     return fmt_bytes;
 }
 
 
 
 
-// Apply transform.
+
 void CMSEXPORT cmsDoTransform(cmsContext ContextID, cmsHTRANSFORM  Transform,
                               const void* InputBuffer,
                               void* OutputBuffer,
@@ -193,7 +193,7 @@
     _cmsTRANSFORM* p = (_cmsTRANSFORM*) Transform;
     cmsStride stride;
 
-    stride.BytesPerLineIn = 0;  // Not used
+    stride.BytesPerLineIn = 0;  
     stride.BytesPerLineOut = 0;
     stride.BytesPerPlaneIn = Size * PixelSize(p->InputFormat);
     stride.BytesPerPlaneOut = Size * PixelSize(p->OutputFormat);
@@ -202,7 +202,7 @@
 }
 
 
-// This is a legacy stride for planar
+
 void CMSEXPORT cmsDoTransformStride(cmsContext ContextID, cmsHTRANSFORM  Transform,
                               const void* InputBuffer,
                               void* OutputBuffer,
@@ -220,7 +220,7 @@
     p -> xform(ContextID, p, InputBuffer, OutputBuffer, Size, 1, &stride);
 }
 
-// This is the "fast" function for plugins
+
 void CMSEXPORT cmsDoTransformLineStride(cmsContext ContextID, cmsHTRANSFORM  Transform,
                               const void* InputBuffer,
                               void* OutputBuffer,
@@ -245,10 +245,10 @@
 
 
 
-// Transform routines ----------------------------------------------------------------------------------------------------------
 
-// Float xform converts floats. Since there are no performance issues, one routine does all job, including gamut check.
-// Note that because extended range, we can use a -1.0 value for out of gamut in this case.
+
+
+
 static
 void FloatXFORM(cmsContext ContextID, _cmsTRANSFORM* p,
                 const void* in,
@@ -280,28 +280,28 @@
 
             accum = p->FromInputFloat(ContextID, p, fIn, accum, Stride->BytesPerPlaneIn);
 
-            // Any gamut chack to do?
+            
             if (core->GamutCheck != NULL) {
 
-                // Evaluate gamut marker.
+                
                 cmsPipelineEvalFloat(ContextID, fIn, &OutOfGamut, core->GamutCheck);
 
-                // Is current color out of gamut?
+                
                 if (OutOfGamut > 0.0) {
 
-                    // Certainly, out of gamut
+                    
                     for (c = 0; c < cmsMAXCHANNELS; c++)
                         fOut[c] = -1.0;
 
                 }
                 else {
-                    // No, proceed normally
+                    
                     cmsPipelineEvalFloat(ContextID, fIn, fOut, core->Lut);
                 }
             }
             else {
 
-                // No gamut check at all
+                
                 cmsPipelineEvalFloat(ContextID, fIn, fOut, core->Lut);
             }
 
@@ -352,9 +352,9 @@
     }
 }
 
-// 16 bit precision -----------------------------------------------------------------------------------------------------------
 
-// Null transformation, only applies formatters. No cache
+
+
 static
 void NullXFORM(cmsContext ContextID,
                _cmsTRANSFORM* p,
@@ -393,11 +393,11 @@
 }
 
 
-// No gamut check, no cache, 16 bits
+
 #define FUNCTION_NAME PrecalculatedXFORM
 #include "extra_xform.h"
 
-// No gamut check, no cache, Identity transform, including pack/unpack
+
 static
 void PrecalculatedXFORMIdentity(cmsContext ContextID,
                                 _cmsTRANSFORM* p,
@@ -480,7 +480,7 @@
     }
 }
 
-// Auxiliary: Handle precalculated gamut check. The retrieval of context may be alittle bit slow, but this function is not critical.
+
 static
 void TransformOnePixelWithGamutCheck(cmsContext ContextID, _cmsTRANSFORM* p,
                                      const cmsUInt16Number wIn[],
@@ -505,37 +505,37 @@
         core->Lut->Eval16Fn(ContextID, wIn, wOut, core->Lut->Data);
 }
 
-// Gamut check, No cache, 16 bits.
+
 #define FUNCTION_NAME PrecalculatedXFORMGamutCheck
 #define GAMUTCHECK
 #include "extra_xform.h"
 
-// No gamut check, Cache, 16 bits,
+
 #define FUNCTION_NAME CachedXFORM
 #define CACHED
 #include "extra_xform.h"
 
-// All those nice features together
+
 #define FUNCTION_NAME CachedXFORMGamutCheck
 #define CACHED
 #define GAMUTCHECK
 #include "extra_xform.h"
 
-// No gamut check, Cache, 16 bits, <= 4 bytes
+
 #define FUNCTION_NAME CachedXFORM4
 #define CACHED
 #define INBYTES 4
 #define EXTRABYTES 0
 #include "extra_xform.h"
 
-// No gamut check, Cache, 16 bits, <= 8 bytes total
+
 #define FUNCTION_NAME CachedXFORM8
 #define CACHED
 #define INBYTES 8
 #define EXTRABYTES 0
 #include "extra_xform.h"
 
-// Special ones for common cases.
+
 #define FUNCTION_NAME CachedXFORM1to1
 #define CACHED
 #define INBYTES 2
@@ -848,23 +848,23 @@
 } while (0)
 #include "extra_xform.h"
 
-// Transform plug-ins ----------------------------------------------------------------------------------------------------
 
-// List of used-defined transform factories
+
+
 typedef struct _cmsTransformCollection_st {
 
     _cmsTransform2Factory  Factory;
-    cmsBool                OldXform;   // Factory returns xform function in the old style
+    cmsBool                OldXform;   
 
     struct _cmsTransformCollection_st *Next;
 
 } _cmsTransformCollection;
 
-// The linked list head
+
 _cmsTransformPluginChunkType _cmsTransformPluginChunk = { NULL };
 
 
-// Duplicates the zone of memory used by the plug-in in the new context
+
 static
 void DupPluginTransformList(struct _cmsContext_struct* ctx,
                                                const struct _cmsContext_struct* src)
@@ -874,7 +874,7 @@
    _cmsTransformCollection*  Anterior = NULL;
    _cmsTransformPluginChunkType* head = (_cmsTransformPluginChunkType*) src->chunks[TransformPlugin];
 
-    // Walk the list copying all nodes
+    
    for (entry = head->TransformCollection;
         entry != NULL;
         entry = entry ->Next) {
@@ -884,7 +884,7 @@
             if (newEntry == NULL)
                 return;
 
-            // We want to keep the linked list order, so this is a little bit tricky
+            
             newEntry -> Next = NULL;
             if (Anterior)
                 Anterior -> Next = newEntry;
@@ -898,13 +898,13 @@
   ctx ->chunks[TransformPlugin] = _cmsSubAllocDup(ctx->MemPool, &newHead, sizeof(_cmsTransformPluginChunkType));
 }
 
-// Allocates memory for transform plugin factory
+
 void _cmsAllocTransformPluginChunk(struct _cmsContext_struct* ctx,
                                         const struct _cmsContext_struct* src)
 {
     if (src != NULL) {
 
-        // Copy all linked list
+        
         DupPluginTransformList(ctx, src);
     }
     else {
@@ -913,7 +913,7 @@
     }
 }
 
-// Adaptor for old versions of plug-in
+
 static
 void _cmsTransform2toTransformAdaptor(cmsContext ContextID, struct _cmstransform_struct *CMMcargo,
                                       const void* InputBuffer,
@@ -944,7 +944,7 @@
 
 
 
-// Register new ways to transform
+
 cmsBool  _cmsRegisterTransformPlugin(cmsContext ContextID, cmsPluginBase* Data)
 {
     cmsPluginTransform* Plugin = (cmsPluginTransform*) Data;
@@ -953,19 +953,19 @@
 
     if (Data == NULL) {
 
-        // Free the chain. Memory is safely freed at exit
+        
         ctx->TransformCollection = NULL;
         return TRUE;
     }
 
-    // Factory callback is required
+    
     if (Plugin->factories.xform == NULL) return FALSE;
 
 
     fl = (_cmsTransformCollection*) _cmsPluginMalloc(ContextID, sizeof(_cmsTransformCollection));
     if (fl == NULL) return FALSE;
 
-    // Check for full xform plug-ins previous to 2.8, we would need an adapter in that case
+    
     if (Plugin->base.ExpectedVersion < 2080-2000) {
 
            fl->OldXform = TRUE;
@@ -973,14 +973,14 @@
     else
            fl->OldXform = FALSE;
 
-    // Copy the parameters
+    
     fl->Factory = Plugin->factories.xform;
 
-    // Keep linked list
+    
     fl ->Next = ctx->TransformCollection;
     ctx->TransformCollection = fl;
 
-    // All is ok
+    
     return TRUE;
 }
 
@@ -992,14 +992,14 @@
     CMMcargo->core->FreeUserData = FreePrivateDataFn;
 }
 
-// returns the pointer defined by the plug-in to store private data
+
 void * CMSEXPORT _cmsGetTransformUserData(struct _cmstransform_struct *CMMcargo)
 {
     _cmsAssert(CMMcargo != NULL && CMMcargo->core != NULL);
     return CMMcargo->core->UserData;
 }
 
-// returns the current formatters
+
 void CMSEXPORT _cmsGetTransformFormatters16(struct _cmstransform_struct *CMMcargo, cmsFormatter16* FromInput, cmsFormatter16* ToOutput)
 {
      _cmsAssert(CMMcargo != NULL);
@@ -1024,7 +1024,7 @@
     }
     if (dwFlags & cmsFLAGS_NOCACHE) {
         if (dwFlags & cmsFLAGS_GAMUTCHECK)
-            p ->xform = PrecalculatedXFORMGamutCheck;  // Gamut check, no cache
+            p ->xform = PrecalculatedXFORMGamutCheck;  
         else if ((InputFormat & ~COLORSPACE_SH(31)) == (OutputFormat & ~COLORSPACE_SH(31)) &&
                  _cmsLutIsIdentity(p->core->Lut)) {
             if (T_PLANAR(InputFormat))
@@ -1032,11 +1032,11 @@
             else
                 p ->xform = PrecalculatedXFORMIdentity;
         } else
-            p ->xform = PrecalculatedXFORM;  // No cache, no gamut check
+            p ->xform = PrecalculatedXFORM;  
 	return;
     }
     if (dwFlags & cmsFLAGS_GAMUTCHECK) {
-        p ->xform = CachedXFORMGamutCheck;    // Gamut check, cache
+        p ->xform = CachedXFORMGamutCheck;    
 	return;
     }
     if ((InputFormat & ~COLORSPACE_SH(31)) == (OutputFormat & ~COLORSPACE_SH(31)) &&
@@ -1049,7 +1049,7 @@
         return;
     }
     if (T_EXTRA(InputFormat) != 0) {
-        p ->xform = CachedXFORM;  // No gamut check, cache
+        p ->xform = CachedXFORM;  
         return;
     }
     if ((InputFormat & ~(COLORSPACE_SH(31)|CHANNELS_SH(7)|BYTES_SH(3))) == 0 &&
@@ -1119,12 +1119,12 @@
         else if (inwords <= 4)
             p ->xform = CachedXFORM8;
         else
-            p ->xform = CachedXFORM;  // No gamut check, cache
+            p ->xform = CachedXFORM;  
     }
 }
 
-// Allocate transform struct and set it to defaults. Ask the optimization plug-in about if those formats are proper
-// for separated transforms. If this is the case,
+
+
 static
 _cmsTRANSFORM* AllocEmptyTransform(cmsContext ContextID, cmsPipeline* lut,
                                                cmsUInt32Number Intent, cmsUInt32Number* InputFormat, cmsUInt32Number* OutputFormat, cmsUInt32Number* dwFlags)
@@ -1133,7 +1133,7 @@
     _cmsTransformCollection* Plugin;
     _cmsTRANSFORMCORE *core;
 
-    // Allocate needed memory
+    
     _cmsTRANSFORM* p = (_cmsTRANSFORM*)_cmsMallocZero(ContextID, sizeof(_cmsTRANSFORM));
     if (!p) {
         cmsPipelineFree(ContextID, lut);
@@ -1149,10 +1149,10 @@
 
     p->core = core;
     core->refs = 1;
-    // Store the proposed pipeline
+    
     p->core->Lut = lut;
 
-       // Let's see if any plug-in want to do the transform by itself
+       
        if (core->Lut != NULL && !(*dwFlags & cmsFLAGS_NOOPTIMIZE)) {
 
               for (Plugin = ctx->TransformCollection;
@@ -1161,25 +1161,25 @@
 
                      if (Plugin->Factory(ContextID, &p->xform, &core->UserData, &core->FreeUserData, &core->Lut, InputFormat, OutputFormat, dwFlags)) {
 
-                            // Last plugin in the declaration order takes control. We just keep
-                            // the original parameters as a logging.
-                            // Note that cmsFLAGS_CAN_CHANGE_FORMATTER is not set, so by default
-                            // an optimized transform is not reusable. The plug-in can, however, change
-                            // the flags and make it suitable.
+                            
+                            
+                            
+                            
+                            
 
                             p->InputFormat = *InputFormat;
                             p->OutputFormat = *OutputFormat;
                             core->dwOriginalFlags = *dwFlags;
 
-                            // Fill the formatters just in case the optimized routine is interested.
-                            // No error is thrown if the formatter doesn't exist. It is up to the optimization
-                            // factory to decide what to do in those cases.
+                            
+                            
+                            
                             p->FromInput = _cmsGetFormatter(ContextID, *InputFormat, cmsFormatterInput, CMS_PACK_FLAGS_16BITS).Fmt16;
                             p->ToOutput = _cmsGetFormatter(ContextID, *OutputFormat, cmsFormatterOutput, CMS_PACK_FLAGS_16BITS).Fmt16;
                             p->FromInputFloat = _cmsGetFormatter(ContextID, *InputFormat, cmsFormatterInput, CMS_PACK_FLAGS_FLOAT).FmtFloat;
                             p->ToOutputFloat = _cmsGetFormatter(ContextID, *OutputFormat, cmsFormatterOutput, CMS_PACK_FLAGS_FLOAT).FmtFloat;
 
-                            // Save the day? (Ignore the warning)
+                            
                             if (Plugin->OldXform) {
                                    p->OldXform = (_cmsTransformFn)(void*) p->xform;
                                    p->xform = _cmsTransform2toTransformAdaptor;
@@ -1188,14 +1188,14 @@
                      }
               }
 
-              // Not suitable for the transform plug-in, let's check the pipeline plug-in
+              
               _cmsOptimizePipeline(ContextID, &core->Lut, Intent, InputFormat, OutputFormat, dwFlags);
        }
 
-    // Check whatever this is a true floating point transform
+    
     if (_cmsFormatterIsFloat(*InputFormat) && _cmsFormatterIsFloat(*OutputFormat)) {
 
-        // Get formatter function always return a valid union, but the contents of this union may be NULL.
+        
         p ->FromInputFloat = _cmsGetFormatter(ContextID, *InputFormat,  cmsFormatterInput, CMS_PACK_FLAGS_FLOAT).FmtFloat;
         p ->ToOutputFloat  = _cmsGetFormatter(ContextID, *OutputFormat, cmsFormatterOutput, CMS_PACK_FLAGS_FLOAT).FmtFloat;
         *dwFlags |= cmsFLAGS_CAN_CHANGE_FORMATTER;
@@ -1212,7 +1212,7 @@
             p ->xform = NullFloatXFORM;
         }
         else {
-            // Float transforms don't use cache, always are non-NULL
+            
             p ->xform = FloatXFORM;
         }
 
@@ -1305,7 +1305,7 @@
     return TRUE;
 }
 
-// Check colorspace
+
 static
 cmsBool  IsProperColorSpace(cmsContext ContextID, cmsColorSpaceSignature Check, cmsUInt32Number dwFormat)
 {
@@ -1321,10 +1321,10 @@
     return FALSE;
 }
 
-// ----------------------------------------------------------------------------------------------------------------
 
-// Jun-21-2000: Some profiles (those that comes with W2K) comes
-// with the media white (media black?) x 100. Add a sanity check
+
+
+
 
 static
 void NormalizeXYZ(cmsCIEXYZ* Dest)
@@ -1357,7 +1357,7 @@
 
 }
 
-// New to lcms 2.0 -- have all parameters available.
+
 cmsHTRANSFORM CMSEXPORT cmsCreateExtendedTransform(cmsContext ContextID,
                                                    cmsUInt32Number nProfiles, cmsHPROFILE hProfiles[],
                                                    cmsBool  BPC[],
@@ -1375,28 +1375,28 @@
     cmsPipeline* Lut;
     cmsUInt32Number LastIntent = Intents[nProfiles-1];
 
-    // If it is a fake transform
+    
     if (dwFlags & cmsFLAGS_NULLTRANSFORM)
     {
         return AllocEmptyTransform(ContextID, NULL, INTENT_PERCEPTUAL, &InputFormat, &OutputFormat, &dwFlags);
     }
 
-    // If gamut check is requested, make sure we have a gamut profile
+    
     if (dwFlags & cmsFLAGS_GAMUTCHECK) {
         if (hGamutProfile == NULL) dwFlags &= ~cmsFLAGS_GAMUTCHECK;
     }
 
-    // On floating point transforms, inhibit cache
+    
     if (_cmsFormatterIsFloat(InputFormat) || _cmsFormatterIsFloat(OutputFormat))
         dwFlags |= cmsFLAGS_NOCACHE;
 
-    // Mark entry/exit spaces
+    
     if (!GetXFormColorSpaces(ContextID, nProfiles, hProfiles, &EntryColorSpace, &ExitColorSpace)) {
         cmsSignalError(ContextID, cmsERROR_NULL, "NULL input profiles on transform");
         return NULL;
     }
 
-    // Check if proper colorspaces
+    
     if (!IsProperColorSpace(ContextID, EntryColorSpace, InputFormat)) {
         cmsSignalError(ContextID, cmsERROR_COLORSPACE_CHECK, "Wrong input color space on transform");
         return NULL;
@@ -1407,14 +1407,14 @@
         return NULL;
     }
 
-    // Create a pipeline with all transformations
+    
     Lut = _cmsLinkProfiles(ContextID, nProfiles, Intents, hProfiles, BPC, AdaptationStates, dwFlags);
     if (Lut == NULL) {
         cmsSignalError(ContextID, cmsERROR_NOT_SUITABLE, "Couldn't link the profiles");
         return NULL;
     }
 
-    // Check channel count
+    
     if ((cmsChannelsOf(ContextID, EntryColorSpace) != cmsPipelineInputChannels(ContextID, Lut)) ||
         (cmsChannelsOf(ContextID, ExitColorSpace)  != cmsPipelineOutputChannels(ContextID, Lut))) {
         cmsPipelineFree(ContextID, Lut);
@@ -1423,23 +1423,23 @@
     }
 
 
-    // All seems ok
+    
     xform = AllocEmptyTransform(ContextID, Lut, LastIntent, &InputFormat, &OutputFormat, &dwFlags);
     if (xform == NULL) {
         return NULL;
     }
 
-    // Keep values
+    
     xform->core->EntryColorSpace = EntryColorSpace;
     xform->core->ExitColorSpace  = ExitColorSpace;
     xform->core->RenderingIntent = Intents[nProfiles-1];
 
-    // Take white points
+    
     SetWhitePoint(&xform->core->EntryWhitePoint, (cmsCIEXYZ*) cmsReadTag(ContextID, hProfiles[0], cmsSigMediaWhitePointTag));
     SetWhitePoint(&xform->core->ExitWhitePoint,  (cmsCIEXYZ*) cmsReadTag(ContextID, hProfiles[nProfiles-1], cmsSigMediaWhitePointTag));
 
 
-    // Create a gamut check LUT if requested
+    
     if (hGamutProfile != NULL && (dwFlags & cmsFLAGS_GAMUTCHECK))
         xform->core->GamutCheck  = _cmsCreateGamutCheckPipeline(ContextID, hProfiles,
                                                         BPC, Intents,
@@ -1448,20 +1448,20 @@
                                                         hGamutProfile);
 
 
-    // Try to read input and output colorant table
+    
     if (cmsIsTag(ContextID, hProfiles[0], cmsSigColorantTableTag)) {
 
-        // Input table can only come in this way.
+        
         xform->core->InputColorant = cmsDupNamedColorList(ContextID, (cmsNAMEDCOLORLIST*) cmsReadTag(ContextID, hProfiles[0], cmsSigColorantTableTag));
     }
 
-    // Output is a little bit more complex.
+    
     if (cmsGetDeviceClass(ContextID, hProfiles[nProfiles-1]) == cmsSigLinkClass) {
 
-        // This tag may exist only on devicelink profiles.
+        
         if (cmsIsTag(ContextID, hProfiles[nProfiles-1], cmsSigColorantTableOutTag)) {
 
-            // It may be NULL if error
+            
             xform->core->OutputColorant = cmsDupNamedColorList(ContextID, (cmsNAMEDCOLORLIST*) cmsReadTag(ContextID, hProfiles[nProfiles-1], cmsSigColorantTableOutTag));
         }
 
@@ -1473,14 +1473,14 @@
         }
     }
 
-    // Store the sequence of profiles
+    
     if (dwFlags & cmsFLAGS_KEEP_SEQUENCE) {
         xform->core->Sequence = _cmsCompileProfileSequence(ContextID, nProfiles, hProfiles);
     }
     else
         xform->core->Sequence = NULL;
 
-    // If this is a cached transform, init first value, which is zero (16 bits only)
+    
     if (!(dwFlags & cmsFLAGS_NOCACHE)) {
 
         memset(&xform ->Cache.CacheIn, 0, sizeof(xform ->Cache.CacheIn));
@@ -1498,7 +1498,7 @@
     return (cmsHTRANSFORM) xform;
 }
 
-// Multiprofile transforms: Gamut check is not available here, as it is unclear from which profile the gamut comes.
+
 cmsHTRANSFORM CMSEXPORT cmsCreateMultiprofileTransform(cmsContext ContextID,
                                                        cmsHPROFILE hProfiles[],
                                                        cmsUInt32Number nProfiles,
@@ -1580,7 +1580,7 @@
 
 
 
-// Grab the input/output formats
+
 cmsUInt32Number CMSEXPORT cmsGetTransformInputFormat(cmsContext ContextID, cmsHTRANSFORM hTransform)
 {
     _cmsTRANSFORM* xform = (_cmsTRANSFORM*) hTransform;
@@ -1610,7 +1610,7 @@
 
     _cmsAssert(oldXform != NULL && oldXform->core != NULL);
 
-    // We only can afford to change formatters if previous transform is at least 16 bits
+    
     if (!(oldXform->core->dwOriginalFlags & cmsFLAGS_CAN_CHANGE_FORMATTER)) {
         cmsSignalError(ContextID, cmsERROR_NOT_SUITABLE, "cmsCloneTransformChangingFormats works only on transforms created originally with at least 16 bits of precision");
         return NULL;
diff -Nur ghostscript-9.53.3-orig/lcms2mt/src/cmsxform.c.orig ghostscript-9.53.3/lcms2mt/src/cmsxform.c.orig
--- ghostscript-9.53.3-orig/lcms2mt/src/cmsxform.c.orig	Thu Jan 01 09:00:00 1970
+++ ghostscript-9.53.3/lcms2mt/src/cmsxform.c.orig	Thu Oct 01 17:11:07 2020
@@ -0,0 +1,1643 @@
+//---------------------------------------------------------------------------------
+//
+//  Little Color Management System
+//  Copyright (c) 1998-2020 Marti Maria Saguer
+//
+// Permission is hereby granted, free of charge, to any person obtaining
+// a copy of this software and associated documentation files (the "Software"),
+// to deal in the Software without restriction, including without limitation
+// the rights to use, copy, modify, merge, publish, distribute, sublicense,
+// and/or sell copies of the Software, and to permit persons to whom the Software
+// is furnished to do so, subject to the following conditions:
+//
+// The above copyright notice and this permission notice shall be included in
+// all copies or substantial portions of the Software.
+//
+// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO
+// THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
+// LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
+// OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
+// WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+//
+//---------------------------------------------------------------------------------
+//
+
+#include "lcms2_internal.h"
+
+// Transformations stuff
+// -----------------------------------------------------------------------
+
+#define DEFAULT_OBSERVER_ADAPTATION_STATE 1.0
+
+// The Context0 observer adaptation state.
+_cmsAdaptationStateChunkType _cmsAdaptationStateChunk = { DEFAULT_OBSERVER_ADAPTATION_STATE };
+
+// Init and duplicate observer adaptation state
+void _cmsAllocAdaptationStateChunk(struct _cmsContext_struct* ctx,
+                                   const struct _cmsContext_struct* src)
+{
+    static _cmsAdaptationStateChunkType AdaptationStateChunk = { DEFAULT_OBSERVER_ADAPTATION_STATE };
+    void* from;
+
+    if (src != NULL) {
+        from = src ->chunks[AdaptationStateContext];
+    }
+    else {
+       from = &AdaptationStateChunk;
+    }
+
+    ctx ->chunks[AdaptationStateContext] = _cmsSubAllocDup(ctx ->MemPool, from, sizeof(_cmsAdaptationStateChunkType));
+}
+
+
+// Sets adaptation state for absolute colorimetric intent in the given context.  Adaptation state applies on all
+// but cmsCreateExtendedTransform().  Little CMS can handle incomplete adaptation states.
+// The adaptation state may be defaulted by this function. If you don't like it, use the extended transform routine
+cmsFloat64Number CMSEXPORT cmsSetAdaptationState(cmsContext ContextID, cmsFloat64Number d)
+{
+    cmsFloat64Number prev;
+    _cmsAdaptationStateChunkType* ptr = (_cmsAdaptationStateChunkType*) _cmsContextGetClientChunk(ContextID, AdaptationStateContext);
+
+    // Get previous value for return
+    prev = ptr ->AdaptationState;
+
+    // Set the value if d is positive or zero
+    if (d >= 0.0) {
+
+        ptr ->AdaptationState = d;
+    }
+
+    // Always return previous value
+    return prev;
+}
+
+
+// -----------------------------------------------------------------------
+
+// Alarm codes for 16-bit transformations, because the fixed range of containers there are
+// no values left to mark out of gamut.
+
+#define DEFAULT_ALARM_CODES_VALUE {0x7F00, 0x7F00, 0x7F00, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}
+
+_cmsAlarmCodesChunkType _cmsAlarmCodesChunk = { DEFAULT_ALARM_CODES_VALUE };
+
+// Sets the codes used to mark out-out-gamut on Proofing transforms for a given context. Values are meant to be
+// encoded in 16 bits.
+void CMSEXPORT cmsSetAlarmCodes(cmsContext ContextID, const cmsUInt16Number AlarmCodesP[cmsMAXCHANNELS])
+{
+    _cmsAlarmCodesChunkType* ContextAlarmCodes = (_cmsAlarmCodesChunkType*) _cmsContextGetClientChunk(ContextID, AlarmCodesContext);
+
+    _cmsAssert(ContextAlarmCodes != NULL); // Can't happen
+
+    memcpy(ContextAlarmCodes->AlarmCodes, AlarmCodesP, sizeof(ContextAlarmCodes->AlarmCodes));
+}
+
+// Gets the current codes used to mark out-out-gamut on Proofing transforms for the given context.
+// Values are meant to be encoded in 16 bits.
+void CMSEXPORT cmsGetAlarmCodes(cmsContext ContextID, cmsUInt16Number AlarmCodesP[cmsMAXCHANNELS])
+{
+    _cmsAlarmCodesChunkType* ContextAlarmCodes = (_cmsAlarmCodesChunkType*) _cmsContextGetClientChunk(ContextID, AlarmCodesContext);
+
+    _cmsAssert(ContextAlarmCodes != NULL); // Can't happen
+
+    memcpy(AlarmCodesP, ContextAlarmCodes->AlarmCodes, sizeof(ContextAlarmCodes->AlarmCodes));
+}
+
+
+// Init and duplicate alarm codes
+void _cmsAllocAlarmCodesChunk(struct _cmsContext_struct* ctx,
+                              const struct _cmsContext_struct* src)
+{
+    static _cmsAlarmCodesChunkType AlarmCodesChunk = { DEFAULT_ALARM_CODES_VALUE };
+    void* from;
+
+    if (src != NULL) {
+        from = src ->chunks[AlarmCodesContext];
+    }
+    else {
+       from = &AlarmCodesChunk;
+    }
+
+    ctx ->chunks[AlarmCodesContext] = _cmsSubAllocDup(ctx ->MemPool, from, sizeof(_cmsAlarmCodesChunkType));
+}
+
+// -----------------------------------------------------------------------
+
+// Get rid of transform resources
+void CMSEXPORT cmsDeleteTransform(cmsContext ContextID, cmsHTRANSFORM hTransform)
+{
+    _cmsTRANSFORM* p = (_cmsTRANSFORM*) hTransform;
+    _cmsTRANSFORMCORE *core;
+    cmsUInt32Number refs;
+
+    if (p == NULL)
+        return;
+
+    core = p->core;
+
+    _cmsAssert(core != NULL);
+
+    refs = _cmsAdjustReferenceCount(&core->refs, -1);
+    _cmsFree(ContextID, (void *) p);
+
+    if (refs != 0)
+        return;
+
+    if (core->GamutCheck)
+        cmsPipelineFree(ContextID, core->GamutCheck);
+
+    if (core->Lut)
+        cmsPipelineFree(ContextID, core->Lut);
+
+    if (core->InputColorant)
+        cmsFreeNamedColorList(ContextID, core->InputColorant);
+
+    if (core->OutputColorant)
+        cmsFreeNamedColorList(ContextID, core->OutputColorant);
+
+    if (core->Sequence)
+        cmsFreeProfileSequenceDescription(ContextID, core->Sequence);
+
+    if (core->UserData)
+        core->FreeUserData(ContextID, core->UserData);
+
+    _cmsFree(ContextID, (void *)core);
+}
+
+
+static
+cmsUInt32Number PixelSize(cmsUInt32Number Format)
+{
+    cmsUInt32Number fmt_bytes = T_BYTES(Format);
+
+    // For double, the T_BYTES field is zero
+    if (fmt_bytes == 0)
+        return sizeof(cmsUInt64Number);
+
+    // Otherwise, it is already correct for all formats
+    return fmt_bytes;
+}
+
+
+
+
+// Apply transform.
+void CMSEXPORT cmsDoTransform(cmsContext ContextID, cmsHTRANSFORM  Transform,
+                              const void* InputBuffer,
+                              void* OutputBuffer,
+                              cmsUInt32Number Size)
+
+{
+    _cmsTRANSFORM* p = (_cmsTRANSFORM*) Transform;
+    cmsStride stride;
+
+    stride.BytesPerLineIn = 0;  // Not used
+    stride.BytesPerLineOut = 0;
+    stride.BytesPerPlaneIn = Size * PixelSize(p->InputFormat);
+    stride.BytesPerPlaneOut = Size * PixelSize(p->OutputFormat);
+
+    p -> xform(ContextID, p, InputBuffer, OutputBuffer, Size, 1, &stride);
+}
+
+
+// This is a legacy stride for planar
+void CMSEXPORT cmsDoTransformStride(cmsContext ContextID, cmsHTRANSFORM  Transform,
+                              const void* InputBuffer,
+                              void* OutputBuffer,
+                              cmsUInt32Number Size, cmsUInt32Number Stride)
+
+{
+    _cmsTRANSFORM* p = (_cmsTRANSFORM*) Transform;
+    cmsStride stride;
+
+    stride.BytesPerLineIn = 0;
+    stride.BytesPerLineOut = 0;
+    stride.BytesPerPlaneIn = Stride;
+    stride.BytesPerPlaneOut = Stride;
+
+    p -> xform(ContextID, p, InputBuffer, OutputBuffer, Size, 1, &stride);
+}
+
+// This is the "fast" function for plugins
+void CMSEXPORT cmsDoTransformLineStride(cmsContext ContextID, cmsHTRANSFORM  Transform,
+                              const void* InputBuffer,
+                              void* OutputBuffer,
+                              cmsUInt32Number PixelsPerLine,
+                              cmsUInt32Number LineCount,
+                              cmsUInt32Number BytesPerLineIn,
+                              cmsUInt32Number BytesPerLineOut,
+                              cmsUInt32Number BytesPerPlaneIn,
+                              cmsUInt32Number BytesPerPlaneOut)
+
+{
+    _cmsTRANSFORM* p = (_cmsTRANSFORM*) Transform;
+    cmsStride stride;
+
+    stride.BytesPerLineIn = BytesPerLineIn;
+    stride.BytesPerLineOut = BytesPerLineOut;
+    stride.BytesPerPlaneIn = BytesPerPlaneIn;
+    stride.BytesPerPlaneOut = BytesPerPlaneOut;
+
+    p->xform(ContextID, p, InputBuffer, OutputBuffer, PixelsPerLine, LineCount, &stride);
+}
+
+
+
+// Transform routines ----------------------------------------------------------------------------------------------------------
+
+// Float xform converts floats. Since there are no performance issues, one routine does all job, including gamut check.
+// Note that because extended range, we can use a -1.0 value for out of gamut in this case.
+static
+void FloatXFORM(cmsContext ContextID, _cmsTRANSFORM* p,
+                const void* in,
+                void* out,
+                cmsUInt32Number PixelsPerLine,
+                cmsUInt32Number LineCount,
+                const cmsStride* Stride)
+{
+    cmsUInt8Number* accum;
+    cmsUInt8Number* output;
+    cmsFloat32Number fIn[cmsMAXCHANNELS], fOut[cmsMAXCHANNELS];
+    cmsFloat32Number OutOfGamut;
+    cmsUInt32Number i, j, c, strideIn, strideOut;
+    _cmsTRANSFORMCORE *core = p->core;
+
+    _cmsHandleExtraChannels(ContextID, p, in, out, PixelsPerLine, LineCount, Stride);
+
+    strideIn = 0;
+    strideOut = 0;
+    memset(fIn, 0, sizeof(fIn));
+    memset(fOut, 0, sizeof(fIn));
+
+    for (i = 0; i < LineCount; i++) {
+
+        accum = (cmsUInt8Number*)in + strideIn;
+        output = (cmsUInt8Number*)out + strideOut;
+
+        for (j = 0; j < PixelsPerLine; j++) {
+
+            accum = p->FromInputFloat(ContextID, p, fIn, accum, Stride->BytesPerPlaneIn);
+
+            // Any gamut chack to do?
+            if (core->GamutCheck != NULL) {
+
+                // Evaluate gamut marker.
+                cmsPipelineEvalFloat(ContextID, fIn, &OutOfGamut, core->GamutCheck);
+
+                // Is current color out of gamut?
+                if (OutOfGamut > 0.0) {
+
+                    // Certainly, out of gamut
+                    for (c = 0; c < cmsMAXCHANNELS; c++)
+                        fOut[c] = -1.0;
+
+                }
+                else {
+                    // No, proceed normally
+                    cmsPipelineEvalFloat(ContextID, fIn, fOut, core->Lut);
+                }
+            }
+            else {
+
+                // No gamut check at all
+                cmsPipelineEvalFloat(ContextID, fIn, fOut, core->Lut);
+            }
+
+
+            output = p->ToOutputFloat(ContextID, p, fOut, output, Stride->BytesPerPlaneOut);
+        }
+
+        strideIn += Stride->BytesPerLineIn;
+        strideOut += Stride->BytesPerLineOut;
+    }
+
+}
+
+
+static
+void NullFloatXFORM(cmsContext ContextID, _cmsTRANSFORM* p,
+                    const void* in,
+                    void* out,
+                    cmsUInt32Number PixelsPerLine,
+                    cmsUInt32Number LineCount,
+                    const cmsStride* Stride)
+
+{
+    cmsUInt8Number* accum;
+    cmsUInt8Number* output;
+    cmsFloat32Number fIn[cmsMAXCHANNELS];
+    cmsUInt32Number i, j, strideIn, strideOut;
+
+    _cmsHandleExtraChannels(ContextID, p, in, out, PixelsPerLine, LineCount, Stride);
+
+    strideIn = 0;
+    strideOut = 0;
+    memset(fIn, 0, sizeof(fIn));
+
+    for (i = 0; i < LineCount; i++) {
+
+           accum = (cmsUInt8Number*) in + strideIn;
+           output = (cmsUInt8Number*) out + strideOut;
+
+           for (j = 0; j < PixelsPerLine; j++) {
+
+                  accum = p->FromInputFloat(ContextID, p, fIn, accum, Stride ->BytesPerPlaneIn);
+                  output = p->ToOutputFloat(ContextID, p, fIn, output, Stride->BytesPerPlaneOut);
+           }
+
+           strideIn += Stride->BytesPerLineIn;
+           strideOut += Stride->BytesPerLineOut;
+    }
+}
+
+// 16 bit precision -----------------------------------------------------------------------------------------------------------
+
+// Null transformation, only applies formatters. No cache
+static
+void NullXFORM(cmsContext ContextID,
+               _cmsTRANSFORM* p,
+               const void* in,
+               void* out,
+               cmsUInt32Number PixelsPerLine,
+               cmsUInt32Number LineCount,
+               const cmsStride* Stride)
+{
+    cmsUInt8Number* accum;
+    cmsUInt8Number* output;
+    cmsUInt16Number wIn[cmsMAXCHANNELS];
+    cmsUInt32Number i, j, strideIn, strideOut;
+
+    _cmsHandleExtraChannels(ContextID, p, in, out, PixelsPerLine, LineCount, Stride);
+
+    strideIn = 0;
+    strideOut = 0;
+    memset(wIn, 0, sizeof(wIn));
+
+    for (i = 0; i < LineCount; i++) {
+
+           accum = (cmsUInt8Number*)in + strideIn;
+           output = (cmsUInt8Number*)out + strideOut;
+
+           for (j = 0; j < PixelsPerLine; j++) {
+
+                  accum = p->FromInput(ContextID, p, wIn, accum, Stride->BytesPerPlaneIn);
+                  output = p->ToOutput(ContextID, p, wIn, output, Stride->BytesPerPlaneOut);
+    }
+
+           strideIn += Stride->BytesPerLineIn;
+           strideOut += Stride->BytesPerLineOut;
+    }
+
+}
+
+
+// No gamut check, no cache, 16 bits
+#define FUNCTION_NAME PrecalculatedXFORM
+#include "extra_xform.h"
+
+// No gamut check, no cache, Identity transform, including pack/unpack
+static
+void PrecalculatedXFORMIdentity(cmsContext ContextID,
+                                _cmsTRANSFORM* p,
+                                const void* in,
+                                void* out,
+                                cmsUInt32Number PixelsPerLine,
+                                cmsUInt32Number LineCount,
+                                const cmsStride* Stride)
+{
+    cmsUInt32Number bpli = Stride->BytesPerLineIn;
+    cmsUInt32Number bplo = Stride->BytesPerLineOut;
+    int bpp;
+    cmsUNUSED_PARAMETER(ContextID);
+
+    /* Silence some warnings */
+    (void)bpli;
+    (void)bplo;
+
+    if ((in == out && bpli == bplo) || PixelsPerLine == 0)
+        return;
+
+    bpp = T_BYTES(p->InputFormat);
+    if (bpp == 0)
+        bpp = sizeof(double);
+    bpp *= T_CHANNELS(p->InputFormat) + T_EXTRA(p->InputFormat);
+    PixelsPerLine *= bpp; /* Convert to BytesPerLine */
+    while (LineCount-- > 0)
+    {
+        memmove(out, in, PixelsPerLine);
+        in = (void *)((cmsUInt8Number *)in + bpli);
+        out = (void *)((cmsUInt8Number *)out + bplo);
+    }
+}
+
+static
+void PrecalculatedXFORMIdentityPlanar(cmsContext ContextID,
+                                      _cmsTRANSFORM* p,
+                                      const void* in,
+                                      void* out,
+                                      cmsUInt32Number PixelsPerLine,
+                                      cmsUInt32Number LineCount,
+                                      const cmsStride* Stride)
+{
+    cmsUInt32Number bpli = Stride->BytesPerLineIn;
+    cmsUInt32Number bplo = Stride->BytesPerLineOut;
+    cmsUInt32Number bppi = Stride->BytesPerPlaneIn;
+    cmsUInt32Number bppo = Stride->BytesPerPlaneOut;
+    int bpp;
+    int planes;
+    const void *plane_in;
+    void *plane_out;
+    cmsUNUSED_PARAMETER(ContextID);
+
+    /* Silence some warnings */
+    (void)bpli;
+    (void)bplo;
+    (void)bppi;
+    (void)bppo;
+
+    if ((in == out && bpli == bplo && bppi == bppo) || PixelsPerLine == 0)
+        return;
+
+    bpp = T_BYTES(p->InputFormat);
+    if (bpp == 0)
+        bpp = sizeof(double);
+    PixelsPerLine *= bpp; /* Convert to BytesPerLine */
+    planes = T_CHANNELS(p->InputFormat) + T_EXTRA(p->InputFormat);
+    while (planes-- > 0)
+    {
+        plane_in = in;
+        plane_out = out;
+        while (LineCount-- > 0)
+        {
+            memmove(plane_out, plane_in, PixelsPerLine);
+            plane_in = (void *)((cmsUInt8Number *)plane_in + bpli);
+            plane_out = (void *)((cmsUInt8Number *)plane_out + bplo);
+        }
+        in = (void *)((cmsUInt8Number *)in + bppi);
+        out = (void *)((cmsUInt8Number *)out + bppo);
+    }
+}
+
+// Auxiliary: Handle precalculated gamut check. The retrieval of context may be alittle bit slow, but this function is not critical.
+static
+void TransformOnePixelWithGamutCheck(cmsContext ContextID, _cmsTRANSFORM* p,
+                                     const cmsUInt16Number wIn[],
+                                     cmsUInt16Number wOut[])
+{
+    cmsUInt16Number wOutOfGamut;
+    _cmsTRANSFORMCORE *core = p->core;
+
+    core->GamutCheck->Eval16Fn(ContextID, wIn, &wOutOfGamut, core->GamutCheck->Data);
+    if (wOutOfGamut >= 1) {
+
+        cmsUInt32Number i;
+        cmsUInt32Number n = core->Lut->OutputChannels;
+        _cmsAlarmCodesChunkType* ContextAlarmCodes = (_cmsAlarmCodesChunkType*) _cmsContextGetClientChunk(ContextID, AlarmCodesContext);
+
+        for (i=0; i < n; i++) {
+
+            wOut[i] = ContextAlarmCodes ->AlarmCodes[i];
+        }
+    }
+    else
+        core->Lut->Eval16Fn(ContextID, wIn, wOut, core->Lut->Data);
+}
+
+// Gamut check, No cache, 16 bits.
+#define FUNCTION_NAME PrecalculatedXFORMGamutCheck
+#define GAMUTCHECK
+#include "extra_xform.h"
+
+// No gamut check, Cache, 16 bits,
+#define FUNCTION_NAME CachedXFORM
+#define CACHED
+#include "extra_xform.h"
+
+// All those nice features together
+#define FUNCTION_NAME CachedXFORMGamutCheck
+#define CACHED
+#define GAMUTCHECK
+#include "extra_xform.h"
+
+// No gamut check, Cache, 16 bits, <= 4 bytes
+#define FUNCTION_NAME CachedXFORM4
+#define CACHED
+#define INBYTES 4
+#define EXTRABYTES 0
+#include "extra_xform.h"
+
+// No gamut check, Cache, 16 bits, <= 8 bytes total
+#define FUNCTION_NAME CachedXFORM8
+#define CACHED
+#define INBYTES 8
+#define EXTRABYTES 0
+#include "extra_xform.h"
+
+// Special ones for common cases.
+#define FUNCTION_NAME CachedXFORM1to1
+#define CACHED
+#define INBYTES 2
+#define EXTRABYTES 0
+#define UNPACK(CTX,T,D,S,Z)                \
+do {                                       \
+       (D)[0] = FROM_8_TO_16(*(S)); (S)++; \
+} while (0)
+#define PACK(CTX,T,S,D,Z)          \
+do {                               \
+    *(D)++ = FROM_16_TO_8((S)[0]); \
+} while (0)
+#include "extra_xform.h"
+
+#define FUNCTION_NAME CachedXFORM1x2to1x2
+#define CACHED
+#define INBYTES 2
+#define EXTRABYTES 0
+#define UNPACK(CTX,T,D,S,Z)                        \
+do {                                               \
+       (D)[0] = *(cmsUInt16Number *)(S); (S) += 2; \
+} while (0)
+#define PACK(CTX,T,S,D,Z)                       \
+do {                                            \
+    *(cmsUInt16Number *)(D) = (S)[0]; (D) += 2; \
+} while (0)
+#include "extra_xform.h"
+
+#define FUNCTION_NAME CachedXFORM1to3
+#define CACHED
+#define INBYTES 2
+#define EXTRABYTES 0
+#define UNPACK(CTX,T,D,S,Z)                \
+do {                                       \
+       (D)[0] = FROM_8_TO_16(*(S)); (S)++; \
+} while (0)
+#define PACK(CTX,T,S,D,Z)          \
+do {                               \
+    *(D)++ = FROM_16_TO_8((S)[0]); \
+    *(D)++ = FROM_16_TO_8((S)[1]); \
+    *(D)++ = FROM_16_TO_8((S)[2]); \
+} while (0)
+#include "extra_xform.h"
+
+#define FUNCTION_NAME CachedXFORM1x2to3x2
+#define CACHED
+#define INBYTES 2
+#define EXTRABYTES 0
+#define UNPACK(CTX,T,D,S,Z)                        \
+do {                                               \
+       (D)[0] = *(cmsUInt16Number *)(S); (S) += 2; \
+} while (0)
+#define PACK(CTX,T,S,D,Z)                       \
+do {                                            \
+    *(cmsUInt16Number *)(D) = (S)[0]; (D) += 2; \
+    *(cmsUInt16Number *)(D) = (S)[1]; (D) += 2; \
+    *(cmsUInt16Number *)(D) = (S)[2]; (D) += 2; \
+} while (0)
+#include "extra_xform.h"
+
+#define FUNCTION_NAME CachedXFORM1to4
+#define CACHED
+#define INBYTES 2
+#define EXTRABYTES 0
+#define UNPACK(CTX,T,D,S,Z)                \
+do {                                       \
+       (D)[0] = FROM_8_TO_16(*(S)); (S)++; \
+} while (0)
+#define PACK(CTX,T,S,D,Z)          \
+do {                               \
+    *(D)++ = FROM_16_TO_8((S)[0]); \
+    *(D)++ = FROM_16_TO_8((S)[1]); \
+    *(D)++ = FROM_16_TO_8((S)[2]); \
+    *(D)++ = FROM_16_TO_8((S)[3]); \
+} while (0)
+#include "extra_xform.h"
+
+#define FUNCTION_NAME CachedXFORM1x2to4x2
+#define CACHED
+#define INBYTES 2
+#define EXTRABYTES 0
+#define UNPACK(CTX,T,D,S,Z)                        \
+do {                                               \
+       (D)[0] = *(cmsUInt16Number *)(S); (S) += 2; \
+} while (0)
+#define PACK(CTX,T,S,D,Z)                       \
+do {                                            \
+    *(cmsUInt16Number *)(D) = (S)[0]; (D) += 2; \
+    *(cmsUInt16Number *)(D) = (S)[1]; (D) += 2; \
+    *(cmsUInt16Number *)(D) = (S)[2]; (D) += 2; \
+    *(cmsUInt16Number *)(D) = (S)[3]; (D) += 2; \
+} while (0)
+#include "extra_xform.h"
+
+#define FUNCTION_NAME CachedXFORM3to1
+#define CACHED
+#define INBYTES 6
+#define EXTRABYTES 0
+#define UNPACK(CTX,T,D,S,Z)                 \
+do {                                        \
+        (D)[0] = FROM_8_TO_16(*(S)); (S)++; \
+        (D)[1] = FROM_8_TO_16(*(S)); (S)++; \
+        (D)[2] = FROM_8_TO_16(*(S)); (S)++; \
+} while (0)
+#define PACK(CTX,T,S,D,Z)          \
+do {                               \
+    *(D)++ = FROM_16_TO_8((S)[0]); \
+} while (0)
+#include "extra_xform.h"
+
+#define FUNCTION_NAME CachedXFORM3x2to1x2
+#define CACHED
+#define INBYTES 6
+#define EXTRABYTES 0
+#define UNPACK(CTX,T,D,S,Z)                         \
+do {                                                \
+        (D)[0] = *(cmsUInt16Number *)(S); (S) += 2; \
+        (D)[1] = *(cmsUInt16Number *)(S); (S) += 2; \
+        (D)[2] = *(cmsUInt16Number *)(S); (S) += 2; \
+} while (0)
+#define PACK(CTX,T,S,D,Z)                       \
+do {                                            \
+    *(cmsUInt16Number *)(D) = (S)[0]; (D) += 2; \
+} while (0)
+#include "extra_xform.h"
+
+#define FUNCTION_NAME CachedXFORM3to3
+#define CACHED
+#define INBYTES 6
+#define EXTRABYTES 0
+#define UNPACK(CTX,T,D,S,Z)                \
+do {                                       \
+       (D)[0] = FROM_8_TO_16(*(S)); (S)++; \
+       (D)[1] = FROM_8_TO_16(*(S)); (S)++; \
+       (D)[2] = FROM_8_TO_16(*(S)); (S)++; \
+} while (0)
+#define PACK(CTX,T,S,D,Z)          \
+do {                               \
+    *(D)++ = FROM_16_TO_8((S)[0]); \
+    *(D)++ = FROM_16_TO_8((S)[1]); \
+    *(D)++ = FROM_16_TO_8((S)[2]); \
+} while (0)
+#include "extra_xform.h"
+
+#define FUNCTION_NAME CachedXFORM3x2to3x2
+#define CACHED
+#define INBYTES 6
+#define EXTRABYTES 0
+#define UNPACK(CTX,T,D,S,Z)                        \
+do {                                               \
+       (D)[0] = *(cmsUInt16Number *)(S); (S) += 2; \
+       (D)[1] = *(cmsUInt16Number *)(S); (S) += 2; \
+       (D)[2] = *(cmsUInt16Number *)(S); (S) += 2; \
+} while (0)
+#define PACK(CTX,T,S,D,Z)                       \
+do {                                            \
+    *(cmsUInt16Number *)(D) = (S)[0]; (D) += 2; \
+    *(cmsUInt16Number *)(D) = (S)[1]; (D) += 2; \
+    *(cmsUInt16Number *)(D) = (S)[2]; (D) += 2; \
+} while (0)
+#include "extra_xform.h"
+
+#define FUNCTION_NAME CachedXFORM3to4
+#define CACHED
+#define INBYTES 6
+#define EXTRABYTES 0
+#define UNPACK(CTX,T,D,S,Z)                \
+do {                                       \
+       (D)[0] = FROM_8_TO_16(*(S)); (S)++; \
+       (D)[1] = FROM_8_TO_16(*(S)); (S)++; \
+       (D)[2] = FROM_8_TO_16(*(S)); (S)++; \
+} while (0)
+#define PACK(CTX,T,S,D,Z)          \
+do {                               \
+    *(D)++ = FROM_16_TO_8((S)[0]); \
+    *(D)++ = FROM_16_TO_8((S)[1]); \
+    *(D)++ = FROM_16_TO_8((S)[2]); \
+    *(D)++ = FROM_16_TO_8((S)[3]); \
+} while (0)
+#include "extra_xform.h"
+
+#define FUNCTION_NAME CachedXFORM3x2to4x2
+#define CACHED
+#define INBYTES 6
+#define EXTRABYTES 0
+#define UNPACK(CTX,T,D,S,Z)                        \
+do {                                               \
+       (D)[0] = *(cmsUInt16Number *)(S); (S) += 2; \
+       (D)[1] = *(cmsUInt16Number *)(S); (S) += 2; \
+       (D)[2] = *(cmsUInt16Number *)(S); (S) += 2; \
+} while (0)
+#define PACK(CTX,T,S,D,Z)                       \
+do {                                            \
+    *(cmsUInt16Number *)(D) = (S)[0]; (D) += 2; \
+    *(cmsUInt16Number *)(D) = (S)[1]; (D) += 2; \
+    *(cmsUInt16Number *)(D) = (S)[2]; (D) += 2; \
+    *(cmsUInt16Number *)(D) = (S)[3]; (D) += 2; \
+} while (0)
+#include "extra_xform.h"
+
+#define FUNCTION_NAME CachedXFORM4to1
+#define CACHED
+#define INBYTES 8
+#define EXTRABYTES 0
+#define UNPACK(CTX,T,D,S,Z)                \
+do {                                       \
+       (D)[0] = FROM_8_TO_16(*(S)); (S)++; \
+       (D)[1] = FROM_8_TO_16(*(S)); (S)++; \
+       (D)[2] = FROM_8_TO_16(*(S)); (S)++; \
+       (D)[3] = FROM_8_TO_16(*(S)); (S)++; \
+} while (0)
+#define PACK(CTX,T,S,D,Z)          \
+do {                               \
+    *(D)++ = FROM_16_TO_8((S)[0]); \
+} while (0)
+#include "extra_xform.h"
+
+#define FUNCTION_NAME CachedXFORM4x2to1x2
+#define CACHED
+#define INBYTES 8
+#define EXTRABYTES 0
+#define UNPACK(CTX,T,D,S,Z)                        \
+do {                                               \
+       (D)[0] = *(cmsUInt16Number *)(S); (S) += 2; \
+       (D)[1] = *(cmsUInt16Number *)(S); (S) += 2; \
+       (D)[2] = *(cmsUInt16Number *)(S); (S) += 2; \
+       (D)[3] = *(cmsUInt16Number *)(S); (S) += 2; \
+} while (0)
+#define PACK(CTX,T,S,D,Z)                       \
+do {                                            \
+    *(cmsUInt16Number *)(D) = (S)[0]; (D) += 2; \
+} while (0)
+#include "extra_xform.h"
+
+#define FUNCTION_NAME CachedXFORM4to3
+#define CACHED
+#define INBYTES 8
+#define EXTRABYTES 0
+#define UNPACK(CTX,T,D,S,Z)                \
+do {                                       \
+       (D)[0] = FROM_8_TO_16(*(S)); (S)++; \
+       (D)[1] = FROM_8_TO_16(*(S)); (S)++; \
+       (D)[2] = FROM_8_TO_16(*(S)); (S)++; \
+       (D)[3] = FROM_8_TO_16(*(S)); (S)++; \
+} while (0)
+#define PACK(CTX,T,S,D,Z)          \
+do {                               \
+    *(D)++ = FROM_16_TO_8((S)[0]); \
+    *(D)++ = FROM_16_TO_8((S)[1]); \
+    *(D)++ = FROM_16_TO_8((S)[2]); \
+} while (0)
+#include "extra_xform.h"
+
+#define FUNCTION_NAME CachedXFORM4x2to3x2
+#define CACHED
+#define INBYTES 8
+#define EXTRABYTES 0
+#define UNPACK(CTX,T,D,S,Z)                        \
+do {                                               \
+       (D)[0] = *(cmsUInt16Number *)(S); (S) += 2; \
+       (D)[1] = *(cmsUInt16Number *)(S); (S) += 2; \
+       (D)[2] = *(cmsUInt16Number *)(S); (S) += 2; \
+       (D)[3] = *(cmsUInt16Number *)(S); (S) += 2; \
+} while (0)
+#define PACK(CTX,T,S,D,Z)                       \
+do {                                            \
+    *(cmsUInt16Number *)(D) = (S)[0]; (D) += 2; \
+    *(cmsUInt16Number *)(D) = (S)[1]; (D) += 2; \
+    *(cmsUInt16Number *)(D) = (S)[2]; (D) += 2; \
+} while (0)
+#include "extra_xform.h"
+
+#define FUNCTION_NAME CachedXFORM4to4
+#define CACHED
+#define INBYTES 8
+#define EXTRABYTES 0
+#define UNPACK(CTX,T,D,S,Z)                \
+do {                                       \
+       (D)[0] = FROM_8_TO_16(*(S)); (S)++; \
+       (D)[1] = FROM_8_TO_16(*(S)); (S)++; \
+       (D)[2] = FROM_8_TO_16(*(S)); (S)++; \
+       (D)[3] = FROM_8_TO_16(*(S)); (S)++; \
+} while (0)
+#define PACK(CTX,T,S,D,Z)          \
+do {                               \
+    *(D)++ = FROM_16_TO_8((S)[0]); \
+    *(D)++ = FROM_16_TO_8((S)[1]); \
+    *(D)++ = FROM_16_TO_8((S)[2]); \
+    *(D)++ = FROM_16_TO_8((S)[3]); \
+} while (0)
+#include "extra_xform.h"
+
+#define FUNCTION_NAME CachedXFORM4x2to4x2
+#define CACHED
+#define INBYTES 8
+#define EXTRABYTES 0
+#define UNPACK(CTX,T,D,S,Z)                        \
+do {                                               \
+       (D)[0] = *(cmsUInt16Number *)(S); (S) += 2; \
+       (D)[1] = *(cmsUInt16Number *)(S); (S) += 2; \
+       (D)[2] = *(cmsUInt16Number *)(S); (S) += 2; \
+       (D)[3] = *(cmsUInt16Number *)(S); (S) += 2; \
+} while (0)
+#define PACK(CTX,T,S,D,Z)                       \
+do {                                            \
+    *(cmsUInt16Number *)(D) = (S)[0]; (D) += 2; \
+    *(cmsUInt16Number *)(D) = (S)[1]; (D) += 2; \
+    *(cmsUInt16Number *)(D) = (S)[2]; (D) += 2; \
+    *(cmsUInt16Number *)(D) = (S)[3]; (D) += 2; \
+} while (0)
+#include "extra_xform.h"
+
+// Transform plug-ins ----------------------------------------------------------------------------------------------------
+
+// List of used-defined transform factories
+typedef struct _cmsTransformCollection_st {
+
+    _cmsTransform2Factory  Factory;
+    cmsBool                OldXform;   // Factory returns xform function in the old style
+
+    struct _cmsTransformCollection_st *Next;
+
+} _cmsTransformCollection;
+
+// The linked list head
+_cmsTransformPluginChunkType _cmsTransformPluginChunk = { NULL };
+
+
+// Duplicates the zone of memory used by the plug-in in the new context
+static
+void DupPluginTransformList(struct _cmsContext_struct* ctx,
+                                               const struct _cmsContext_struct* src)
+{
+   _cmsTransformPluginChunkType newHead = { NULL };
+   _cmsTransformCollection*  entry;
+   _cmsTransformCollection*  Anterior = NULL;
+   _cmsTransformPluginChunkType* head = (_cmsTransformPluginChunkType*) src->chunks[TransformPlugin];
+
+    // Walk the list copying all nodes
+   for (entry = head->TransformCollection;
+        entry != NULL;
+        entry = entry ->Next) {
+
+            _cmsTransformCollection *newEntry = ( _cmsTransformCollection *) _cmsSubAllocDup(ctx ->MemPool, entry, sizeof(_cmsTransformCollection));
+
+            if (newEntry == NULL)
+                return;
+
+            // We want to keep the linked list order, so this is a little bit tricky
+            newEntry -> Next = NULL;
+            if (Anterior)
+                Anterior -> Next = newEntry;
+
+            Anterior = newEntry;
+
+            if (newHead.TransformCollection == NULL)
+                newHead.TransformCollection = newEntry;
+    }
+
+  ctx ->chunks[TransformPlugin] = _cmsSubAllocDup(ctx->MemPool, &newHead, sizeof(_cmsTransformPluginChunkType));
+}
+
+// Allocates memory for transform plugin factory
+void _cmsAllocTransformPluginChunk(struct _cmsContext_struct* ctx,
+                                        const struct _cmsContext_struct* src)
+{
+    if (src != NULL) {
+
+        // Copy all linked list
+        DupPluginTransformList(ctx, src);
+    }
+    else {
+        static _cmsTransformPluginChunkType TransformPluginChunkType = { NULL };
+        ctx ->chunks[TransformPlugin] = _cmsSubAllocDup(ctx ->MemPool, &TransformPluginChunkType, sizeof(_cmsTransformPluginChunkType));
+    }
+}
+
+// Adaptor for old versions of plug-in
+static
+void _cmsTransform2toTransformAdaptor(cmsContext ContextID, struct _cmstransform_struct *CMMcargo,
+                                      const void* InputBuffer,
+                                      void* OutputBuffer,
+                                      cmsUInt32Number PixelsPerLine,
+                                      cmsUInt32Number LineCount,
+                                      const cmsStride* Stride)
+{
+
+       cmsUInt32Number i, strideIn, strideOut;
+
+       _cmsHandleExtraChannels(ContextID, CMMcargo, InputBuffer, OutputBuffer, PixelsPerLine, LineCount, Stride);
+
+       strideIn = 0;
+       strideOut = 0;
+
+       for (i = 0; i < LineCount; i++) {
+
+              void *accum = (cmsUInt8Number*)InputBuffer + strideIn;
+              void *output = (cmsUInt8Number*)OutputBuffer + strideOut;
+
+              CMMcargo->OldXform(ContextID, CMMcargo, accum, output, PixelsPerLine, Stride->BytesPerPlaneIn);
+
+              strideIn += Stride->BytesPerLineIn;
+              strideOut += Stride->BytesPerLineOut;
+       }
+}
+
+
+
+// Register new ways to transform
+cmsBool  _cmsRegisterTransformPlugin(cmsContext ContextID, cmsPluginBase* Data)
+{
+    cmsPluginTransform* Plugin = (cmsPluginTransform*) Data;
+    _cmsTransformCollection* fl;
+    _cmsTransformPluginChunkType* ctx = ( _cmsTransformPluginChunkType*) _cmsContextGetClientChunk(ContextID,TransformPlugin);
+
+    if (Data == NULL) {
+
+        // Free the chain. Memory is safely freed at exit
+        ctx->TransformCollection = NULL;
+        return TRUE;
+    }
+
+    // Factory callback is required
+    if (Plugin->factories.xform == NULL) return FALSE;
+
+
+    fl = (_cmsTransformCollection*) _cmsPluginMalloc(ContextID, sizeof(_cmsTransformCollection));
+    if (fl == NULL) return FALSE;
+
+    // Check for full xform plug-ins previous to 2.8, we would need an adapter in that case
+    if (Plugin->base.ExpectedVersion < 2080-2000) {
+
+           fl->OldXform = TRUE;
+    }
+    else
+           fl->OldXform = FALSE;
+
+    // Copy the parameters
+    fl->Factory = Plugin->factories.xform;
+
+    // Keep linked list
+    fl ->Next = ctx->TransformCollection;
+    ctx->TransformCollection = fl;
+
+    // All is ok
+    return TRUE;
+}
+
+
+void CMSEXPORT _cmsSetTransformUserData(struct _cmstransform_struct *CMMcargo, void* ptr, _cmsFreeUserDataFn FreePrivateDataFn)
+{
+    _cmsAssert(CMMcargo != NULL && CMMcargo->core != NULL);
+    CMMcargo->core->UserData = ptr;
+    CMMcargo->core->FreeUserData = FreePrivateDataFn;
+}
+
+// returns the pointer defined by the plug-in to store private data
+void * CMSEXPORT _cmsGetTransformUserData(struct _cmstransform_struct *CMMcargo)
+{
+    _cmsAssert(CMMcargo != NULL && CMMcargo->core != NULL);
+    return CMMcargo->core->UserData;
+}
+
+// returns the current formatters
+void CMSEXPORT _cmsGetTransformFormatters16(struct _cmstransform_struct *CMMcargo, cmsFormatter16* FromInput, cmsFormatter16* ToOutput)
+{
+     _cmsAssert(CMMcargo != NULL);
+     if (FromInput) *FromInput = CMMcargo ->FromInput;
+     if (ToOutput)  *ToOutput  = CMMcargo ->ToOutput;
+}
+
+void CMSEXPORT _cmsGetTransformFormattersFloat(struct _cmstransform_struct *CMMcargo, cmsFormatterFloat* FromInput, cmsFormatterFloat* ToOutput)
+{
+     _cmsAssert(CMMcargo != NULL);
+     if (FromInput) *FromInput = CMMcargo ->FromInputFloat;
+     if (ToOutput)  *ToOutput  = CMMcargo ->ToOutputFloat;
+}
+
+
+void
+_cmsFindFormatter(_cmsTRANSFORM* p, cmsUInt32Number InputFormat, cmsUInt32Number OutputFormat, cmsUInt32Number dwFlags)
+{
+    if (dwFlags & cmsFLAGS_NULLTRANSFORM) {
+        p ->xform = NullXFORM;
+        return;
+    }
+    if (dwFlags & cmsFLAGS_NOCACHE) {
+        if (dwFlags & cmsFLAGS_GAMUTCHECK)
+            p ->xform = PrecalculatedXFORMGamutCheck;  // Gamut check, no cache
+        else if ((InputFormat & ~COLORSPACE_SH(31)) == (OutputFormat & ~COLORSPACE_SH(31)) &&
+                 _cmsLutIsIdentity(p->core->Lut)) {
+            if (T_PLANAR(InputFormat))
+                p ->xform = PrecalculatedXFORMIdentityPlanar;
+            else
+                p ->xform = PrecalculatedXFORMIdentity;
+        } else
+            p ->xform = PrecalculatedXFORM;  // No cache, no gamut check
+	return;
+    }
+    if (dwFlags & cmsFLAGS_GAMUTCHECK) {
+        p ->xform = CachedXFORMGamutCheck;    // Gamut check, cache
+	return;
+    }
+    if ((InputFormat & ~COLORSPACE_SH(31)) == (OutputFormat & ~COLORSPACE_SH(31)) &&
+        _cmsLutIsIdentity(p->core->Lut)) {
+        /* No point in a cache here! */
+        if (T_PLANAR(InputFormat))
+            p ->xform = PrecalculatedXFORMIdentityPlanar;
+        else
+            p ->xform = PrecalculatedXFORMIdentity;
+        return;
+    }
+    if (T_EXTRA(InputFormat) != 0) {
+        p ->xform = CachedXFORM;  // No gamut check, cache
+        return;
+    }
+    if ((InputFormat & ~(COLORSPACE_SH(31)|CHANNELS_SH(7)|BYTES_SH(3))) == 0 &&
+        (OutputFormat & ~(COLORSPACE_SH(31)|CHANNELS_SH(7)|BYTES_SH(3))) == 0) {
+        switch ((InputFormat & (CHANNELS_SH(7)|BYTES_SH(3)))|
+                ((OutputFormat & (CHANNELS_SH(7)|BYTES_SH(3)))<<6)) {
+            case CHANNELS_SH(1) | BYTES_SH(1) | ((CHANNELS_SH(1) | BYTES_SH(1))<<6):
+                p->xform = CachedXFORM1to1;
+                return;
+            case CHANNELS_SH(1) | BYTES_SH(2) | ((CHANNELS_SH(1) | BYTES_SH(2))<<6):
+                p->xform = CachedXFORM1x2to1x2;
+                return;
+            case CHANNELS_SH(1) | BYTES_SH(1) | ((CHANNELS_SH(3) | BYTES_SH(1))<<6):
+                p->xform = CachedXFORM1to3;
+                return;
+            case CHANNELS_SH(1) | BYTES_SH(2) | ((CHANNELS_SH(3) | BYTES_SH(2))<<6):
+                p->xform = CachedXFORM1x2to3x2;
+                return;
+            case CHANNELS_SH(1) | BYTES_SH(1) | ((CHANNELS_SH(4) | BYTES_SH(1))<<6):
+                p->xform = CachedXFORM1to4;
+                return;
+            case CHANNELS_SH(1) | BYTES_SH(2) | ((CHANNELS_SH(4) | BYTES_SH(2))<<6):
+                p->xform = CachedXFORM1x2to4x2;
+                return;
+            case CHANNELS_SH(3) | BYTES_SH(1) | ((CHANNELS_SH(1) | BYTES_SH(1))<<6):
+                p ->xform = CachedXFORM3to1;
+		return;
+            case CHANNELS_SH(3) | BYTES_SH(2) | ((CHANNELS_SH(1) | BYTES_SH(2))<<6):
+                p ->xform = CachedXFORM3x2to1x2;
+                return;
+            case CHANNELS_SH(3) | BYTES_SH(1) | ((CHANNELS_SH(3) | BYTES_SH(1))<<6):
+                p->xform = CachedXFORM3to3;
+                return;
+            case CHANNELS_SH(3) | BYTES_SH(2) | ((CHANNELS_SH(3) | BYTES_SH(2))<<6):
+                p->xform = CachedXFORM3x2to3x2;
+                return;
+            case CHANNELS_SH(3) | BYTES_SH(1) | ((CHANNELS_SH(4) | BYTES_SH(1))<<6):
+                p->xform = CachedXFORM3to4;
+                return;
+            case CHANNELS_SH(3) | BYTES_SH(2) | ((CHANNELS_SH(4) | BYTES_SH(2))<<6):
+                p->xform = CachedXFORM3x2to4x2;
+                return;
+            case CHANNELS_SH(4) | BYTES_SH(1) | ((CHANNELS_SH(1) | BYTES_SH(1))<<6):
+                p->xform = CachedXFORM4to1;
+                return;
+            case CHANNELS_SH(4) | BYTES_SH(2) | ((CHANNELS_SH(1) | BYTES_SH(2))<<6):
+                p->xform = CachedXFORM4x2to1x2;
+                return;
+            case CHANNELS_SH(4) | BYTES_SH(1) | ((CHANNELS_SH(3) | BYTES_SH(1))<<6):
+                p->xform = CachedXFORM4to3;
+                return;
+            case CHANNELS_SH(4) | BYTES_SH(2) | ((CHANNELS_SH(3) | BYTES_SH(2))<<6):
+                p->xform = CachedXFORM4x2to3x2;
+                return;
+            case CHANNELS_SH(4) | BYTES_SH(1) | ((CHANNELS_SH(4) | BYTES_SH(1))<<6):
+                p->xform = CachedXFORM4to4;
+                return;
+            case CHANNELS_SH(4) | BYTES_SH(2) | ((CHANNELS_SH(4) | BYTES_SH(2))<<6):
+                p->xform = CachedXFORM4x2to4x2;
+                return;
+        }
+    }
+    {
+        int inwords = T_CHANNELS(InputFormat);
+        if (inwords <= 2)
+            p ->xform = CachedXFORM4;
+        else if (inwords <= 4)
+            p ->xform = CachedXFORM8;
+        else
+            p ->xform = CachedXFORM;  // No gamut check, cache
+    }
+}
+
+// Allocate transform struct and set it to defaults. Ask the optimization plug-in about if those formats are proper
+// for separated transforms. If this is the case,
+static
+_cmsTRANSFORM* AllocEmptyTransform(cmsContext ContextID, cmsPipeline* lut,
+                                               cmsUInt32Number Intent, cmsUInt32Number* InputFormat, cmsUInt32Number* OutputFormat, cmsUInt32Number* dwFlags)
+{
+    _cmsTransformPluginChunkType* ctx = ( _cmsTransformPluginChunkType*) _cmsContextGetClientChunk(ContextID, TransformPlugin);
+    _cmsTransformCollection* Plugin;
+    _cmsTRANSFORMCORE *core;
+
+    // Allocate needed memory
+    _cmsTRANSFORM* p = (_cmsTRANSFORM*)_cmsMallocZero(ContextID, sizeof(_cmsTRANSFORM));
+    if (!p) {
+        cmsPipelineFree(ContextID, lut);
+        return NULL;
+    }
+
+    core = (_cmsTRANSFORMCORE*)_cmsMallocZero(ContextID, sizeof(*core));
+    if (!core) {
+        _cmsFree(ContextID, p);
+        cmsPipelineFree(ContextID, lut);
+        return NULL;
+    }
+
+    p->core = core;
+    core->refs = 1;
+    // Store the proposed pipeline
+    p->core->Lut = lut;
+
+       // Let's see if any plug-in want to do the transform by itself
+       if (core->Lut != NULL && !(*dwFlags & cmsFLAGS_NOOPTIMIZE)) {
+
+              for (Plugin = ctx->TransformCollection;
+                     Plugin != NULL;
+                     Plugin = Plugin->Next) {
+
+                     if (Plugin->Factory(ContextID, &p->xform, &core->UserData, &core->FreeUserData, &core->Lut, InputFormat, OutputFormat, dwFlags)) {
+
+                            // Last plugin in the declaration order takes control. We just keep
+                            // the original parameters as a logging.
+                            // Note that cmsFLAGS_CAN_CHANGE_FORMATTER is not set, so by default
+                            // an optimized transform is not reusable. The plug-in can, however, change
+                            // the flags and make it suitable.
+
+                            p->InputFormat = *InputFormat;
+                            p->OutputFormat = *OutputFormat;
+                            core->dwOriginalFlags = *dwFlags;
+
+                            // Fill the formatters just in case the optimized routine is interested.
+                            // No error is thrown if the formatter doesn't exist. It is up to the optimization
+                            // factory to decide what to do in those cases.
+                            p->FromInput = _cmsGetFormatter(ContextID, *InputFormat, cmsFormatterInput, CMS_PACK_FLAGS_16BITS).Fmt16;
+                            p->ToOutput = _cmsGetFormatter(ContextID, *OutputFormat, cmsFormatterOutput, CMS_PACK_FLAGS_16BITS).Fmt16;
+                            p->FromInputFloat = _cmsGetFormatter(ContextID, *InputFormat, cmsFormatterInput, CMS_PACK_FLAGS_FLOAT).FmtFloat;
+                            p->ToOutputFloat = _cmsGetFormatter(ContextID, *OutputFormat, cmsFormatterOutput, CMS_PACK_FLAGS_FLOAT).FmtFloat;
+
+                            // Save the day? (Ignore the warning)
+                            if (Plugin->OldXform) {
+                                   p->OldXform = (_cmsTransformFn)(void*) p->xform;
+                                   p->xform = _cmsTransform2toTransformAdaptor;
+                            }
+                            return p;
+                     }
+              }
+
+              // Not suitable for the transform plug-in, let's check the pipeline plug-in
+              _cmsOptimizePipeline(ContextID, &core->Lut, Intent, InputFormat, OutputFormat, dwFlags);
+       }
+
+    // Check whatever this is a true floating point transform
+    if (_cmsFormatterIsFloat(*InputFormat) && _cmsFormatterIsFloat(*OutputFormat)) {
+
+        // Get formatter function always return a valid union, but the contents of this union may be NULL.
+        p ->FromInputFloat = _cmsGetFormatter(ContextID, *InputFormat,  cmsFormatterInput, CMS_PACK_FLAGS_FLOAT).FmtFloat;
+        p ->ToOutputFloat  = _cmsGetFormatter(ContextID, *OutputFormat, cmsFormatterOutput, CMS_PACK_FLAGS_FLOAT).FmtFloat;
+        *dwFlags |= cmsFLAGS_CAN_CHANGE_FORMATTER;
+
+        if (p ->FromInputFloat == NULL || p ->ToOutputFloat == NULL) {
+
+            cmsSignalError(ContextID, cmsERROR_UNKNOWN_EXTENSION, "Unsupported raster format");
+            cmsDeleteTransform(ContextID, p);
+            return NULL;
+        }
+
+        if (*dwFlags & cmsFLAGS_NULLTRANSFORM) {
+
+            p ->xform = NullFloatXFORM;
+        }
+        else {
+            // Float transforms don't use cache, always are non-NULL
+            p ->xform = FloatXFORM;
+        }
+
+    }
+    else {
+
+        if (*InputFormat == 0 && *OutputFormat == 0) {
+            p ->FromInput = p ->ToOutput = NULL;
+            *dwFlags |= cmsFLAGS_CAN_CHANGE_FORMATTER;
+        }
+        else {
+
+            cmsUInt32Number BytesPerPixelInput;
+
+            p ->FromInput = _cmsGetFormatter(ContextID, *InputFormat,  cmsFormatterInput, CMS_PACK_FLAGS_16BITS).Fmt16;
+            p ->ToOutput  = _cmsGetFormatter(ContextID, *OutputFormat, cmsFormatterOutput, CMS_PACK_FLAGS_16BITS).Fmt16;
+
+            if (p ->FromInput == NULL || p ->ToOutput == NULL) {
+
+                cmsSignalError(ContextID, cmsERROR_UNKNOWN_EXTENSION, "Unsupported raster format");
+                cmsDeleteTransform(ContextID, p);
+                return NULL;
+            }
+
+            BytesPerPixelInput = T_BYTES(p ->InputFormat);
+            if (BytesPerPixelInput == 0 || BytesPerPixelInput >= 2)
+                   *dwFlags |= cmsFLAGS_CAN_CHANGE_FORMATTER;
+
+        }
+
+        _cmsFindFormatter(p, *InputFormat, *OutputFormat, *dwFlags);
+    }
+
+    p ->InputFormat     = *InputFormat;
+    p ->OutputFormat    = *OutputFormat;
+    core->dwOriginalFlags = *dwFlags;
+    core->UserData        = NULL;
+    return p;
+}
+
+static
+cmsBool GetXFormColorSpaces(cmsContext ContextID, cmsUInt32Number nProfiles, cmsHPROFILE hProfiles[], cmsColorSpaceSignature* Input, cmsColorSpaceSignature* Output)
+{
+    cmsColorSpaceSignature ColorSpaceIn, ColorSpaceOut;
+    cmsColorSpaceSignature PostColorSpace;
+    cmsUInt32Number i;
+
+    if (nProfiles == 0) return FALSE;
+    if (hProfiles[0] == NULL) return FALSE;
+
+    *Input = PostColorSpace = cmsGetColorSpace(ContextID, hProfiles[0]);
+
+    for (i=0; i < nProfiles; i++) {
+
+        cmsProfileClassSignature cls;
+        cmsHPROFILE hProfile = hProfiles[i];
+
+        int lIsInput = (PostColorSpace != cmsSigXYZData) &&
+                       (PostColorSpace != cmsSigLabData);
+
+        if (hProfile == NULL) return FALSE;
+
+        cls = cmsGetDeviceClass(ContextID, hProfile);
+
+        if (cls == cmsSigNamedColorClass) {
+
+            ColorSpaceIn    = cmsSig1colorData;
+            ColorSpaceOut   = (nProfiles > 1) ? cmsGetPCS(ContextID, hProfile) : cmsGetColorSpace(ContextID, hProfile);
+        }
+        else
+        if (lIsInput || (cls == cmsSigLinkClass)) {
+
+            ColorSpaceIn    = cmsGetColorSpace(ContextID, hProfile);
+            ColorSpaceOut   = cmsGetPCS(ContextID, hProfile);
+        }
+        else
+        {
+            ColorSpaceIn    = cmsGetPCS(ContextID, hProfile);
+            ColorSpaceOut   = cmsGetColorSpace(ContextID, hProfile);
+        }
+
+        if (i==0)
+            *Input = ColorSpaceIn;
+
+        PostColorSpace = ColorSpaceOut;
+    }
+
+    *Output = PostColorSpace;
+
+    return TRUE;
+}
+
+// Check colorspace
+static
+cmsBool  IsProperColorSpace(cmsContext ContextID, cmsColorSpaceSignature Check, cmsUInt32Number dwFormat)
+{
+    int Space1 = (int) T_COLORSPACE(dwFormat);
+    int Space2 = _cmsLCMScolorSpace(ContextID, Check);
+
+    if (Space1 == PT_ANY) return TRUE;
+    if (Space1 == Space2) return TRUE;
+
+    if (Space1 == PT_LabV2 && Space2 == PT_Lab) return TRUE;
+    if (Space1 == PT_Lab   && Space2 == PT_LabV2) return TRUE;
+
+    return FALSE;
+}
+
+// ----------------------------------------------------------------------------------------------------------------
+
+// Jun-21-2000: Some profiles (those that comes with W2K) comes
+// with the media white (media black?) x 100. Add a sanity check
+
+static
+void NormalizeXYZ(cmsCIEXYZ* Dest)
+{
+    while (Dest -> X > 2. &&
+           Dest -> Y > 2. &&
+           Dest -> Z > 2.) {
+
+               Dest -> X /= 10.;
+               Dest -> Y /= 10.;
+               Dest -> Z /= 10.;
+       }
+}
+
+static
+void SetWhitePoint(cmsCIEXYZ* wtPt, const cmsCIEXYZ* src)
+{
+    if (src == NULL) {
+        wtPt ->X = cmsD50X;
+        wtPt ->Y = cmsD50Y;
+        wtPt ->Z = cmsD50Z;
+    }
+    else {
+        wtPt ->X = src->X;
+        wtPt ->Y = src->Y;
+        wtPt ->Z = src->Z;
+
+        NormalizeXYZ(wtPt);
+    }
+
+}
+
+// New to lcms 2.0 -- have all parameters available.
+cmsHTRANSFORM CMSEXPORT cmsCreateExtendedTransform(cmsContext ContextID,
+                                                   cmsUInt32Number nProfiles, cmsHPROFILE hProfiles[],
+                                                   cmsBool  BPC[],
+                                                   cmsUInt32Number Intents[],
+                                                   cmsFloat64Number AdaptationStates[],
+                                                   cmsHPROFILE hGamutProfile,
+                                                   cmsUInt32Number nGamutPCSposition,
+                                                   cmsUInt32Number InputFormat,
+                                                   cmsUInt32Number OutputFormat,
+                                                   cmsUInt32Number dwFlags)
+{
+    _cmsTRANSFORM* xform;
+    cmsColorSpaceSignature EntryColorSpace;
+    cmsColorSpaceSignature ExitColorSpace;
+    cmsPipeline* Lut;
+    cmsUInt32Number LastIntent = Intents[nProfiles-1];
+
+    // If it is a fake transform
+    if (dwFlags & cmsFLAGS_NULLTRANSFORM)
+    {
+        return AllocEmptyTransform(ContextID, NULL, INTENT_PERCEPTUAL, &InputFormat, &OutputFormat, &dwFlags);
+    }
+
+    // If gamut check is requested, make sure we have a gamut profile
+    if (dwFlags & cmsFLAGS_GAMUTCHECK) {
+        if (hGamutProfile == NULL) dwFlags &= ~cmsFLAGS_GAMUTCHECK;
+    }
+
+    // On floating point transforms, inhibit cache
+    if (_cmsFormatterIsFloat(InputFormat) || _cmsFormatterIsFloat(OutputFormat))
+        dwFlags |= cmsFLAGS_NOCACHE;
+
+    // Mark entry/exit spaces
+    if (!GetXFormColorSpaces(ContextID, nProfiles, hProfiles, &EntryColorSpace, &ExitColorSpace)) {
+        cmsSignalError(ContextID, cmsERROR_NULL, "NULL input profiles on transform");
+        return NULL;
+    }
+
+    // Check if proper colorspaces
+    if (!IsProperColorSpace(ContextID, EntryColorSpace, InputFormat)) {
+        cmsSignalError(ContextID, cmsERROR_COLORSPACE_CHECK, "Wrong input color space on transform");
+        return NULL;
+    }
+
+    if (!IsProperColorSpace(ContextID, ExitColorSpace, OutputFormat)) {
+        cmsSignalError(ContextID, cmsERROR_COLORSPACE_CHECK, "Wrong output color space on transform");
+        return NULL;
+    }
+
+    // Create a pipeline with all transformations
+    Lut = _cmsLinkProfiles(ContextID, nProfiles, Intents, hProfiles, BPC, AdaptationStates, dwFlags);
+    if (Lut == NULL) {
+        cmsSignalError(ContextID, cmsERROR_NOT_SUITABLE, "Couldn't link the profiles");
+        return NULL;
+    }
+
+    // Check channel count
+    if ((cmsChannelsOf(ContextID, EntryColorSpace) != cmsPipelineInputChannels(ContextID, Lut)) ||
+        (cmsChannelsOf(ContextID, ExitColorSpace)  != cmsPipelineOutputChannels(ContextID, Lut))) {
+        cmsPipelineFree(ContextID, Lut);
+        cmsSignalError(ContextID, cmsERROR_NOT_SUITABLE, "Channel count doesn't match. Profile is corrupted");
+        return NULL;
+    }
+
+
+    // All seems ok
+    xform = AllocEmptyTransform(ContextID, Lut, LastIntent, &InputFormat, &OutputFormat, &dwFlags);
+    if (xform == NULL) {
+        return NULL;
+    }
+
+    // Keep values
+    xform->core->EntryColorSpace = EntryColorSpace;
+    xform->core->ExitColorSpace  = ExitColorSpace;
+    xform->core->RenderingIntent = Intents[nProfiles-1];
+
+    // Take white points
+    SetWhitePoint(&xform->core->EntryWhitePoint, (cmsCIEXYZ*) cmsReadTag(ContextID, hProfiles[0], cmsSigMediaWhitePointTag));
+    SetWhitePoint(&xform->core->ExitWhitePoint,  (cmsCIEXYZ*) cmsReadTag(ContextID, hProfiles[nProfiles-1], cmsSigMediaWhitePointTag));
+
+
+    // Create a gamut check LUT if requested
+    if (hGamutProfile != NULL && (dwFlags & cmsFLAGS_GAMUTCHECK))
+        xform->core->GamutCheck  = _cmsCreateGamutCheckPipeline(ContextID, hProfiles,
+                                                        BPC, Intents,
+                                                        AdaptationStates,
+                                                        nGamutPCSposition,
+                                                        hGamutProfile);
+
+
+    // Try to read input and output colorant table
+    if (cmsIsTag(ContextID, hProfiles[0], cmsSigColorantTableTag)) {
+
+        // Input table can only come in this way.
+        xform->core->InputColorant = cmsDupNamedColorList(ContextID, (cmsNAMEDCOLORLIST*) cmsReadTag(ContextID, hProfiles[0], cmsSigColorantTableTag));
+    }
+
+    // Output is a little bit more complex.
+    if (cmsGetDeviceClass(ContextID, hProfiles[nProfiles-1]) == cmsSigLinkClass) {
+
+        // This tag may exist only on devicelink profiles.
+        if (cmsIsTag(ContextID, hProfiles[nProfiles-1], cmsSigColorantTableOutTag)) {
+
+            // It may be NULL if error
+            xform->core->OutputColorant = cmsDupNamedColorList(ContextID, (cmsNAMEDCOLORLIST*) cmsReadTag(ContextID, hProfiles[nProfiles-1], cmsSigColorantTableOutTag));
+        }
+
+    } else {
+
+        if (cmsIsTag(ContextID, hProfiles[nProfiles-1], cmsSigColorantTableTag)) {
+
+            xform->core->OutputColorant = cmsDupNamedColorList(ContextID, (cmsNAMEDCOLORLIST*) cmsReadTag(ContextID, hProfiles[nProfiles-1], cmsSigColorantTableTag));
+        }
+    }
+
+    // Store the sequence of profiles
+    if (dwFlags & cmsFLAGS_KEEP_SEQUENCE) {
+        xform->core->Sequence = _cmsCompileProfileSequence(ContextID, nProfiles, hProfiles);
+    }
+    else
+        xform->core->Sequence = NULL;
+
+    // If this is a cached transform, init first value, which is zero (16 bits only)
+    if (!(dwFlags & cmsFLAGS_NOCACHE)) {
+
+        memset(&xform ->Cache.CacheIn, 0, sizeof(xform ->Cache.CacheIn));
+
+        if (xform->core->GamutCheck != NULL) {
+            TransformOnePixelWithGamutCheck(ContextID, xform, xform->Cache.CacheIn, xform->Cache.CacheOut);
+        }
+        else {
+
+            xform->core->Lut->Eval16Fn(ContextID, xform ->Cache.CacheIn, xform->Cache.CacheOut, xform->core->Lut->Data);
+        }
+
+    }
+
+    return (cmsHTRANSFORM) xform;
+}
+
+// Multiprofile transforms: Gamut check is not available here, as it is unclear from which profile the gamut comes.
+cmsHTRANSFORM CMSEXPORT cmsCreateMultiprofileTransform(cmsContext ContextID,
+                                                       cmsHPROFILE hProfiles[],
+                                                       cmsUInt32Number nProfiles,
+                                                       cmsUInt32Number InputFormat,
+                                                       cmsUInt32Number OutputFormat,
+                                                       cmsUInt32Number Intent,
+                                                       cmsUInt32Number dwFlags)
+{
+    cmsUInt32Number i;
+    cmsBool BPC[256];
+    cmsUInt32Number Intents[256];
+    cmsFloat64Number AdaptationStates[256];
+
+    if (nProfiles <= 0 || nProfiles > 255) {
+         cmsSignalError(ContextID, cmsERROR_RANGE, "Wrong number of profiles. 1..255 expected, %d found.", nProfiles);
+        return NULL;
+    }
+
+    for (i=0; i < nProfiles; i++) {
+        BPC[i] = dwFlags & cmsFLAGS_BLACKPOINTCOMPENSATION ? TRUE : FALSE;
+        Intents[i] = Intent;
+        AdaptationStates[i] = cmsSetAdaptationState(ContextID, -1);
+    }
+
+
+    return cmsCreateExtendedTransform(ContextID, nProfiles, hProfiles, BPC, Intents, AdaptationStates, NULL, 0, InputFormat, OutputFormat, dwFlags);
+}
+
+
+
+cmsHTRANSFORM CMSEXPORT cmsCreateTransform(cmsContext ContextID,
+                                           cmsHPROFILE Input,
+                                           cmsUInt32Number InputFormat,
+                                           cmsHPROFILE Output,
+                                           cmsUInt32Number OutputFormat,
+                                           cmsUInt32Number Intent,
+                                           cmsUInt32Number dwFlags)
+{
+
+    cmsHPROFILE hArray[2];
+
+    hArray[0] = Input;
+    hArray[1] = Output;
+
+    return cmsCreateMultiprofileTransform(ContextID, hArray, Output == NULL ? 1U : 2U, InputFormat, OutputFormat, Intent, dwFlags);
+}
+
+
+cmsHTRANSFORM CMSEXPORT cmsCreateProofingTransform(cmsContext ContextID,
+                                                   cmsHPROFILE InputProfile,
+                                                   cmsUInt32Number InputFormat,
+                                                   cmsHPROFILE OutputProfile,
+                                                   cmsUInt32Number OutputFormat,
+                                                   cmsHPROFILE ProofingProfile,
+                                                   cmsUInt32Number nIntent,
+                                                   cmsUInt32Number ProofingIntent,
+                                                   cmsUInt32Number dwFlags)
+{
+    cmsHPROFILE hArray[4];
+    cmsUInt32Number Intents[4];
+    cmsBool  BPC[4];
+    cmsFloat64Number Adaptation[4];
+    cmsBool  DoBPC = (dwFlags & cmsFLAGS_BLACKPOINTCOMPENSATION) ? TRUE : FALSE;
+
+
+    hArray[0]  = InputProfile; hArray[1] = ProofingProfile; hArray[2]  = ProofingProfile;               hArray[3] = OutputProfile;
+    Intents[0] = nIntent;      Intents[1] = nIntent;        Intents[2] = INTENT_RELATIVE_COLORIMETRIC;  Intents[3] = ProofingIntent;
+    BPC[0]     = DoBPC;        BPC[1] = DoBPC;              BPC[2] = 0;                                 BPC[3] = 0;
+
+    Adaptation[0] = Adaptation[1] = Adaptation[2] = Adaptation[3] = cmsSetAdaptationState(ContextID, -1);
+
+    if (!(dwFlags & (cmsFLAGS_SOFTPROOFING|cmsFLAGS_GAMUTCHECK)))
+        return cmsCreateTransform(ContextID, InputProfile, InputFormat, OutputProfile, OutputFormat, nIntent, dwFlags);
+
+    return cmsCreateExtendedTransform(ContextID, 4, hArray, BPC, Intents, Adaptation,
+                                        ProofingProfile, 1, InputFormat, OutputFormat, dwFlags);
+
+}
+
+
+
+// Grab the input/output formats
+cmsUInt32Number CMSEXPORT cmsGetTransformInputFormat(cmsContext ContextID, cmsHTRANSFORM hTransform)
+{
+    _cmsTRANSFORM* xform = (_cmsTRANSFORM*) hTransform;
+    cmsUNUSED_PARAMETER(ContextID);
+
+    if (xform == NULL) return 0;
+    return xform->InputFormat;
+}
+
+cmsUInt32Number CMSEXPORT cmsGetTransformOutputFormat(cmsContext ContextID, cmsHTRANSFORM hTransform)
+{
+    _cmsTRANSFORM* xform = (_cmsTRANSFORM*) hTransform;
+    cmsUNUSED_PARAMETER(ContextID);
+
+    if (xform == NULL) return 0;
+    return xform->OutputFormat;
+}
+
+cmsHTRANSFORM cmsCloneTransformChangingFormats(cmsContext ContextID,
+                                               const cmsHTRANSFORM hTransform,
+                                               cmsUInt32Number InputFormat,
+                                               cmsUInt32Number OutputFormat)
+{
+    const _cmsTRANSFORM *oldXform = (const _cmsTRANSFORM *)hTransform;
+    _cmsTRANSFORM *xform;
+    cmsFormatter16 FromInput, ToOutput;
+
+    _cmsAssert(oldXform != NULL && oldXform->core != NULL);
+
+    // We only can afford to change formatters if previous transform is at least 16 bits
+    if (!(oldXform->core->dwOriginalFlags & cmsFLAGS_CAN_CHANGE_FORMATTER)) {
+        cmsSignalError(ContextID, cmsERROR_NOT_SUITABLE, "cmsCloneTransformChangingFormats works only on transforms created originally with at least 16 bits of precision");
+        return NULL;
+    }
+
+    xform = _cmsMalloc(ContextID, sizeof(*xform));
+    if (xform == NULL)
+        return NULL;
+
+    memcpy(xform, oldXform, sizeof(*xform));
+
+    FromInput = _cmsGetFormatter(ContextID, InputFormat,  cmsFormatterInput, CMS_PACK_FLAGS_16BITS).Fmt16;
+    ToOutput  = _cmsGetFormatter(ContextID, OutputFormat, cmsFormatterOutput, CMS_PACK_FLAGS_16BITS).Fmt16;
+
+    if (FromInput == NULL || ToOutput == NULL) {
+
+        cmsSignalError(ContextID, cmsERROR_UNKNOWN_EXTENSION, "Unsupported raster format");
+        return NULL;
+    }
+
+    xform ->InputFormat  = InputFormat;
+    xform ->OutputFormat = OutputFormat;
+    xform ->FromInput    = FromInput;
+    xform ->ToOutput     = ToOutput;
+    _cmsFindFormatter(xform, InputFormat, OutputFormat, xform->core->dwOriginalFlags);
+
+    (void)_cmsAdjustReferenceCount(&xform->core->refs, 1);
+
+    return xform;
+}
diff -Nur ghostscript-9.53.3-orig/lcms2mt/src/mkchg.sh ghostscript-9.53.3/lcms2mt/src/mkchg.sh
--- ghostscript-9.53.3-orig/lcms2mt/src/mkchg.sh	Thu Jan 01 09:00:00 1970
+++ ghostscript-9.53.3/lcms2mt/src/mkchg.sh	Thu Oct 01 22:45:16 2020
@@ -0,0 +1,4 @@
+#!/bin/sh
+sed -e 's#//.*$##g' cmsxform.c >cmsxform.c.tmp
+mv cmsxform.c cmsxform.c.orig
+mv cmsxform.c.tmp cmsxform.c
diff -Nur ghostscript-9.53.3-orig/lib/cidfmap ghostscript-9.53.3/lib/cidfmap
--- ghostscript-9.53.3-orig/lib/cidfmap	Thu Jan 01 09:00:00 1970
+++ ghostscript-9.53.3/lib/cidfmap	Sat Sep 26 07:54:34 2020
@@ -0,0 +1,47 @@
+%!
+% This is a sample map file for CIDFont category.
+
+%
+% The map is a set of records, which must use one of the two formats :
+%
+% 1. A substutution of a CIDFont font with another CIDFont :
+%
+%    /substituted /original ;
+%
+%    Where 'substituted' is a name being used in a document,
+%    'original' is a name of an available resource.
+%
+% 2. A substutution of a CIDFont font with a True Type font :
+%
+%    /substituted << /FileType /TrueType /Path (path) /SubfontID 1 /CSI [(ordering) supplement] >> ;
+%
+%    Where 'substituted' is a name being used in a document,
+%    'path' is a path to a True Type font file,
+%    'ordering' is a value of Ordering required for CIDSystemInfo dictionary,
+%    'supplement' is a value of Supplement required for CIDSystemInfo dictionary.
+%    'SubfontID' is the index of the desired font in a TTC - ignored if the target is not a TTC.
+%
+%    The Ordering, and Registry (if present) entries should be PostScript string types
+%    ie enclosed in parentheses, not PostScript name type (initial character '/'). See
+%    gs/doc/Use.htm#CIDFontSubstitution
+%
+%    Alternatively:
+%    (substituted name) << /FileType /TrueType /Path (path) /SubfontID 1 /CSI [(ordering) supplement] >> ;
+%
+%    This is where the CIDFont name in the document contains a space character. Using a string instead of a name
+%    allows this work - Ghostscript will internally convert the key string with a space to a name.
+%
+%
+% Examples :
+%    
+%   /ShinGo-Bold   /HeiseiKakuGo-W5 ;
+%   /Ryumin-Medium << /FileType /TrueType /Path (H:/AuxFiles/Fonts/BATANG.TTC) /SubfontID 3 /CSI [(Japan1) 2] >> ;
+%   /Ryumin-Medium << /FileType /TrueType /Path (windir) getenv not {(c:/windows)}if (/Fonts/BATANG.TTC)concatstrings /SubfontID 3 /CSI [(Japan1) 2] >> ;
+%
+%   NOTE: getenv returns a boolean to indicate success of or failure, as well as the value on success. In the example, it uses this
+%         to include a default value should getenv fail.
+%
+%  (Century Gothic) << /FileType /TrueType /Path (/usr/share/fonts/truetype/fonts-japanese-gothic.ttf) /CSI [(Identity) 1] >> ;
+%
+%  Note the use of a string to cope with the name containing a space.
+%
diff -Nur ghostscript-9.53.3-orig/lib/dvipdf ghostscript-9.53.3/lib/dvipdf
--- ghostscript-9.53.3-orig/lib/dvipdf	Thu Oct 01 17:11:07 2020
+++ ghostscript-9.53.3/lib/dvipdf	Thu Jan 01 09:00:00 1970
@@ -1,46 +0,0 @@
-#!/bin/sh
-# Convert DVI to PDF.
-#
-# Please contact Andrew Ford <A.Ford@ford-mason.co.uk> with any questions
-# about this file.
-#
-# Based on ps2pdf
-
-# This definition is changed on install to match the
-# executable name set in the makefile
-GS_EXECUTABLE=gs
-
-
-OPTIONS=""
-DVIPSOPTIONS=""
-while true
-do
-	case "$1" in
-	-R*) DVIPSOPTIONS="$DVIPSOPTIONS $1";;
-	-?*) OPTIONS="$OPTIONS $1" ;;
-	*)  break ;;
-	esac
-	shift
-done
-
-if [ $# -lt 1 -o $# -gt 2 ]; then
-	echo "Usage: `basename \"$0\"` [options...] input.dvi [output.pdf]" 1>&2
-	exit 1
-fi
-
-infile=$1;
-
-if [ $# -eq 1 ]
-then
-	case "${infile}" in
-	  *.dvi)	base=`basename "${infile}" .dvi` ;;
-	  *)		base=`basename "${infile}"` ;;
-	esac
-	outfile="${base}".pdf
-else
-	outfile=$2
-fi
-
-# We have to include the options twice because -I only takes effect if it
-# appears before other options.
-exec dvips -Ppdf $DVIPSOPTIONS -q -f "$infile" | $GS_EXECUTABLE $OPTIONS -q -P- -dSAFER -dNOPAUSE -dBATCH -sDEVICE=pdfwrite -sstdout=%stderr -sOutputFile="$outfile" $OPTIONS -
diff -Nur ghostscript-9.53.3-orig/lib/eps2eps ghostscript-9.53.3/lib/eps2eps
--- ghostscript-9.53.3-orig/lib/eps2eps	Thu Oct 01 17:11:07 2020
+++ ghostscript-9.53.3/lib/eps2eps	Thu Jan 01 09:00:00 1970
@@ -1,28 +0,0 @@
-#!/bin/sh
-# "Distill" Encapsulated PostScript.
-
-# This definition is changed on install to match the
-# executable name set in the makefile
-GS_EXECUTABLE=gs
-gs="`dirname \"$0\"`/$GS_EXECUTABLE"
-if test ! -x "$gs"; then
-	gs="$GS_EXECUTABLE"
-fi
-GS_EXECUTABLE="$gs"
-
-OPTIONS="-dDEVICEWIDTH=250000 -dDEVICEHEIGHT=250000"
-while true
-do
-	case "$1" in
-	-?*) OPTIONS="$OPTIONS $1" ;;
-	*)  break ;;
-	esac
-	shift
-done
-
-if [ $# -ne 2 ]; then
-	echo "Usage: `basename \"$0\"` ...switches... input.eps output.eps" 1>&2
-	exit 1
-fi
-
-exec "$GS_EXECUTABLE" -q -sDEVICE=eps2write -sstdout=%stderr "-sOutputFile=$2" -dNOPAUSE -dBATCH -P- -dSAFER $OPTIONS "$1"
diff -Nur ghostscript-9.53.3-orig/lib/eps2eps.cmd ghostscript-9.53.3/lib/eps2eps.cmd
--- ghostscript-9.53.3-orig/lib/eps2eps.cmd	Thu Oct 01 17:11:07 2020
+++ ghostscript-9.53.3/lib/eps2eps.cmd	Thu Jan 01 09:00:00 1970
@@ -1,35 +0,0 @@
-/*
- * This file is maintained by a user: if you have any questions about it,
- * please contact Mark Hale (mark.hale@physics.org).
- */
-
-/* "Distill" Encapsulated PostScript. */
-
-parse arg params
-
-gs='@gsos2'
-
-if params='' then call usage
-
-options='-dNOPAUSE -dBATCH -P- -dSAFER'
-
-/* extract options from command line */
-i=1
-param=word(params,i)
-do while substr(param,1,1)='-'
-	options=options param
-	i=i+1
-	param=word(params,i)
-end
-
-infile=param
-if infile='' then call usage
-outfile=word(params,i+1)
-if outfile='' then call usage
-
-gs '-q -sDEVICE=eps2write -sOutputFile='outfile options infile
-exit
-
-usage:
-say 'Usage: eps2eps ...switches... input.eps output.eps'
-exit
diff -Nur ghostscript-9.53.3-orig/lib/gsbj ghostscript-9.53.3/lib/gsbj
--- ghostscript-9.53.3-orig/lib/gsbj	Thu Oct 01 17:11:07 2020
+++ ghostscript-9.53.3/lib/gsbj	Thu Jan 01 09:00:00 1970
@@ -1,12 +0,0 @@
-#!/bin/sh
-
-# This definition is changed on install to match the
-# executable name set in the makefile
-GS_EXECUTABLE=gs
-gs="`dirname \"$0\"`/$GS_EXECUTABLE"
-if test ! -x "$gs"; then
-	gs="$GS_EXECUTABLE"
-fi
-GS_EXECUTABLE="$gs"
-
-exec "$GS_EXECUTABLE" -q -sDEVICE=bj10e -r180 -P- -dSAFER -dNOPAUSE -sPROGNAME=$0 -- gslp.ps --heading-center "`date`" "$@"
diff -Nur ghostscript-9.53.3-orig/lib/gsdj ghostscript-9.53.3/lib/gsdj
--- ghostscript-9.53.3-orig/lib/gsdj	Thu Oct 01 17:11:07 2020
+++ ghostscript-9.53.3/lib/gsdj	Thu Jan 01 09:00:00 1970
@@ -1,12 +0,0 @@
-#!/bin/sh
-
-# This definition is changed on install to match the
-# executable name set in the makefile
-GS_EXECUTABLE=gs
-gs="`dirname \"$0\"`/$GS_EXECUTABLE"
-if test ! -x "$gs"; then
-	gs="$GS_EXECUTABLE"
-fi
-GS_EXECUTABLE="$gs"
-
-exec "$GS_EXECUTABLE" -q -sDEVICE=deskjet -r300 -P- -dSAFER -dNOPAUSE -sPROGNAME=$0 -- gslp.ps --heading-center "`date`" "$@"
diff -Nur ghostscript-9.53.3-orig/lib/gsdj500 ghostscript-9.53.3/lib/gsdj500
--- ghostscript-9.53.3-orig/lib/gsdj500	Thu Oct 01 17:11:07 2020
+++ ghostscript-9.53.3/lib/gsdj500	Thu Jan 01 09:00:00 1970
@@ -1,12 +0,0 @@
-#!/bin/sh
-
-# This definition is changed on install to match the
-# executable name set in the makefile
-GS_EXECUTABLE=gs
-gs="`dirname \"$0\"`/$GS_EXECUTABLE"
-if test ! -x "$gs"; then
-	gs="$GS_EXECUTABLE"
-fi
-GS_EXECUTABLE="$gs"
-
-exec "$GS_EXECUTABLE" -q -sDEVICE=djet500 -r300 -P- -dSAFER -dNOPAUSE -sPROGNAME=$0 -- gslp.ps --heading-center "`date`" "$@"
diff -Nur ghostscript-9.53.3-orig/lib/gslj ghostscript-9.53.3/lib/gslj
--- ghostscript-9.53.3-orig/lib/gslj	Thu Oct 01 17:11:07 2020
+++ ghostscript-9.53.3/lib/gslj	Thu Jan 01 09:00:00 1970
@@ -1,12 +0,0 @@
-#!/bin/sh
-
-# This definition is changed on install to match the
-# executable name set in the makefile
-GS_EXECUTABLE=gs
-gs="`dirname \"$0\"`/$GS_EXECUTABLE"
-if test ! -x "$gs"; then
-	gs="$GS_EXECUTABLE"
-fi
-GS_EXECUTABLE="$gs"
-
-exec "$GS_EXECUTABLE" -q -sDEVICE=laserjet -r300 -P- -dSAFER -dNOPAUSE -sPROGNAME=$0 -- gslp.ps --heading-center "`date`" "$@"
diff -Nur ghostscript-9.53.3-orig/lib/gslp ghostscript-9.53.3/lib/gslp
--- ghostscript-9.53.3-orig/lib/gslp	Thu Oct 01 17:11:07 2020
+++ ghostscript-9.53.3/lib/gslp	Thu Jan 01 09:00:00 1970
@@ -1,12 +0,0 @@
-#!/bin/sh
-
-# This definition is changed on install to match the
-# executable name set in the makefile
-GS_EXECUTABLE=gs
-gs="`dirname \"$0\"`/$GS_EXECUTABLE"
-if test ! -x "$gs"; then
-	gs="$GS_EXECUTABLE"
-fi
-GS_EXECUTABLE="$gs"
-
-exec "$GS_EXECUTABLE" -q -sDEVICE=epson -r180 -P- -dSAFER -dNOPAUSE -sPROGNAME=$0 -- gslp.ps --heading-center "`date`" "$@"
diff -Nur ghostscript-9.53.3-orig/lib/gsnd ghostscript-9.53.3/lib/gsnd
--- ghostscript-9.53.3-orig/lib/gsnd	Thu Oct 01 17:11:07 2020
+++ ghostscript-9.53.3/lib/gsnd	Thu Jan 01 09:00:00 1970
@@ -1,12 +0,0 @@
-#!/bin/sh
-
-# This definition is changed on install to match the
-# executable name set in the makefile
-GS_EXECUTABLE=gs
-gs="`dirname \"$0\"`/$GS_EXECUTABLE"
-if test ! -x "$gs"; then
-	gs="$GS_EXECUTABLE"
-fi
-GS_EXECUTABLE="$gs"
-
-exec "$GS_EXECUTABLE" -P- -dSAFER -dNODISPLAY "$@"
diff -Nur ghostscript-9.53.3-orig/lib/lprsetup.sh ghostscript-9.53.3/lib/lprsetup.sh
--- ghostscript-9.53.3-orig/lib/lprsetup.sh	Thu Oct 01 17:11:07 2020
+++ ghostscript-9.53.3/lib/lprsetup.sh	Thu Jan 01 09:00:00 1970
@@ -1,223 +0,0 @@
-#!/bin/sh
-#
-# BSD PRINT FILTER SETUP utility for Ghostscript - used and tested on
-# SunOS 4.1.3, but I hope it will be useful on other BSD systems
-# See documentation for usage
-#
-
-GSPATH=
-while [ $# -gt 0 ]
-do
-    case "$1" in
-	-p) GSPATH="$2"/lib/ghostscript; shift;;
-        -h) echo >&2 \
-            "usage: $0 [-p <gs install prefix>]\n"\
-            "Where <gs install prefix> is the ""prefix""\n"\
-            "for the Ghostscript install - the default is\n"\
-            """/usr/local"""
-            exit 1;;
-	-*) echo >&2 \
-	    "usage: $0 [-p <gs install prefix>]"
-	    exit 1;;
-	*)  break;;	# terminate while loop
-    esac
-    shift
-done
-
-DEVICES="bjt600.32 bjc600.32 bjc600.24 bjc600.24.3 bjc600.16 bjc600.8 bjc600.8.1 bjc600.1 bjc600.dq"
-#FILTERS="if nf tf gf vf df cf rf"
-FILTERS="if"
-
-# The port your printer is on
-PRINTERDEV=/dev/lp1
-# The kind of printer (accepted values: 'parallel' and 'serial')
-PRINTERTYPE=parallel
-
-if [ "x$GSPATH"="x" ] ; then
-  GSDIR=`which gs | awk -F / 'sub(FS $NF,x)' | awk -F / 'sub(FS $NF,x)'`/lib/ghostscript
-else
-  GSDIR=$GSPATH
-fi
-
-GSFILTERDIR=$GSDIR/filt
-SPOOLDIR=/var/spool
-GSIF=unix-lpr.sh
-PCAP=printcap.insert
-
-if [ "x$GSPATH"="x" ] ; then
-  echo "Warning: Writing filters to $GSFILTERDIR"
-  echo "if you do not want this, you have 10 seconds to hit ^c to abort this script:"
-  for i in 10 09 08 07 06 05 04 03 02 01 continuing....; do
-   sleep 1
-   echo -n 
-   echo -n $i
-  done
-  echo
-fi
-
-PATH=/bin:/usr/bin:/usr/ucb
-export PATH
-
-if [ ! -w $GSDIR ]; then
-  echo "$GSDIR must be writable to create filter directory"
-  exit 1
-fi
-
-echo "
-Making links in the filter directory $GSFILTERDIR ...
-"
-
-#
-# Make the directory for holding the filter and links
-#
-if [ -d $GSFILTERDIR ]; then
-  echo "$GSFILTERDIR already exists - not created"
-else
-  mkdir $GSFILTERDIR
-fi
-rm -f $GSFILTERDIR/direct
-ln -s . $GSFILTERDIR/direct
-rm -f $GSFILTERDIR/indirect
-ln -s . $GSFILTERDIR/indirect
-
-#
-# Create a link from each filtertype to the real filter script
-#
-for filter in $FILTERS
-do
-  rm -f $GSFILTERDIR/gs$filter
-  ln -s  ../$GSIF $GSFILTERDIR/gs$filter
-done
-
-#
-# Create a link from each device to the filter directory
-#
-for device in $DEVICES
-do
-  dualqueue=
-  case "$device" in
-    *.dq) device=`basename $device .dq` ; dualqueue=t ;;
-  esac
-  rm -f $GSFILTERDIR/$device
-  if [ $dualqueue ]; then
-    rm -f $GSFILTERDIR/indirect/$device
-    ln -s . $GSFILTERDIR/indirect/$device
-  else
-    rm -f $GSFILTERDIR/direct/$device
-    ln -s . $GSFILTERDIR/direct/$device
-  fi
-done
-
-#
-# Create a basic printcap insert - this is made in the CURRENT directory
-#
-rm -f $PCAP
-cat > $PCAP << EOF
-# This is an example printcap insert for Ghostscript printers
-# You will probably want either to change the names for each printer
-# below (first line for each device) to something more sensible, or
-# to add additional name entries (eg cdjcolor for cdj500.24)
-# The example is shown set up for $PRINTERTYPE printers - you will need
-# to alter the entries for different or networked remote printer,
-# eg. a remote network printer would have a line something like:
-#    :lp=:rm=artemis:rp=LPT1:
-# for a PC called artemis, replacing the serial port settings
-#
-# NB/ This is only an example - it is unlikely to be complete or exactly
-# correct for your system, but is designed to illustrate filter names 
-# corresponding to the accompanying bsd-if print filter
-#
-EOF
-
-(
-previous=undefined
-for device in $DEVICES
-do
-  dualqueue=
-  case "$device" in
-    *.dq) device=`basename $device .dq` ; dualqueue=t ;;
-  esac
-  base="`echo $device | sed 's/\.[0-9][0-9]*$//'`"
-  base="`echo $base | sed 's/\.[0-9][0-9]*$//'`"
-#
-# If device listed with '.dq' suffix, we set up a separate output queue
-#
-  if [ $dualqueue ]; then
-    if [ $base != $previous ]; then
-      previous=$base
-      echo "\
-# Entry for raw device $base.raw
-$base.raw|Raw output device $base:\\
-    :lp=$PRINTERDEV:\\"
-    if test "$PRINTERTYPE" = serial
-    then
-	echo "br#19200:xc#0177777:\\"
-        echo ":ms=-parity,ixon,-opost:\\"
-    fi
-    echo ":sd=$SPOOLDIR/$base/raw:\\
-    :mx#0:sf:sh:rs:"
-    fi
-    echo "\
-# Entry for device $device (output to $base.raw)
-$device|Ghostscript device $device:\\
-    :lp=/dev/null:\\"
-  else
-    echo "\
-# Entry for device $device
-$device|Ghostscript device $device:\\
-    :lp=$PRINTERDEV:\\"
-    if test "$PRINTERTYPE" = serial
-    then
-	echo "br#19200:xc#0177777:\\"
-        echo ":ms=-parity,ixon,-opost:\\"
-    fi
-  fi
-  echo "\
-    :sd=$SPOOLDIR/$base:\\
-    :lf=$SPOOLDIR/$base/logfile:\\
-    :af=$SPOOLDIR/$base/acct:\\"
-  for filter in $FILTERS
-  do
-    if [ $dualqueue ]; then
-      echo "\
-    :$filter=$GSFILTERDIR/indirect/$device/gs$filter:\\"
-    else
-      echo "\
-    :$filter=$GSFILTERDIR/direct/$device/gs$filter:\\"
-    fi
-  done
-  echo "\
-    :mx#0:sf:sh:rs:"
-done
-) >> $PCAP
-
-echo "
-Example printcap insert file \"$PCAP\" now created"
-
-#
-# Remind the user what's still to do
-#
-
-echo "
-NB/ You will need to create the following directories, with
-appropriate permissions, and do 'touch logfile' and 'touch acct'
-in the top level directories (ie. not the 'raw' ones):
-"
-(
-for device in $DEVICES
-do
-  dualqueue=
-  case "$device" in
-    *.dq) device=`basename $device .dq` ; dualqueue=t ;;
-  esac
-  base="`echo $device | sed 's/\.[0-9][0-9]*$//'`"
-  base="`echo $base | sed 's/\.[0-9][0-9]*$//'`"
-  echo "  $SPOOLDIR/$base"
-  if [ $dualqueue ]; then
-    echo "  $SPOOLDIR/$base/raw"
-  fi
-done
-) | sort -u
-
-echo "
-        + + + "
diff -Nur ghostscript-9.53.3-orig/lib/pdf2dsc ghostscript-9.53.3/lib/pdf2dsc
--- ghostscript-9.53.3-orig/lib/pdf2dsc	Thu Oct 01 17:11:07 2020
+++ ghostscript-9.53.3/lib/pdf2dsc	Thu Jan 01 09:00:00 1970
@@ -1,34 +0,0 @@
-#! /bin/sh
-
-# psf2dsc: generates an index of a PDF file.
-#
-# Yves Arrouye <arrouye@debian.org>, 1996.
-# 2000-05-18 lpd <ghost@aladdin.com> added -dSAFER
-
-# This definition is changed on install to match the
-# executable name set in the makefile
-GS_EXECUTABLE=gs
-gs="`dirname \"$0\"`/$GS_EXECUTABLE"
-if test ! -x "$gs"; then
-	gs="$GS_EXECUTABLE"
-fi
-GS_EXECUTABLE="$gs"
-
-me=`basename $0`
-
-usage() {
-    >&2 echo usage: $me "pdffile [ dscfile ]"
-    exit 1
-}
-
-if [ $# -gt 2 ]
-then
-    usage
-fi
-
-pdffile=$1
-dscfile=$2
-: ${dscfile:=`echo $pdffile | sed 's,\.[^/.]*,,'`.dsc}
-
-exec "$GS_EXECUTABLE" -q -dNODISPLAY -P- -dSAFER -dDELAYSAFER\
-    -sPDFname="$pdffile" -sDSCname="$dscfile" pdf2dsc.ps -c quit
diff -Nur ghostscript-9.53.3-orig/lib/pdf2ps ghostscript-9.53.3/lib/pdf2ps
--- ghostscript-9.53.3-orig/lib/pdf2ps	Thu Oct 01 17:11:07 2020
+++ ghostscript-9.53.3/lib/pdf2ps	Thu Jan 01 09:00:00 1970
@@ -1,37 +0,0 @@
-#!/bin/sh
-# Convert PDF to PostScript.
-
-# This definition is changed on install to match the
-# executable name set in the makefile
-GS_EXECUTABLE=gs
-gs="`dirname \"$0\"`/$GS_EXECUTABLE"
-if test ! -x "$gs"; then
-	gs="$GS_EXECUTABLE"
-fi
-GS_EXECUTABLE="$gs"
-
-OPTIONS=""
-while true
-do
-	case "$1" in
-	-?*) OPTIONS="$OPTIONS $1" ;;
-	*)  break ;;
-	esac
-	shift
-done
-
-if [ $# -eq 2 ] 
-then
-    outfile=$2
-elif [ $# -eq 1 ]
-then
-    outfile=`basename "$1" \.pdf`.ps
-else
-    echo "Usage: `basename \"$0\"` [-dASCII85EncodePages=false] [-dLanguageLevel=1|2|3] input.pdf [output.ps]" 1>&2
-    exit 1
-fi
-
-# Doing an initial 'save' helps keep fonts from being flushed between pages.
-# We have to include the options twice because -I only takes effect if it
-# appears before other options.
-exec "$GS_EXECUTABLE" $OPTIONS -q -dNOPAUSE -dBATCH -P- -dSAFER -sDEVICE=ps2write "-sOutputFile=$outfile" $OPTIONS -c save pop -f "$1"
diff -Nur ghostscript-9.53.3-orig/lib/pdf2ps.cmd ghostscript-9.53.3/lib/pdf2ps.cmd
--- ghostscript-9.53.3-orig/lib/pdf2ps.cmd	Thu Oct 01 17:11:07 2020
+++ ghostscript-9.53.3/lib/pdf2ps.cmd	Thu Jan 01 09:00:00 1970
@@ -1,40 +0,0 @@
-/*
- * This file is maintained by a user: if you have any questions about it,
- * please contact Mark Hale (mark.hale@physics.org).
- */
-
-/* Convert PDF to PostScript. */
-
-parse arg params
-
-gs='@gsos2'
-inext='.pdf'
-outext='.ps'
-
-if params='' then call usage
-
-options='-dNOPAUSE -dBATCH -P- -dSAFER -sDEVICE=ps2write'
-
-/* extract options from command line */
-i=1
-param=word(params,i)
-do while substr(param,1,1)='-'
-	options=options param
-	i=i+1
-	param=word(params,i)
-end
-
-infile=param
-if infile='' then call usage
-outfile=word(params,i+1)
-if outfile='' then do
-	outfile=infile''outext
-	infile=infile''inext
-end
-
-gs '-q -sOutputFile='outfile options infile
-exit
-
-usage:
-say 'Usage: pdf2ps [-dASCII85DecodePages=false] [-dLanguageLevel=n] input[.pdf output.ps]'
-exit
diff -Nur ghostscript-9.53.3-orig/lib/pf2afm ghostscript-9.53.3/lib/pf2afm
--- ghostscript-9.53.3-orig/lib/pf2afm	Thu Oct 01 17:11:07 2020
+++ ghostscript-9.53.3/lib/pf2afm	Thu Jan 01 09:00:00 1970
@@ -1,16 +0,0 @@
-#!/bin/sh
-# Make an AFM file from PFB / PFA and (optionally) PFM files.  Usage:
-#	pf2afm fontfilename
-# Output goes to fontfilename.afm, which must not already exist.
-# See pf2afm.ps for more details.
-
-# This definition is changed on install to match the
-# executable name set in the makefile
-GS_EXECUTABLE=gs
-gs="`dirname \"$0\"`/$GS_EXECUTABLE"
-if test ! -x "$gs"; then
-	gs="$GS_EXECUTABLE"
-fi
-GS_EXECUTABLE="$gs"
-
-exec "$GS_EXECUTABLE" -q -dNODISPLAY -P- -dSAFER -dDELAYSAFER  -- pf2afm.ps "$@"
diff -Nur ghostscript-9.53.3-orig/lib/pf2afm.cmd ghostscript-9.53.3/lib/pf2afm.cmd
--- ghostscript-9.53.3-orig/lib/pf2afm.cmd	Thu Oct 01 17:11:07 2020
+++ ghostscript-9.53.3/lib/pf2afm.cmd	Thu Jan 01 09:00:00 1970
@@ -1,6 +0,0 @@
-/*
- * This file is maintained by a user: if you have any questions about it,
- * please contact Mark Hale (mark.hale@physics.org).
- */
-
-@gsos2 -q -dNODISPLAY -P- -dSAFER -dDELAYSAFER -- pf2afm.ps %1
diff -Nur ghostscript-9.53.3-orig/lib/pfbtopfa ghostscript-9.53.3/lib/pfbtopfa
--- ghostscript-9.53.3-orig/lib/pfbtopfa	Thu Oct 01 17:11:07 2020
+++ ghostscript-9.53.3/lib/pfbtopfa	Thu Jan 01 09:00:00 1970
@@ -1,24 +0,0 @@
-#!/bin/sh
-# Convert .pfb fonts to .pfa format
-
-# This definition is changed on install to match the
-# executable name set in the makefile
-GS_EXECUTABLE=gs
-gs="`dirname \"$0\"`/$GS_EXECUTABLE"
-if test ! -x "$gs"; then
-	gs="$GS_EXECUTABLE"
-fi
-GS_EXECUTABLE="$gs"
-
-if [ $# -eq 2 ] 
-then
-    outfile=$2
-elif [ $# -eq 1 ]
-then
-    outfile=`basename "$1" \.pfb`.pfa
-else
-    echo "Usage: `basename \"$0\"` input.pfb [output.pfa]" 1>&2
-    exit 1
-fi
-
-exec "$GS_EXECUTABLE" -q -P- -dNODISPLAY -- pfbtopfa.ps "$1" "$outfile"
diff -Nur ghostscript-9.53.3-orig/lib/pphs ghostscript-9.53.3/lib/pphs
--- ghostscript-9.53.3-orig/lib/pphs	Thu Oct 01 17:11:07 2020
+++ ghostscript-9.53.3/lib/pphs	Thu Jan 01 09:00:00 1970
@@ -1,15 +0,0 @@
-#!/bin/sh
-# Print the Primary Hint Stream from a linearized PDF file.  Usage:
-#	pphs filename.pdf
-# Output goes to stdout.
-
-# This definition is changed on install to match the
-# executable name set in the makefile
-GS_EXECUTABLE=gs
-gs="`dirname \"$0\"`/$GS_EXECUTABLE"
-if test ! -x "$gs"; then
-	gs="$GS_EXECUTABLE"
-fi
-GS_EXECUTABLE="$gs"
-
-exec "$GS_EXECUTABLE" -q -P- -dSAFER -dNODISPLAY -- pphs.ps "$@"
diff -Nur ghostscript-9.53.3-orig/lib/printafm ghostscript-9.53.3/lib/printafm
--- ghostscript-9.53.3-orig/lib/printafm	Thu Oct 01 17:11:07 2020
+++ ghostscript-9.53.3/lib/printafm	Thu Jan 01 09:00:00 1970
@@ -1,15 +0,0 @@
-#!/bin/sh
-# Print the metrics from a font in AFM format.  Usage:
-#	printafm fontname
-# Output goes to stdout.
-
-# This definition is changed on install to match the
-# executable name set in the makefile
-GS_EXECUTABLE=gs
-gs="`dirname \"$0\"`/$GS_EXECUTABLE"
-if test ! -x "$gs"; then
-	gs="$GS_EXECUTABLE"
-fi
-GS_EXECUTABLE="$gs"
-
-exec "$GS_EXECUTABLE" -q -P- -dSAFER -dNODISPLAY -- printafm.ps "$@"
diff -Nur ghostscript-9.53.3-orig/lib/ps2ascii ghostscript-9.53.3/lib/ps2ascii
--- ghostscript-9.53.3-orig/lib/ps2ascii	Thu Oct 01 17:11:07 2020
+++ ghostscript-9.53.3/lib/ps2ascii	Thu Jan 01 09:00:00 1970
@@ -1,21 +0,0 @@
-#!/bin/sh
-# Extract ASCII text from a PostScript file.  Usage:
-#	ps2ascii [infile.ps [outfile.txt]]
-# If outfile is omitted, output goes to stdout.
-# If both infile and outfile are omitted, ps2ascii acts as a filter,
-# reading from stdin and writing on stdout.
-
-# This definition is changed on install to match the
-# executable name set in the makefile
-GS_EXECUTABLE=gs
-
-trap "rm -f _temp_.err _temp_.out" 0 1 2 15
-
-OPTIONS="-q -dSAFER -sDEVICE=txtwrite"
-if ( test $# -eq 0 ) then
-    $GS_EXECUTABLE $OPTIONS -o - -
-elif ( test $# -eq 1 ) then
-    $GS_EXECUTABLE $OPTIONS -o - "$1"
-else
-    $GS_EXECUTABLE $OPTIONS -o "$2" "$1"
-fi
diff -Nur ghostscript-9.53.3-orig/lib/ps2ascii.cmd ghostscript-9.53.3/lib/ps2ascii.cmd
--- ghostscript-9.53.3-orig/lib/ps2ascii.cmd	Thu Oct 01 17:11:07 2020
+++ ghostscript-9.53.3/lib/ps2ascii.cmd	Thu Jan 01 09:00:00 1970
@@ -1,17 +0,0 @@
-/*
- * This file is maintained by a user: if you have any questions about it,
- * please contact Mark Hale (mark.hale@physics.org).
- */
-
-@echo off
-if '%1'=='' goto a0
-if '%2'=='' goto a1
-gsos2 -q -dSAFER -sDEVICE=txtwrite -o %2 %1
-goto x
-:a0
-gsos2 -q -dSAFER -sDEVICE=txtwrite -o - -
-goto x
-:a1
-gsos2 -q -dSAFER -sDEVICE=txtwrite -o - %1
-goto x
-:x
diff -Nur ghostscript-9.53.3-orig/lib/ps2epsi ghostscript-9.53.3/lib/ps2epsi
--- ghostscript-9.53.3-orig/lib/ps2epsi	Thu Oct 01 17:11:07 2020
+++ ghostscript-9.53.3/lib/ps2epsi	Thu Jan 01 09:00:00 1970
@@ -1,47 +0,0 @@
-#!/bin/sh
-
-# Revised in 2020 to use the eps2write device (within ps2epsi.ps)
-
-# This definition is changed on install to match the
-# executable name set in the makefile, but we check a couple of other
-# places (bin/ sibling to $LIBDIR and 'gs' on the $PATH)
-GS_EXECUTABLE=gs
-LIBDIR=`dirname $0`
-gs="$LIBDIR/$GS_EXECUTABLE"
-if test ! -x "$gs"; then
-	# Might be executing lib/ps2epsi with bin/ as sibling to lib/
-	gs="$LIBDIR/../bin/$GS_EXECUTABLE"
-	if test ! -x "$gs"; then
-		# Fallback to using any 'gs' on the path
-		gs="$GS_EXECUTABLE"
-	fi
-fi
-GS_EXECUTABLE="$gs"
-
-export outfile
-
-if [ $# -lt 1 -o $# -gt 2 ]; then
-	echo "Usage: `basename \"$0\"` file.ps [file.epsi]" 1>&2
-	exit 1
-fi
-
-infile=$1;
-
-if [ $# -eq 1 ]; then
-	case "${infile}" in
-	  *.ps)		base=`basename "${infile}" .ps` ;;
-	  *.cps)	base=`basename "${infile}" .cps` ;;
-	  *.eps)	base=`basename "${infile}" .eps` ;;
-	  *.epsf)	base=`basename "${infile}" .epsf` ;;
-	  *)		base=`basename "${infile}"` ;;
-	esac
-	outfile=${base}.epsi
-else
-	outfile=$2
-fi
-
-# Note, we expect 'ps2epsi.ps' to be in the same directory as 'ps2epsi'
-"$GS_EXECUTABLE" -q -dNOOUTERSAVE -dNODISPLAY -dLastPage=1 -sOutputFile="${outfile}" \
-		--permit-file-all="${infile}" -- "$LIBDIR/ps2epsi.ps"  "${infile}" 1>&2
-
-exit 0
diff -Nur ghostscript-9.53.3-orig/lib/ps2epsi.cmd ghostscript-9.53.3/lib/ps2epsi.cmd
--- ghostscript-9.53.3-orig/lib/ps2epsi.cmd	Thu Oct 01 17:11:07 2020
+++ ghostscript-9.53.3/lib/ps2epsi.cmd	Thu Jan 01 09:00:00 1970
@@ -1,16 +0,0 @@
-@echo off
-if %1/==/ goto usage
-if %2/==/ goto usage
-
-set infile=%1
-set outfile=%2
-
-rem Now convert the input to EPSF and add the Preview to the EPSF file
-gsos2 -q -dNOOUTERSAVE -dNODISPLAY -dLastPage=1 -sOutputFile=%outfile% --permit-file-read=%infile% %~dp0ps2epsi.ps %infile%
-
-goto end
-
-:usage
-echo "Usage: ps2epsi <infile.ps> <outfile.epi>"
-
-:end
diff -Nur ghostscript-9.53.3-orig/lib/ps2pdf ghostscript-9.53.3/lib/ps2pdf
--- ghostscript-9.53.3-orig/lib/ps2pdf	Thu Oct 01 17:11:07 2020
+++ ghostscript-9.53.3/lib/ps2pdf	Thu Jan 01 09:00:00 1970
@@ -1,12 +0,0 @@
-#!/bin/sh
-# Convert PostScript to PDF.
-
-# Currently, we produce PDF 1.4 by default, but this is not guaranteed
-# not to change in the future.
-version=14
-
-ps2pdf="`dirname \"$0\"`/ps2pdf$version"
-if test ! -x "$ps2pdf"; then
-	ps2pdf="ps2pdf$version"
-fi
-exec "$ps2pdf" "$@"
diff -Nur ghostscript-9.53.3-orig/lib/ps2pdf.bat ghostscript-9.53.3/lib/ps2pdf.bat
--- ghostscript-9.53.3-orig/lib/ps2pdf.bat	Thu Oct 01 17:11:07 2020
+++ ghostscript-9.53.3/lib/ps2pdf.bat	Sat Sep 26 07:15:22 2020
@@ -6,8 +6,8 @@
 
 set LIBDIR=%~dp0
 
-rem The current default compatibility level is PDF 1.4.
-echo -dCompatibilityLevel#1.4 >"%TEMP%\_.at"
+rem The current default compatibility level is PDF 1.5.
+echo -dCompatibilityLevel#1.5 >"%TEMP%\_.at"
 goto bot
 
 rem Pass arguments through a file to avoid overflowing the command line.
diff -Nur ghostscript-9.53.3-orig/lib/ps2pdf.cmd ghostscript-9.53.3/lib/ps2pdf.cmd
--- ghostscript-9.53.3-orig/lib/ps2pdf.cmd	Thu Oct 01 17:11:07 2020
+++ ghostscript-9.53.3/lib/ps2pdf.cmd	Thu Jan 01 09:00:00 1970
@@ -1,42 +0,0 @@
-/*
- * This file is maintained by a user: if you have any questions about it,
- * please contact Mark Hale (mark.hale@physics.org).
- */
-
-/* Convert PostScript to PDF 1.4 (Acrobat 5-and-later compatible). */
-/* The PDF compatibility level may change in the future: */
-/* use ps2pdf12 or ps2pdf13 if you want a specific level. */
-
-parse arg params
-
-gs='@gsos2'
-inext='.ps'
-outext='.pdf'
-
-if params='' then call usage
-
-options=''
-
-/* extract options from command line */
-i=1
-param=word(params,i)
-do while substr(param,1,1)='-'
-	options=options param
-	i=i+1
-	param=word(params,i)
-end
-
-infile=param
-if infile='' then call usage
-outfile=word(params,i+1)
-if outfile='' then do
-	outfile=infile''outext
-	infile=infile''inext
-end
-
-gs options '-q -P- -dSAFER -dNOPAUSE -dBATCH -sDEVICE=pdfwrite -sOutputFile='outfile options '-c save pop -f' infile
-exit
-
-usage:
-say 'Usage: ps2pdf [options...] input[.ps output.pdf]'
-exit
diff -Nur ghostscript-9.53.3-orig/lib/ps2pdf12 ghostscript-9.53.3/lib/ps2pdf12
--- ghostscript-9.53.3-orig/lib/ps2pdf12	Thu Oct 01 17:11:07 2020
+++ ghostscript-9.53.3/lib/ps2pdf12	Thu Jan 01 09:00:00 1970
@@ -1,7 +0,0 @@
-#!/bin/sh
-# Convert PostScript to PDF 1.2 (Acrobat 3-and-later compatible).
-ps2pdfwr="`dirname \"$0\"`/ps2pdfwr"
-if test ! -x "$ps2pdfwr"; then
-	ps2pdfwr="ps2pdfwr"
-fi
-exec "$ps2pdfwr" -dCompatibilityLevel=1.2 "$@"
diff -Nur ghostscript-9.53.3-orig/lib/ps2pdf12.cmd ghostscript-9.53.3/lib/ps2pdf12.cmd
--- ghostscript-9.53.3-orig/lib/ps2pdf12.cmd	Thu Oct 01 17:11:07 2020
+++ ghostscript-9.53.3/lib/ps2pdf12.cmd	Thu Jan 01 09:00:00 1970
@@ -1,10 +0,0 @@
-/*
- * This file is maintained by a user: if you have any questions about it,
- * please contact Mark Hale (mark.hale@physics.org).
- */
-
-/* Convert PostScript to PDF 1.2 (Acrobat 3-and-later compatible). */
-
-parse arg params
-
-call 'ps2pdf' '-dCompatibilityLevel=1.2' params
diff -Nur ghostscript-9.53.3-orig/lib/ps2pdf13 ghostscript-9.53.3/lib/ps2pdf13
--- ghostscript-9.53.3-orig/lib/ps2pdf13	Thu Oct 01 17:11:07 2020
+++ ghostscript-9.53.3/lib/ps2pdf13	Thu Jan 01 09:00:00 1970
@@ -1,7 +0,0 @@
-#!/bin/sh
-# Convert PostScript to PDF 1.3 (Acrobat 4-and-later compatible).
-ps2pdfwr="`dirname \"$0\"`/ps2pdfwr"
-if test ! -x "$ps2pdfwr"; then
-	ps2pdfwr="ps2pdfwr"
-fi
-exec "$ps2pdfwr" -dCompatibilityLevel=1.3 "$@"
diff -Nur ghostscript-9.53.3-orig/lib/ps2pdf13.cmd ghostscript-9.53.3/lib/ps2pdf13.cmd
--- ghostscript-9.53.3-orig/lib/ps2pdf13.cmd	Thu Oct 01 17:11:07 2020
+++ ghostscript-9.53.3/lib/ps2pdf13.cmd	Thu Jan 01 09:00:00 1970
@@ -1,10 +0,0 @@
-/*
- * This file is maintained by a user: if you have any questions about it,
- * please contact Mark Hale (mark.hale@physics.org).
- */
-
-/* Convert PostScript to PDF 1.3 (Acrobat 4-and-later compatible). */
-
-parse arg params
-
-call 'ps2pdf' '-dCompatibilityLevel=1.3' params
diff -Nur ghostscript-9.53.3-orig/lib/ps2pdf14 ghostscript-9.53.3/lib/ps2pdf14
--- ghostscript-9.53.3-orig/lib/ps2pdf14	Thu Oct 01 17:11:07 2020
+++ ghostscript-9.53.3/lib/ps2pdf14	Thu Jan 01 09:00:00 1970
@@ -1,7 +0,0 @@
-#!/bin/sh
-# Convert PostScript to PDF 1.4 (Acrobat 5-and-later compatible).
-ps2pdfwr="`dirname \"$0\"`/ps2pdfwr"
-if test ! -x "$ps2pdfwr"; then
-	ps2pdfwr="ps2pdfwr"
-fi
-exec "$ps2pdfwr" -dCompatibilityLevel=1.4 "$@"
diff -Nur ghostscript-9.53.3-orig/lib/ps2pdf14.cmd ghostscript-9.53.3/lib/ps2pdf14.cmd
--- ghostscript-9.53.3-orig/lib/ps2pdf14.cmd	Thu Oct 01 17:11:07 2020
+++ ghostscript-9.53.3/lib/ps2pdf14.cmd	Thu Jan 01 09:00:00 1970
@@ -1,10 +0,0 @@
-/*
- * This file is maintained by a user: if you have any questions about it,
- * please contact Mark Hale (mark.hale@physics.org).
- */
-
-/* Convert PostScript to PDF 1.4 (Acrobat 5-and-later compatible). */
-
-parse arg params
-
-call 'ps2pdf' '-dCompatibilityLevel=1.4' params
diff -Nur ghostscript-9.53.3-orig/lib/ps2pdfwr ghostscript-9.53.3/lib/ps2pdfwr
--- ghostscript-9.53.3-orig/lib/ps2pdfwr	Thu Oct 01 17:11:07 2020
+++ ghostscript-9.53.3/lib/ps2pdfwr	Thu Jan 01 09:00:00 1970
@@ -1,44 +0,0 @@
-#!/bin/sh
-# Convert PostScript to PDF without specifying CompatibilityLevel.
-
-# This definition is changed on install to match the
-# executable name set in the makefile
-GS_EXECUTABLE=gs
-gs="`dirname \"$0\"`/$GS_EXECUTABLE"
-if test ! -x "$gs"; then
-	gs="$GS_EXECUTABLE"
-fi
-GS_EXECUTABLE="$gs"
-
-OPTIONS="-P- -dSAFER"
-while true
-do
-	case "$1" in
-	-?*) OPTIONS="$OPTIONS $1" ;;
-	*)  break ;;
-	esac
-	shift
-done
-
-if [ $# -lt 1 -o $# -gt 2 ]; then
-	echo "Usage: `basename \"$0\"` [options...] (input.[e]ps|-) [output.pdf|-]" 1>&2
-	exit 1
-fi
-
-infile="$1";
-
-if [ $# -eq 1 ]
-then
-	case "${infile}" in
-	  -)		outfile=- ;;
-	  *.eps)	base=`basename "${infile}" .eps`; outfile="${base}.pdf" ;;
-	  *.ps)		base=`basename "${infile}" .ps`; outfile="${base}.pdf" ;;
-	  *)		base=`basename "${infile}"`; outfile="${base}.pdf" ;;
-	esac
-else
-	outfile="$2"
-fi
-
-# We have to include the options twice because -I only takes effect if it
-# appears before other options.
-exec "$GS_EXECUTABLE" $OPTIONS -q -P- -dNOPAUSE -dBATCH -sDEVICE=pdfwrite -sstdout=%stderr "-sOutputFile=$outfile" $OPTIONS "$infile"
diff -Nur ghostscript-9.53.3-orig/lib/ps2pdfxx.bat ghostscript-9.53.3/lib/ps2pdfxx.bat
--- ghostscript-9.53.3-orig/lib/ps2pdfxx.bat	Thu Oct 01 17:11:07 2020
+++ ghostscript-9.53.3/lib/ps2pdfxx.bat	Sat Sep 26 07:17:08 2020
@@ -6,7 +6,7 @@
 rem to this file.
 
 call "%~dp0gssetgs.bat"
-echo -q -P- -dSAFER -dNOPAUSE -dBATCH -sDEVICE#pdfwrite >"%TEMP%\_.at"2
+echo -q -P- -dALLOWPSTRANSPARENCY -dNOPAUSE -dBATCH -sDEVICE#pdfwrite >"%TEMP%\_.at"2
 
 if "%OS%"=="Windows_NT" goto nt
 
diff -Nur ghostscript-9.53.3-orig/lib/ps2ps ghostscript-9.53.3/lib/ps2ps
--- ghostscript-9.53.3-orig/lib/ps2ps	Thu Oct 01 17:11:07 2020
+++ ghostscript-9.53.3/lib/ps2ps	Thu Jan 01 09:00:00 1970
@@ -1,29 +0,0 @@
-#!/bin/sh
-# "Distill" PostScript.
-
-# This definition is changed on install to match the
-# executable name set in the makefile
-GS_EXECUTABLE=gs
-gs="`dirname \"$0\"`/$GS_EXECUTABLE"
-if test ! -x "$gs"; then
-	gs="$GS_EXECUTABLE"
-fi
-GS_EXECUTABLE="$gs"
-
-OPTIONS="-P- -dSAFER"
-while true
-do
-	case "$1" in
-	-?*) OPTIONS="$OPTIONS $1" ;;
-	*)  break ;;
-	esac
-	shift
-done
-
-if [ $# -ne 2 ]; then
-	echo "Usage: `basename \"$0\"` [options] input.ps output.ps" 1>&2
-	echo "  e.g. `basename \"$0\"` -sPAPERSIZE=a4 input.ps output.ps" 1>&2
-	exit 1
-fi
-
-exec "$GS_EXECUTABLE" -q -sDEVICE=ps2write -sstdout=%stderr "-sOutputFile=$2" -dNOPAUSE -dBATCH $OPTIONS "$1"
diff -Nur ghostscript-9.53.3-orig/lib/ps2ps.cmd ghostscript-9.53.3/lib/ps2ps.cmd
--- ghostscript-9.53.3-orig/lib/ps2ps.cmd	Thu Oct 01 17:11:07 2020
+++ ghostscript-9.53.3/lib/ps2ps.cmd	Thu Jan 01 09:00:00 1970
@@ -1,35 +0,0 @@
-/*
- * This file is maintained by a user: if you have any questions about it,
- * please contact Mark Hale (mark.hale@physics.org).
- */
-
-/* "Distill" PostScript. */
-
-parse arg params
-
-gs='@gsos2'
-
-if params='' then call usage
-
-options='-P- -dSAFER -dNOPAUSE -dBATCH'
-
-/* extract options from command line */
-i=1
-param=word(params,i)
-do while substr(param,1,1)='-'
-	options=options param
-	i=i+1
-	param=word(params,i)
-end
-
-infile=param
-if infile='' then call usage
-outfile=word(params,i+1)
-if outfile='' then call usage
-
-gs '-q -sDEVICE=ps2write -sOutputFile='outfile options infile
-exit
-
-usage:
-say 'Usage: ps2ps ...switches... input.ps output.ps'
-exit
diff -Nur ghostscript-9.53.3-orig/lib/ps2ps2 ghostscript-9.53.3/lib/ps2ps2
--- ghostscript-9.53.3-orig/lib/ps2ps2	Thu Oct 01 17:11:07 2020
+++ ghostscript-9.53.3/lib/ps2ps2	Thu Jan 01 09:00:00 1970
@@ -1,26 +0,0 @@
-#!/bin/sh
-# "Distill" PostScript with the Ghostscript 'ps2write' device
-# this generates a PDF-style stream with an attached 
-# PostScript program to interpret it.
-
-# This definition is changed on install to match the
-# executable name set in the makefile
-GS_EXECUTABLE=gs
-
-OPTIONS="-P- -dSAFER"
-while true
-do
-	case "$1" in
-	-?*) OPTIONS="$OPTIONS $1" ;;
-	*)  break ;;
-	esac
-	shift
-done
-
-if [ $# -ne 2 ]; then
-	echo "Usage: `basename \"$0\"` [options] input.ps output.ps" 1>&2
-	echo "  e.g. `basename \"$0\"` -sPAPERSIZE=a4 input.ps output.ps" 1>&2
-	exit 1
-fi
-
-exec $GS_EXECUTABLE -q -sDEVICE=ps2write -sstdout=%stderr "-sOutputFile=$2" -dNOPAUSE -dBATCH $OPTIONS "$1"
diff -Nur ghostscript-9.53.3-orig/lib/ps2ps2.cmd ghostscript-9.53.3/lib/ps2ps2.cmd
--- ghostscript-9.53.3-orig/lib/ps2ps2.cmd	Thu Oct 01 17:11:07 2020
+++ ghostscript-9.53.3/lib/ps2ps2.cmd	Thu Jan 01 09:00:00 1970
@@ -1,35 +0,0 @@
-/*
- * This file is maintained by a user: if you have any questions about it,
- * please contact Mark Hale (mark.hale@physics.org).
- */
-
-/* "Distill" PostScript. */
-
-parse arg params
-
-gs='@gsos2'
-
-if params='' then call usage
-
-options='-P- -dSAFER -dNOPAUSE -dBATCH'
-
-/* extract options from command line */
-i=1
-param=word(params,i)
-do while substr(param,1,1)='-'
-	options=options param
-	i=i+1
-	param=word(params,i)
-end
-
-infile=param
-if infile='' then call usage
-outfile=word(params,i+1)
-if outfile='' then call usage
-
-gs '-q -sDEVICE=ps2write -sOutputFile='outfile options infile
-exit
-
-usage:
-say 'Usage: ps2ps ...switches... input.ps output.ps'
-exit
diff -Nur ghostscript-9.53.3-orig/lib/unix-lpr.sh ghostscript-9.53.3/lib/unix-lpr.sh
--- ghostscript-9.53.3-orig/lib/unix-lpr.sh	Thu Oct 01 17:11:07 2020
+++ ghostscript-9.53.3/lib/unix-lpr.sh	Thu Jan 01 09:00:00 1970
@@ -1,165 +0,0 @@
-#!/bin/sh
-#
-# Unix lpr filter. The default setup sends output directly to a pipe,
-# which requires the Ghostscript process to fork, and thus may cause 
-# small systems to run out of memory/swap space. An alternative strategy,
-# based on a suggestion by Andy Fyfe (andy@cs.caltech.edu), uses a named
-# pipe for output, which avoids the fork and can thus save a lot of memory.
-#
-# Unfortunately this approach can cause problems when a print job is aborted, 
-# as the abort can cause one of the processes to die, leaving the process 
-# at the other end of the pipe hanging forever.
-#
-# Because of this, the named pipe method has not been made the default,
-# but it may be restored by commenting out the lines referring to
-# 'gsoutput' and uncommenting the lines referring to 'gspipe'.
-#
-
-# This definition is changed on install to match the
-# executable name set in the makefile
-GS_EXECUTABLE=gs
-
-PBMPLUSPATH=/usr/local/bin
-PSFILTERPATH=/usr/local/lib/ghostscript
-LOCALPATH=/usr/local/bin
-X11HOME=/usr/X11R6
-
-PATH=/bin:/usr/bin:/usr/ucb:/usr/etc
-PATH=${PATH}\:${LOCALPATH}\:${PBMPLUSPATH}\:${PSFILTERPATH}
-LD_LIBRARY_PATH=${X11HOME}/lib
-
-export PATH LD_LIBRARY_PATH acctfile host user
-
-user= host= acctfile=/dev/null
-
-#
-# Redirect stdout to stderr (for the logfile) and open a new channel
-# connected to stdout for the raw data. This enables us to keep the
-# raw data separate from programmed postscript output and error messages.
-#
-exec 3>&1 1>&2
-
-#
-# Get username and hostname from filter parameters
-#
-while [ $# != 0 ]
-do  case "$1" in
-  -n)	user=$2 ; shift ;;
-  -h)	host=$2 ; shift ;;
-  -*)	;;
-  *)	acctfile=$1 ;;
-  esac
-  shift
-done
-
-#
-# Get the filter, printer device and queue type (direct/indirect)
-#
-filter=`basename $0`
-device=`dirname $0`
-type=`dirname ${device}`
-device=`basename ${device}`
-fdevname=$device
-type=`basename ${type}`
-
-#
-# Find the bpp and number of colors, if specified
-#
-
-colorspec="`echo ${device} | sed 's/.*\.[0-9][0-9]*\.\([0-9][0-9]*\)$/\1/'`"
-if test "$colorspec" = "${device}"
-then
-    colorspec=""
-else
-    device=`basename ${device} .$colorspec`
-    colorspec="-dColors=$colorspec"
-fi
-
-bpp="`echo ${device} | sed 's/.*\.\([0-9][0-9]*\)$/\1/'`"
-if test "$bpp" = "${device}"
-then
-    bpp=1
-else
-    device=`basename ${device} .$bpp`
-fi
-
-#
-# Information for the logfile
-#
-lock=`dirname ${acctfile}`/lock
-cf=`sed -n '$p' ${lock}`
-job=`sed -n 's/^J//p' ${cf}`
- 
-echo "gsbanner: ${host}:${user}  Job: ${job}  Date: `date`"
-echo "gsif: ${host}:${user} ${fdevname} start - `date`"
-
-#
-# Set the direct or indirect output destinations
-#
-#gspipe=/tmp/gspipe.$$
-#mknod ${gspipe} p
-
-case "${type}" in
-  direct)
-		gsoutput="cat 1>&3" ;;
-#		cat ${gspipe} 1>&3 & ;;
-  indirect)
-		gsoutput="lpr -P${device}.raw" ;;
-#		cat ${gspipe} | lpr -P${device}.raw & ;;
-esac
-
-(
-#
-# Any setup required may be done here (eg. setting gamma for colour printing)
-#
-#echo "{0.333 exp} dup dup currenttransfer setcolortransfer"
-
-#
-# The input data is filtered here, before being passed on to Ghostscript
-#
-case "${filter}" in
-  gsif)	  cat ;;
-  gsnf)	  psdit ;;
-  gstf)	  pscat ;;
-  gsgf)	  psplot ;;
-  gsvf)	  rasttopnm | pnmtops ;;
-  gsdf)	  dvi2ps -sqlw ;;
-  gscf|gsrf) echo "${filter}: filter not available" 1>&2 ; exit 0 ;;
-esac
-
-#
-# This is the postlude which does the accounting
-#
-echo "\
-(acctfile) getenv
-  { currentdevice /PageCount gsgetdeviceprop dup cvi 0 gt
-    { exch (a) file /acctfile exch def
-      /string 20 string def
-      string cvs dup length dup
-      4 lt
-        { 4 exch sub
-          { acctfile ( ) writestring } repeat
-        } { pop } ifelse
-      acctfile exch writestring
-      acctfile (.00 ) writestring
-      acctfile (host) getenv 
-        { string cvs } { (NOHOST) } ifelse writestring
-      acctfile (:) writestring
-      acctfile (user) getenv
-        { string cvs } { (NOUSER) } ifelse writestring
-      acctfile (\n) writestring
-      acctfile closefile
-    } { pop } ifelse
-  } if
-quit"
-) | $GS_EXECUTABLE -q -P- -dSAFER -dNOPAUSE -sDEVICE=${device} \
-		-dBitsPerPixel=${bpp} $colorspec \
-		-sOutputFile=\|"${gsoutput}" -
-#		-sOutputFile=${gspipe} -
-
-rm -f ${gspipe}
-#
-# End the logfile entry
-#
-echo "gsif: end - `date`"
-
diff -Nur ghostscript-9.53.3-orig/psi/iconf.c ghostscript-9.53.3/psi/iconf.c
--- ghostscript-9.53.3-orig/psi/iconf.c	Thu Oct 01 17:11:07 2020
+++ ghostscript-9.53.3/psi/iconf.c	Thu Oct 01 22:35:30 2020
@@ -77,6 +77,7 @@
 oper_(interp1_op_defs)		/* Interpreter operators */
 oper_(interp2_op_defs)		/* ibid. */
 #include "iconfig.h"
+#include "gconf.h"
 #undef oper_
 const op_def *const op_defs_all[] = {
 #define oper_(defs) defs,
diff -Nur ghostscript-9.53.3-orig/psi/int.mak ghostscript-9.53.3/psi/int.mak
--- ghostscript-9.53.3-orig/psi/int.mak	Thu Oct 01 17:11:07 2020
+++ ghostscript-9.53.3/psi/int.mak	Thu Oct 01 22:42:04 2020
@@ -1861,6 +1861,20 @@
 
 # ================ Dependencies for auxiliary programs ================ #
 
+#
+# ================ Kanji font support
+#
+ 
+kanji_=$(PSOBJ)kfutil.obj $(PSOBJ)zkfimpath.obj
+$(PSD)kanji.dev: $(kanji_)
+	$(SETMOD) $(PSD)kanji $(kanji_)
+	$(ADDMOD) $(PSD)kanji -oper zkfimagepath
+
+kfwin32_=$(PSOBJ)zkfwin32.$(OBJ)
+$(PSD)kfwin32.dev: $(kfwin32_) $(PSD)kanji.dev
+	$(SETMOD) $(PSD)kfwin32 $(kfwin32_)
+	$(ADDMOD) $(PSD)kfwin32 -oper zkfwin32
+	$(ADDMOD) $(PSD)kfwin32 -ps kfwin32 kfwin32bm
 # ============================= Main program ============================== #
 
 $(PSOBJ)gs.$(OBJ) : $(PSSRC)gs.c $(GH)\
diff -Nur ghostscript-9.53.3-orig/psi/msvc.mak ghostscript-9.53.3/psi/msvc.mak
--- ghostscript-9.53.3-orig/psi/msvc.mak	Thu Oct 01 17:11:07 2020
+++ ghostscript-9.53.3/psi/msvc.mak	Thu Oct 01 22:42:46 2020
@@ -48,7 +48,7 @@
 DEBUG=0
 !endif
 !ifndef TDEBUG
-TDEBUG=1
+TDEBUG=0
 !endif
 !ifndef DEBUGSYM
 DEBUGSYM=1
@@ -302,7 +302,7 @@
 # Define the root directory for Ghostscript installation.
 
 !ifndef AROOTDIR
-AROOTDIR=c:/gs
+AROOTDIR=C:/gs
 !endif
 !ifndef GSROOTDIR
 GSROOTDIR=$(AROOTDIR)/gs$(GS_DOT_VERSION)
@@ -321,7 +321,7 @@
 # illegal escape.
 
 !ifndef GS_LIB_DEFAULT
-GS_LIB_DEFAULT=$(GSROOTDIR)/Resource/Init;$(GSROOTDIR)/lib;$(GSROOTDIR)/Resource/Font;$(AROOTDIR)/fonts
+GS_LIB_DEFAULT=C:/Windows/Fonts;C:/WINDOWS/Fonts;C:/windows/Fonts
 !endif
 
 # Define whether or not searching for initialization files should always
@@ -631,7 +631,7 @@
 FTSRCDIR=freetype
 !endif
 !ifndef FT_CFLAGS
-FT_CFLAGS=-I$(FTSRCDIR)\include
+FT_CFLAGS=/I$(FTSRCDIR)/include /I.
 !endif
 
 !ifdef BITSTREAM_BRIDGE
@@ -1006,7 +1006,7 @@
 !ifndef MSVC_VERSION
 !MESSAGE Could not determine MSVC_VERSION! Guessing at an ancient one.
 !MESSAGE Unknown nmake version: $(_NMAKE_VER)
-MSVC_VERSION=6
+MSVC_VERSION=10
 !endif
 !ifndef MSVC_MINOR_VERSION
 MSVC_MINOR_VERSION=0
@@ -1128,9 +1128,9 @@
 !if $(MSVC_VERSION) == 10
 ! ifndef DEVSTUDIO
 !if $(BUILD_SYSTEM) == 64
-DEVSTUDIO=C:\Program Files (x86)\Microsoft Visual Studio 10.0
+DEVSTUDIO=C:\usr\studio10
 !else
-DEVSTUDIO=C:\Program Files\Microsoft Visual Studio 10.0
+DEVSTUDIO=C:\usr\studio10
 !endif
 ! endif
 !if "$(DEVSTUDIO)"==""
@@ -1147,21 +1147,21 @@
 RCDIR=$(MSSDK)\bin
 !  endif
 ! else
-!ifdef WIN64
-RCDIR=C:\Program Files (x86)\Microsoft SDKs\Windows\v7.0\bin
+!if $(BUILD_SYSTEM) == 64
+RCDIR=C:\Program Files (x86)\Microsoft SDKs\Windows\v7.0A\bin
 !else
-RCDIR=C:\Program Files\Microsoft SDKs\Windows\v7.0\bin
+RCDIR=C:\Program Files\Microsoft SDKs\Windows\v7.0A\bin
 !endif
 ! endif
 COMPBASE=$(DEVSTUDIO)\VC
 SHAREDBASE=$(DEVSTUDIO)\VC
 !ifdef WIN64
 !if $(BUILD_SYSTEM) == 64
-COMPDIR64=$(COMPBASE)\bin\amd64
-LINKLIBPATH=/LIBPATH:"$(MSSDK)\lib\x64" /LIBPATH:"$(COMPBASE)\lib\amd64"
+COMPDIR64=$(COMPBASE)\bin\x86_amd64
+LINKLIBPATH=/LIBPATH:"$(COMPBASE)\lib\amd64" /LIBPATH:"C:\Program Files (x86)\Microsoft SDKs\Windows\v7.0A\lib\x64"
 !else
 COMPDIR64=$(COMPBASE)\bin\x86_amd64
-LINKLIBPATH=/LIBPATH:"$(COMPBASE)\lib\amd64" /LIBPATH:"$(COMPBASE)\PlatformSDK\Lib\x64"
+LINKLIBPATH=/LIBPATH:"$(COMPBASE)\lib\amd64" /LIBPATH:"C:\Program Files\Microsoft SDKs\Windows\v7.0A\lib\x64"
 !endif
 !endif
 !endif
@@ -1254,9 +1254,9 @@
 !if $(MSVC_VERSION) == 14
 ! ifndef DEVSTUDIO
 !  if $(BUILD_SYSTEM) == 64
-DEVSTUDIO=C:\Program Files (x86)\Microsoft Visual Studio 14.0
+DEVSTUDIO=C:\usr\studio15
 !  else
-DEVSTUDIO=C:\Program Files\Microsoft Visual Studio 14.0
+DEVSTUDIO=C:\usr\studio15
 !  endif
 ! endif
 ! if "$(DEVSTUDIO)"==""
@@ -1274,9 +1274,9 @@
 !   endif
 !  else
 !   if $(BUILD_SYSTEM) == 64
-RCDIR=C:\Program Files (x86)\Microsoft SDKs\Windows\v10.0A\Bin
+RCDIR=C:\Program Files (x86)\Windows Kits\8.1\bin\x86
 !   else
-RCDIR=C:\Program Files\Microsoft SDKs\Windows\v10.0A\Bin
+RCDIR=C:\Program Files\Windows Kits\8.1\bin\x86
 !   endif
 !  endif
 COMPBASE=$(DEVSTUDIO)\VC
@@ -1596,7 +1596,7 @@
 	     $(GLD)seprlib.dev $(GLD)translib.dev $(GLD)cidlib.dev $(GLD)psf0lib.dev $(GLD)psf1lib.dev\
              $(GLD)psf2lib.dev $(GLD)lzwd.dev $(GLD)sicclib.dev $(GLD)mshandle.dev $(GLD)mspoll.dev \
              $(GLD)ramfs.dev $(GLD)sjpx.dev $(GLD)sjbig2.dev \
-             $(GLD)pwgd.dev $(GLD)siscale.dev $(URF_DEV)
+             $(GLD)pwgd.dev $(GLD)siscale.dev $(URF_DEV) $(PSD)kanji.dev $(PSD)kfwin32.dev
 
 
 !ifndef METRO
@@ -1608,7 +1608,7 @@
 # See gs.mak for details.
 
 !ifndef COMPILE_INITS
-COMPILE_INITS=1
+COMPILE_INITS=0
 !endif
 
 # Choose whether to store band lists on files or in memory.
@@ -1688,7 +1688,7 @@
 
 # Define the name of the makefile -- used in dependencies.
 
-MAKEFILE=$(PSSRCDIR)\msvc.mak
+MAKEFILE=$(PSSRCDIR)\msvc32.mak
 TOP_MAKEFILES=$(MAKEFILE) $(GLSRCDIR)\msvccmd.mak $(GLSRCDIR)\msvctail.mak $(GLSRCDIR)\winlib.mak $(PSSRCDIR)\winint.mak
 
 # Define the files to be removed by `make clean'.
diff -Nur ghostscript-9.53.3-orig/psi/msvc32.mak ghostscript-9.53.3/psi/msvc32.mak
--- ghostscript-9.53.3-orig/psi/msvc32.mak	Thu Oct 01 17:11:07 2020
+++ ghostscript-9.53.3/psi/msvc32.mak	Thu Oct 01 22:43:22 2020
@@ -21,5 +21,5 @@
 
 # Note that we don't override (undefine) any command line define of WIN64, so
 # this makefile can be used for a 64-bit build or 32-bit
-
+WIN32=1
 !include $(PSSRCDIR)\msvc.mak
diff -Nur ghostscript-9.53.3-orig/psi/nsisinst.nsi ghostscript-9.53.3/psi/nsisinst.nsi
--- ghostscript-9.53.3-orig/psi/nsisinst.nsi	Thu Oct 01 17:11:07 2020
+++ ghostscript-9.53.3/psi/nsisinst.nsi	Thu Oct 01 22:35:04 2020
@@ -155,7 +155,9 @@
 
 FunctionEnd
 
-!searchparse /ignorecase /noerrors "${TARGET}" w WINTYPE
+; My TARGET name is different from the standard one.
+;!searchparse /ignorecase /noerrors "${TARGET}" w WINTYPE
+!searchparse /ignorecase /noerrors "${TARGET}" w WINTYPE full-gpl
 !echo "Building ${WINTYPE}-bit installer"
 
 Name "GPL Ghostscript"
@@ -201,11 +203,11 @@
 File /r /x arch /x base /x cups /x contrib /x devices /x expat /x freetype /x gpdl /x ijs /x ios /x jbig2dec /x jpeg /x jpegxr /x lcms2mt /x lib /x libpng /x man /x obj /x openjpeg /x pcl /x psi /x tiff /x toolbin /x windows /x xps /x zlib doc
 File /r /x arch /x base /x cups /x contrib /x devices /x expat /x freetype /x gpdl /x ijs /x ios /x jbig2dec /x jpeg /x jpegxr /x lcms2mt /x lib /x libpng /x man /x obj /x openjpeg /x pcl /x psi /x tiff /x toolbin /x windows /x xps /x zlib examples
 File /r /x arch /x base /x cups /x contrib /x devices /x expat /x freetype /x gpdl /x ijs /x ios /x jbig2dec /x jpeg /x jpegxr /x lcms2mt /x libpng /x man /x obj /x openjpeg /x pcl /x psi /x tiff /x toolbin /x windows /x xps /x zlib /x lib/gssetgs.bat lib
-File /r /x arch /x base /x cups /x contrib /x devices /x expat /x freetype /x gpdl /x ijs /x ios /x jbig2dec /x jpeg /x jpegxr /x lcms2mt /x lib /x libpng /x man /x obj /x openjpeg /x pcl /x psi /x tiff /x toolbin /x windows /x xps /x zlib Resource
 File /r /x arch /x base /x cups /x contrib /x devices /x expat /x freetype /x gpdl /x ijs /x ios /x jbig2dec /x jpeg /x jpegxr /x lcms2mt /x lib /x libpng /x man /x obj /x openjpeg /x pcl /x psi /x tiff /x toolbin /x windows /x xps /x zlib iccprofiles
-
-
+File /r /x arch /x base /x cups /x contrib /x devices /x expat /x freetype /x gpdl /x ijs /x ios /x jbig2dec /x jpeg /x jpegxr /x lcms2mt /x lib /x libpng /x man /x obj /x openjpeg /x pcl /x psi /x tiff /x toolbin /x windows /x xps /x zlib kanji
+File /r /x arch /x base /x cups /x contrib /x devices /x expat /x freetype /x gpdl /x ijs /x ios /x jbig2dec /x jpeg /x jpegxr /x lcms2mt /x lib /x libpng /x man /x obj /x openjpeg /x pcl /x psi /x tiff /x toolbin /x windows /x xps /x zlib Resource
 File /oname=lib\gssetgs.bat .\lib\gssetgs${WINTYPE}.bat
+File /oname=${TARGET}.diff .\${TARGET}.diff
 File /oname=bin\gsdll${WINTYPE}.dll .\bin\gsdll${WINTYPE}.dll
 File /oname=bin\gsdll${WINTYPE}.lib .\bin\gsdll${WINTYPE}.lib
 File /oname=bin\gswin${WINTYPE}.exe .\bin\gswin${WINTYPE}.exe
@@ -218,9 +220,9 @@
 WriteRegStr HKEY_LOCAL_MACHINE "Software\GPL Ghostscript\${VERSION}" "GS_DLL" "$INSTDIR\bin\gsdll${WINTYPE}.dll"
 
 !if "${COMPILE_INITS}" == "0"
-WriteRegStr HKEY_LOCAL_MACHINE "Software\GPL Ghostscript\${VERSION}" "GS_LIB" "$INSTDIR\Resource\Init;$INSTDIR\bin;$INSTDIR\lib;$INSTDIR\fonts"
+WriteRegStr HKEY_LOCAL_MACHINE "Software\GPL Ghostscript\${VERSION}" "GS_LIB" "$INSTDIR\Resource\Init;$INSTDIR\Resource;$INSTDIR\bin;$INSTDIR\lib;$INSTDIR\kanji;$INSTDIR\fonts"
 !else
-WriteRegStr HKEY_LOCAL_MACHINE "Software\GPL Ghostscript\${VERSION}" "GS_LIB" "$INSTDIR\bin;$INSTDIR\lib;$INSTDIR\fonts"
+WriteRegStr HKEY_LOCAL_MACHINE "Software\GPL Ghostscript\${VERSION}" "GS_LIB" "$INSTDIR\bin;$INSTDIR\lib;$INSTDIR\kanji;$INSTDIR\fonts"
 !endif
 
 WriteRegStr HKEY_LOCAL_MACHINE "Software\Artifex\GPL Ghostscript\${VERSION}" "" "$INSTDIR"
@@ -295,10 +297,12 @@
 RMDir /r "$INSTDIR\lib"
 RMDir /r "$INSTDIR\Resource"
 RMDir /r "$INSTDIR\iccprofiles"
+RMDir /r "$INSTDIR\kanji"
 Delete   "$INSTDIR\bin\gsdll${WINTYPE}.dll"
 Delete   "$INSTDIR\bin\gsdll${WINTYPE}.lib"
 Delete   "$INSTDIR\bin\gswin${WINTYPE}.exe"
 Delete   "$INSTDIR\bin\gswin${WINTYPE}c.exe"
+Delete   "$INSTDIR\${TARGET}.diff"
 RMDir    "$INSTDIR\bin"
 RMDir    "$INSTDIR"
 !if "${WINTYPE}" == "64"
diff -Nur ghostscript-9.53.3-orig/psi/winint.mak ghostscript-9.53.3/psi/winint.mak
--- ghostscript-9.53.3-orig/psi/winint.mak	Thu Oct 01 17:11:07 2020
+++ ghostscript-9.53.3/psi/winint.mak	Thu Oct 01 22:44:35 2020
@@ -26,16 +26,16 @@
 # Define the location of the NSIS makensis installer utility
 !ifndef MAKENSIS_XE
 !if $(BUILD_SYSTEM) == 64
-MAKENSIS_XE="C:\Program Files (x86)\NSIS\makensis.exe"
+MAKENSIS_XE="c:\usr\app32\nsis\makensis.exe"
 !else
-MAKENSIS_XE="C:\Program Files\NSIS\makensis.exe"
+MAKENSIS_XE="c:\usr\app32\nsis\makensis.exe"
 !endif
 !endif
 
 !ifdef WIN64
-NSISTARGET=gs$(GS_VERSION)w64
+NSISTARGET=gs9533w64full-gpl
 !else
-NSISTARGET=gs$(GS_VERSION)w32
+NSISTARGET=gs9533w32full-gpl
 !endif
 
 # Define the C++ compiler invocation for library modules.
diff -Nur ghostscript-9.53.3-orig/psi/zbfont.c ghostscript-9.53.3/psi/zbfont.c
--- ghostscript-9.53.3-orig/psi/zbfont.c	Thu Oct 01 17:11:07 2020
+++ ghostscript-9.53.3/psi/zbfont.c	Thu Oct 01 22:35:48 2020
@@ -749,8 +749,15 @@
 
         while (count--) {
            ref r;
+/*
            if ((code = array_get(imemory, pencoding, count, &r)) < 0 ||
              !(r_has_type(&r, type) || r_has_type(&r, t_null))) {
+*/
+/* BEGIN --ak */
+           if ((code = array_get(imemory, pencoding, count, &r)) < 0 ||
+             ((ftype != 3) &&
+             !(r_has_type(&r, type) || r_has_type(&r, t_null)))) {
+/* END --ak   */
                if (!cpsi_mode && ftype == ft_user_defined) {
                    if (code < 0 || r_has_type(&r, t_null)) {
                        return_error(gs_error_typecheck);
